module simd_useq_decoder(dec_opcode1,dec_rd,dec_opcode3,dec_rs2,dec_uk4,dec_rs1,dec_opcode4,dec_k8,dec_cond,dec_k12,dec_k4,instruction,clk,rst_n);
`include "simd_params.v"
input [USEQ_INST_MSB:0] instruction;
input clk;
input rst_n;
output [USEQ_INST_FORMAT_OPCODE1_MSB:0] dec_opcode1;
output [USEQ_INST_FORMAT_RD_MSB:0] dec_rd;
output [USEQ_INST_FORMAT_OPCODE3_MSB:0] dec_opcode3;
output [USEQ_INST_FORMAT_RS2_MSB:0] dec_rs2;
output [USEQ_INST_FORMAT_UK4_MSB:0] dec_uk4;
output [USEQ_INST_FORMAT_RS1_MSB:0] dec_rs1;
output [USEQ_INST_FORMAT_OPCODE4_MSB:0] dec_opcode4;
output [USEQ_INST_FORMAT_K8_MSB:0] dec_k8;
output [USEQ_INST_FORMAT_COND_MSB:0] dec_cond;
output [USEQ_INST_FORMAT_K12_MSB:0] dec_k12;
output [USEQ_INST_FORMAT_K4_MSB:0] dec_k4;



  reg [USEQ_INST_MSB:0]    dec_inst_r;
/*
  //@begin[inst_decode]
wire [USEQ_INST_FORMAT_OPCODE1_MSB:0] dec_opcode1  = dec_inst_r[USEQ_INST_FORMAT_OPCODE1_OFFSET +: USEQ_INST_FORMAT_OPCODE1_SIZE];

wire [USEQ_INST_FORMAT_RD_MSB:0] dec_rd  = dec_inst_r[USEQ_INST_FORMAT_RD_OFFSET +: USEQ_INST_FORMAT_RD_SIZE];

wire [USEQ_INST_FORMAT_OPCODE3_MSB:0] dec_opcode3  = dec_inst_r[USEQ_INST_FORMAT_OPCODE3_OFFSET +: USEQ_INST_FORMAT_OPCODE3_SIZE];
//wire [USEQ_INST_FORMAT_OPCODE3_MSB:0] dec_opcode3  = dec_inst_r[15:12];

wire [USEQ_INST_FORMAT_RS2_MSB:0] dec_rs2  = dec_inst_r[USEQ_INST_FORMAT_RS2_OFFSET +: USEQ_INST_FORMAT_RS2_SIZE];

wire [USEQ_INST_FORMAT_UK4_MSB:0] dec_uk4  = dec_inst_r[USEQ_INST_FORMAT_UK4_OFFSET +: USEQ_INST_FORMAT_UK4_SIZE];

wire [USEQ_INST_FORMAT_RS1_MSB:0] dec_rs1  = dec_inst_r[USEQ_INST_FORMAT_RS1_OFFSET +: USEQ_INST_FORMAT_RS1_SIZE];

wire [USEQ_INST_FORMAT_OPCODE4_MSB:0] dec_opcode4  = dec_inst_r[USEQ_INST_FORMAT_OPCODE4_OFFSET +: USEQ_INST_FORMAT_OPCODE4_SIZE];

wire [USEQ_INST_FORMAT_K8_MSB:0] dec_k8  = dec_inst_r[USEQ_INST_FORMAT_K8_OFFSET +: USEQ_INST_FORMAT_K8_SIZE];

wire [USEQ_INST_FORMAT_COND_MSB:0] dec_cond  = dec_inst_r[USEQ_INST_FORMAT_COND_OFFSET +: USEQ_INST_FORMAT_COND_SIZE];

wire [USEQ_INST_FORMAT_K12_MSB:0] dec_k12  = dec_inst_r[USEQ_INST_FORMAT_K12_OFFSET +: USEQ_INST_FORMAT_K12_SIZE];

wire [USEQ_INST_FORMAT_K4_MSB:0] dec_k4  = dec_inst_r[USEQ_INST_FORMAT_K4_OFFSET +: USEQ_INST_FORMAT_K4_SIZE];

  //@end[inst_decode]
  */
  
wire [USEQ_INST_FORMAT_OPCODE1_MSB:0] dec_opcode1  = dec_inst_r[USEQ_INST_FORMAT_OPCODE1_OFFSET +: USEQ_INST_FORMAT_OPCODE1_SIZE];

wire [USEQ_INST_FORMAT_RD_MSB:0] dec_rd  = dec_inst_r[USEQ_INST_FORMAT_RD_OFFSET +: USEQ_INST_FORMAT_RD_SIZE];

wire [USEQ_INST_FORMAT_OPCODE3_MSB:0] dec_opcode3  = dec_inst_r[USEQ_INST_FORMAT_OPCODE3_OFFSET +: USEQ_INST_FORMAT_OPCODE3_SIZE];
//wire [USEQ_INST_FORMAT_OPCODE3_MSB:0] dec_opcode3  = dec_inst_r[15:12];

wire [USEQ_INST_FORMAT_RS2_MSB:0] dec_rs2  = dec_inst_r[USEQ_INST_FORMAT_RS2_OFFSET +: USEQ_INST_FORMAT_RS2_SIZE];

wire [USEQ_INST_FORMAT_UK4_MSB:0] dec_uk4  = dec_inst_r[USEQ_INST_FORMAT_UK4_OFFSET +: USEQ_INST_FORMAT_UK4_SIZE];

wire [USEQ_INST_FORMAT_RS1_MSB:0] dec_rs1  = dec_inst_r[USEQ_INST_FORMAT_RS1_OFFSET +: USEQ_INST_FORMAT_RS1_SIZE];

wire [USEQ_INST_FORMAT_OPCODE4_MSB:0] dec_opcode4  = dec_inst_r[USEQ_INST_FORMAT_OPCODE4_OFFSET +: USEQ_INST_FORMAT_OPCODE4_SIZE];

wire [USEQ_INST_FORMAT_K8_MSB:0] dec_k8  = dec_inst_r[USEQ_INST_FORMAT_K8_OFFSET +: USEQ_INST_FORMAT_K8_SIZE];

wire [USEQ_INST_FORMAT_COND_MSB:0] dec_cond  = dec_inst_r[USEQ_INST_FORMAT_COND_OFFSET +: USEQ_INST_FORMAT_COND_SIZE];

wire [USEQ_INST_FORMAT_K12_MSB:0] dec_k12  = dec_inst_r[USEQ_INST_FORMAT_K12_OFFSET +: USEQ_INST_FORMAT_K12_SIZE];

wire [USEQ_INST_FORMAT_K4_MSB:0] dec_k4  = dec_inst_r[USEQ_INST_FORMAT_K4_OFFSET +: USEQ_INST_FORMAT_K4_SIZE];


  always @(posedge clk or negedge rst_n) begin
    if(rst_n == 1'b0) begin
      /*AUTORESET*/
      // Beginning of autoreset for uninitialized flops
      dec_inst_r <= {(1+(USEQ_INST_MSB)){1'b0}};
      // End of automatics
    end
    else begin
      dec_inst_r <= instruction;
      
    end
  end

 
  

  
 
endmodule 