`timescale 1ns / 1ps
module TOP(RED,GRN,BLUE,HS,VS,button1,button2,button3,
  // Outputs
  fx2FifoSel_out, fx2PktEnd_out, fx2Read_out, fx2Write_out,
  fx2OE_out, fx2Addr_out, led_out, anode_out,
  sseg_out,
  // Inouts
  fx2Data_io,
  // Inputs
  clk_50MHz, reset_in, fx2Clk_in, fx2GotData_in, fx2GotRoom_in, sw_in);
`include "../pythonscript/generated_verilog/VGA_params.v"
`include "../pythonscript/generated_verilog/test_prog_params.v"


 // "Regular" 50MHz clock input on Nexys2 borad 
  input clk_50MHz;
  input reset_in;
  
   

   
  // Data & control from the FX2
  input                 fx2Clk_in;              // To U_COMM_FPGA of comm_fpga.v
  input                 fx2GotData_in;          // To U_COMM_FPGA of comm_fpga.v
  input                 fx2GotRoom_in;          // To U_COMM_FPGA of comm_fpga.v
  output                fx2FifoSel_out;         // From U_COMM_FPGA of comm_fpga.v
  output                fx2PktEnd_out;          // From U_COMM_FPGA of comm_fpga.v
  output                fx2Read_out;            // From U_COMM_FPGA of comm_fpga.v
  output                fx2Write_out;           // From U_COMM_FPGA of comm_fpga.v
  output                fx2OE_out;
  output [1:0]          fx2Addr_out;
  inout [7:0]           fx2Data_io;
  
   // Nexys2 leds & switches
  output [7:0] led_out; // 
  input  [7:0] sw_in;

  // Nexys2 Seven segments
  output [3:0]          anode_out;              // From U_SEVEN_SEGMENT of bus32_seven_segments.v
  output [7:0]          sseg_out;               // From U_SEVEN_SEGMENT of bus32_seven_segments.v
  
  
output [2:0] RED;
output [2:0] GRN;
output [1:0] BLUE;
output VS;
output HS;

input button1;
input button2;
input button3;
wire [7:0] CABCDEFGP;
wire [3:0] AN;
wire button_timer_working;
wire sw0;


//LIBFPGA

 wire  [31:0]        gpio_out;
  wire [31:0]         gpio_in;
  
   wire  [31:0]        cpu_out;
  wire [31:0]         cpu_in;

  wire fpga_pmodad1_csneg;
  wire pmodad1_fpga_sdata1;
  wire pmodad1_fpga_sdata2;
  wire fpga_pmodad1_clk;

  wire spi_clk;
  wire spi_mosi;
  wire spi_miso;
  wire spi_cs;

  wire [1:0] spi_in;
  wire [1:0] spi_out;
  wire       saint_active;
  wire       saint_ac_r;
  wire       saint_start_r;
  wire       saint_acq_in_progress_r;
  wire rst;
  assign rst = reset_in;
  
  
//  assign ADC_CSNEG = fpga_pmodad1_csneg;
//  assign pmodad1_fpga_sdata1 = ADC_DATA1;
//  assign pmodad1_fpga_sdata2 = ADC_DATA2;
//  assign ADC_CLK = fpga_pmodad1_clk;


  assign led_out[7:4] = gpio_out[7:4];
  assign led_out[0]   = saint_ac_r;
  assign led_out[1]   = saint_active;
  assign led_out[2]   = saint_acq_in_progress_r;
  assign led_out[3]   = saint_start_r;
  
  
  assign gpio_in[7:0] = sw_in[7:0];
  assign gpio_in[31:8] = 24'd0;
  
  //assign JA0 = spi_clk;
  //assign JA1 = spi_mosi;
  //assign JA2 = spi_cs;  
  //assign spi_miso = JA3;
  //assign JA4 = spi_out[0];
  //assign JA5 = spi_out[1];
  //assign spi_in[0]   = JA6;
  //assign spi_in[1]   = JA7;

  
  
  wire reset;
  wire clk_usb;
  wire clk_fpga;
  // reg gotRoom_in;
  // reg gotData_in;
  reg [7:0] fifoData_io_reg;
  wire [7:0] fifoData_io;

  tri [7:0]  fifo_bus;

  reg [63:0] result;
  wire [15:0]size_r;
  
  wire clk_40MHz;
  wire clk_50MHz;

  wire bus32_regif_ack_clk_bus32_a;
  wire [31:0]          bus32_regif_rdata;      // To U_REGIF of regif.v

	 wire [31:0]         cpu_bus32_rdata;
	 wire                cpu_bus32_ack_r; 
  wire                gpio_bus32_ack_r;       // From U_GPIO of bus32_simple_gpio.v
  wire [31:0]         gpio_bus32_rdata;       // From U_GPIO of bus32_simple_gpio.v
  wire                tcspi_bus32_ack_r;      // From U_TCSPI of bus32_tcspi.v
  wire [31:0]         tcspi_bus32_rdata;      // From U_TCSPI of bus32_tcspi.v
  wire [31:0]         adc_bus32_rdata;  
  wire                adc_bus32_ack_r;  
  wire [31:0]         dac_bus32_rdata;  
  wire                dac_bus32_ack_r;  
  wire [31:0]         saint_bus32_rdata;  
  wire                saint_bus32_ack_r;  

  
  wire                sevenseg_bus32_ack_r;      // From U_TCSPI of bus32_tcspi.v
  wire [31:0]         sevenseg_bus32_rdata;      // From U_TCSPI of bus32_tcspi.v
  

  wire                xline;

  wire                saint_xline_r;
               

  
  assign clk_usb   = fx2Clk_in;
  assign clk_fpga  = clk_40MHz;
  assign reset 	   = reset_in;
  
  
   
  /*AUTOREG*/
  // Beginning of automatic regs (for this module's undeclared outputs)
  reg                   fx2FifoSel_out;
  // End of automatics
  /*AUTOWIRE*/
  // Beginning of automatic wires (for undeclared instantiated-module outputs)
  wire                  active_r;               // From U_RAM_WRITE_IF of ram_write_if.v
  wire                  adc_acq;                // From U_ADC_CTRL of bus32_ad9220_ctrl.v
  wire                  adc_data_valid;         // From U_ADC_CTRL of bus32_ad9220_ctrl.v
  wire                  busy_r_clk_fpga;        // From U_RAM_WRITE_IF of ram_write_if.v
  wire                  busy_r_clk_usb;         // From U_CDC of cdc.v
  wire [7:0]            dpram_dout;             // From U_DPRAM of blk_mem_gen_v6_3.v
  wire                  dpram_next_read;        // From U_REGIF of regif.v
  wire [11:0]           dpram_read_addr;        // From U_RAM_READ_IF of ram_read_if.v
  wire [9:0]            dpram_write_addr;       // From U_RAM_WRITE_IF of ram_write_if.v
  wire                  dpram_write_en;         // From U_RAM_WRITE_IF of ram_write_if.v
  wire [6:0]            regif_addr;             // From U_COMM_FPGA of comm_fpga.v
  wire [31:0]           regif_bus32_addr;       // From U_REGIF of regif.v
  wire [3:0]            regif_bus32_byte_strobes;// From U_REGIF of regif.v
  wire                  regif_bus32_req_r;      // From U_REGIF of regif.v
  wire [31:0]           regif_bus32_wdata;      // From U_REGIF of regif.v
  wire                  regif_bus32_write;      // From U_REGIF of regif.v
  wire [7:0]            regif_rdata;            // From U_REGIF of regif.v
  wire                  regif_read_en;          // From U_COMM_FPGA of comm_fpga.v
  wire [7:0]            regif_wdata;            // From U_COMM_FPGA of comm_fpga.v
  wire                  regif_write_en;         // From U_COMM_FPGA of comm_fpga.v
  wire                  start_r_clk_usb;        // From U_REGIF of regif.v
  // End of automatics
  
  
  
  integer               error_count;
  

  wire [11:0]		adc_data;
  wire                  adc_clk;
  wire                  adc_overflow;
  wire [11:0]           dac_data_r;
  wire                  dac_wr_neg;
  wire                  dac_cs_neg;
  
  
  assign fx2OE_out = fx2Read_out;
  assign fx2Addr_out[1] = 1'b1;  // Use EP6OUT/EP8IN, not EP2OUT/EP4IN.

comm_fpga U_COMM_FPGA (
                         // Inputs
                         .chanGotData_in        (1'b1),
                         .chanGotRoom_in        (1'b1),                                                
                          /*AUTOINST*/
                         // Outputs
                         .fx2FifoSel_out        (fx2Addr_out[0]), // Templated
                         .fx2Read_out           (fx2Read_out),
                         .fx2Write_out          (fx2Write_out),
                         .fx2PktEnd_out         (fx2PktEnd_out),
                         .chanAddr_out          (regif_addr[6:0]), // Templated
                         .chanRead_out          (regif_read_en), // Templated
                         .chanData_out          (regif_wdata[7:0]), // Templated
                         .chanWrite_out         (regif_write_en), // Templated
                         // Inouts
                         .fx2Data_io            (fx2Data_io[7:0]),
                         // Inputs
                         .fx2Clk_in             (fx2Clk_in),
                         .fx2GotData_in         (fx2GotData_in),
                         .fx2GotRoom_in         (fx2GotRoom_in),
                         .chanData_in           (regif_rdata[7:0])); // Templated
								 
regif U_REGIF (
                 /*AUTOINST*/
                 // Outputs
                 .rdata                 (regif_rdata[7:0]),      // Templated
                 .dpram_next_read       (dpram_next_read),
                 .start_r               (start_r_clk_usb),       // Templated
                 .size_r                (size_r[15:0]),
                 .regif_bus32_addr      (regif_bus32_addr[31:0]),
                 .regif_bus32_wdata     (regif_bus32_wdata[31:0]),
                 .regif_bus32_byte_strobes(regif_bus32_byte_strobes[3:0]),
                 .regif_bus32_write     (regif_bus32_write),
                 .regif_bus32_req_r     (regif_bus32_req_r),
                 // Inputs
                 .addr                  (regif_addr[6:0]),       // Templated
                 .wdata                 (regif_wdata[7:0]),      // Templated
                 .write_en              (regif_write_en),        // Templated
                 .read_en               (regif_read_en),         // Templated
                 .dpram_dout            (dpram_dout[7:0]),
                 .busy_r                (busy_r_clk_usb),        // Templated
                 .bus32_regif_rdata     (bus32_regif_rdata[31:0]),
                 .bus32_regif_ack_clk_bus32_r(bus32_regif_ack_clk_bus32_a), // Templated
                 .clk_bus32             (clk_usb),              // Templated
                 .reset_bus32           (reset),                 // Templated
                 .clk                   (clk_usb),               // Templated
                 .reset                 (reset));								 

wire sel_cpu_a;
 wire sel_gpio_a;
    wire sel_tcspi_a;
    wire sel_adc_a;
    wire sel_sevenseg_a;
    wire sel_dac_a;
    wire sel_saint_a;
	 assign sel_cpu_a     = (regif_bus32_addr[31:0]  == 32'h00007000);
    assign sel_gpio_a     = (regif_bus32_addr[31:0]  == 32'h00001000);
    assign sel_tcspi_a    = (regif_bus32_addr[31:12] === 32'h00002);
    assign sel_sevenseg_a = (regif_bus32_addr[31:0]  == 32'h00003000);
    assign sel_adc_a      = (regif_bus32_addr[31:12] === 32'h00004);
    assign sel_dac_a      = (regif_bus32_addr[31:0] === 32'h00005000);
    assign sel_saint_a    = (regif_bus32_addr[31:12] === 32'h00006);
                 
    assign bus32_regif_rdata[31:0] = sel_cpu_a   ? cpu_bus32_rdata  : 
												(sel_gpio_a   ? gpio_bus32_rdata  : 
                                     (sel_tcspi_a ? tcspi_bus32_rdata :
                                      (sel_adc_a ? adc_bus32_rdata :
                                       (sel_dac_a ? dac_bus32_rdata :
                                        (sel_saint_a ? saint_bus32_rdata : 
                                      (sel_sevenseg_a ? sevenseg_bus32_rdata : 32'b0))))));


    assign bus32_regif_ack_clk_bus32_a = gpio_bus32_ack_r;

bus32_cpu_control U_CPU (
                            .cpu_out           (cpu_out[31:0]),
                            .cpu_in            (cpu_in[31:0]),
                            .cpu_bus32_rdata   (cpu_bus32_rdata[31:0]),
                            .cpu_bus32_ack_r   (cpu_bus32_ack_r),                            
                            /*AUTOINST*/
                            // Inputs
                            .bus32_cpu_addr    (regif_bus32_addr[31:0]), // Templated
                            .bus32_cpu_wdata   (regif_bus32_wdata[31:0]), // Templated
                            .bus32_cpu_byte_strobes(regif_bus32_byte_strobes[3:0]), // Templated
                            .bus32_cpu_write   (regif_bus32_write), // Templated
                            .bus32_cpu_req_r   (regif_bus32_req_r), // Templated
                            .sel_a              (sel_cpu_a),    // Templated
                            .clk                (clk_usb),      // Templated
                            .reset              (reset));


bus32_simple_gpio U_GPIO (
                            .gpio_out           (gpio_out[31:0]),
                            .gpio_in            (gpio_in[31:0]),
                            .gpio_bus32_rdata   (gpio_bus32_rdata[31:0]),
                            .gpio_bus32_ack_r   (gpio_bus32_ack_r),                            
                            /*AUTOINST*/
                            // Inputs
                            .bus32_gpio_addr    (regif_bus32_addr[31:0]), // Templated
                            .bus32_gpio_wdata   (regif_bus32_wdata[31:0]), // Templated
                            .bus32_gpio_byte_strobes(regif_bus32_byte_strobes[3:0]), // Templated
                            .bus32_gpio_write   (regif_bus32_write), // Templated
                            .bus32_gpio_req_r   (regif_bus32_req_r), // Templated
                            .sel_a              (sel_gpio_a),    // Templated
                            .clk                (clk_usb),      // Templated
                            .reset              (reset));
									 


bus32_seven_segments U_SEVEN_SEGMENT (
                                      .sevenseg_bus32_rdata(sevenseg_bus32_rdata[31:0]),
                                      .sevenseg_bus32_ack_r(sevenseg_bus32_ack_r),
                                      
                                      /*AUTOINST*/
                                      // Outputs
                                      .sseg_out         (sseg_out[7:0]),
                                      .anode_out        (anode_out[3:0]),
                                      // Inputs
                                      .bus32_sevenseg_addr(regif_bus32_addr[31:0]), // Templated
                                      .bus32_sevenseg_wdata(regif_bus32_wdata[31:0]), // Templated
                                      .bus32_sevenseg_byte_strobes(regif_bus32_byte_strobes[3:0]), // Templated
                                      .bus32_sevenseg_write(regif_bus32_write), // Templated
                                      .bus32_sevenseg_req_r(regif_bus32_req_r), // Templated
                                      .bus32_sel_a      (sel_sevenseg_a), // Templated
                                      .clk_bus32        (clk_usb),      // Templated
                                      .reset            (reset));									




/*vga_draw VGA(.CABCDEFGP(CABCDEFGP[7:0]),.AN(AN[3:0]),.RED(RED[2:0]),.GRN(GRN[2:0]),.BLUE(BLUE[1:0]),.HS(HS),.VS(VS),
.clk(clk_50MHz),.rst(rst),.button1(button1),.button2(button2),.button3(button3),.sw0(sw0),
.button_timer_working(button_timer_working),.nmenu1_ptr(nmenu1_ptr[3:0]),.nmenu2_ptr(nmenu2_ptr[3:0]), 
.nmenu3_ptr(nmenu3_ptr[3:0]),.rf_reg(rf_reg[15:0]),.rf_selreg(rf_selreg[3:0]));
*/


endmodule