module vga_draw(CABCDEFGP,AN,RED,GRN,BLUE,HS,VS,clk,rst,button1,button2,button3,sw0,button_timer_working,nmenu1_ptr,nmenu2_ptr, nmenu3_ptr,rf_reg,rf_selreg);
`include "../pythonscript/generated_verilog/VGA_params.v"
output [2:0] RED;
output [2:0] GRN;
output [1:0] BLUE;
output VS;
output HS;
output [7:0] CABCDEFGP;
output button_timer_working;//,LED0,LED1,LED2,LED3,LED4,LED5,LED6;
output [3:0] AN;
output [3:0]nmenu1_ptr;
output [3:0]nmenu2_ptr;
output [3:0]nmenu3_ptr;
output [3:0] rf_selreg;
input [15:0] rf_reg;
input rst;
input clk;
input button1;
input button2;
input button3;
input sw0;

parameter VMAX  = 525;
parameter HMAX  = 800;

// total number of visible lines
parameter HLINES= 640;
// total number of visible lines
parameter VLINES=   480;

reg [2:0] RED;
reg [2:0] GRN;
reg [1:0] BLUE;

//reg LED0,LED1,LED2,LED3,LED4,LED5,LED6;

wire [2:0] REDG;
wire [2:0] GRNG;
wire [1:0] BLUEG;

wire [10:0] hcount;
wire [10:0] vcount;
wire blank;

wire [15:0] addr_ptr;
wire [3:0] bit_ptr;


reg [10:0] counter; 
reg [3:0] counter_seg;
reg [3:0] AN;
reg [1:0] ANUPDATE;
reg [19:0] counter_seg_update;
reg [3:0] counter_seg_thousands;
reg [3:0] counter_seg_hundreds;
reg [3:0] counter_seg_tens;
reg [7:0] CABCDEFGP;
reg [7:0] seg [0:9];

reg [9:0] vga_ram_hadr;
reg [9:0] vga_ram_vadr;
reg vga_ram_we;
wire [7:0] vga_ram_out;
reg [7:0] vga_ram_in;
reg [9:0]	pointerhadr;
reg start;
wire done;
reg [15:0] symbol;
reg [9:0]hpx;
reg [9:0]vpx;
wire [15:0] write_addr;
wire write_we;
wire [7:0] write_data;
reg [15:0] addr_in;
wire working;
wire clk40;

reg updatemenu1;
reg updatemenux;

reg [31:0] button_counter;
reg button_timer_working;
reg button_timer_start;
wire [1:0] b32;
assign b32 = {button3,button2};

parameter MAX_TIMER = 25000000;
localparam WAITFORB=1, WAITFORBRELEASE=0,BUTTON_CLICKED_REMOVE_BLOCK=2,
BUTTON_CLICKED_REMOVE_BLOCK_WAIT=3,BUTTON_CLICKED_ADD_BLOCK=4,BUTTON_CLICKED_ADD_BLOCK_WAIT=5,
BUTTON_CLICKED_REFRESH_REGISTERS=6,BUTTON_CLICKED_REFRESH_REGISTERS_WAIT=7,
BUTTON_CLICKED_REFRESH_REGISTERS_REFRESHGUI=8,BUTTON_CLICKED_REFRESH_REGISTERS_REFRESHGUI_WAIT=9,
BUTTON_CLICKED_ADD_BLOCK_UPDATE_PTRS = 10;
reg [3:0] state, // Current state 
 nxtState; // Next state 

parameter MAXCOUNT = 832000;
parameter	Timing1 =  208000;
parameter	Timing2 =  416000;
parameter	Timing3 =  624000;
parameter	Timing4 =  832000;

parameter MENU1_MAX = 5;
parameter MENU2_MAX = 6;
parameter MENU3_MAX = 4;
reg button2_released;
reg button3_released;
reg [15:0]vpxhpx;
reg [3:0]menu1_ptr;
reg [3:0]menu2_ptr;
reg [3:0]menu3_ptr;

reg [3:0]nmenu1_ptr;
reg [3:0]nmenu2_ptr;
reg [3:0]nmenu3_ptr;
reg [15:0]gui_write_addr;
reg gui_register_refresh;

reg [3:0]reg_counter;
reg [3:0]nreg_counter;
reg [3:0]reg_hex_counter;
reg [3:0]nreg_hex_counter;
/*
always @(posedge clk or posedge rst) begin
	if(rst == 1'b1) begin
		 seg[1] <= 8'b10011111;
		 seg[2] <= 8'b00100101;
		 seg[3] <= 8'b00001101;
		 seg[4] <= 8'b10011001;
		 seg[5] <= 8'b01001001;
		 seg[6] <= 8'b01000001;
		 seg[7] <= 8'b00011111;
		 seg[8] <= 8'b00000001;
		 seg[9] <= 8'b00001001;
		 seg[0] <= 8'b00000011;
		counter_seg_update <= 0;
		ANUPDATE <= 2'b0;
		CABCDEFGP <= 8'b0;
	end else begin
		if(counter_seg_update < Timing1) begin
			ANUPDATE <= 3;
			CABCDEFGP <= seg[menu1_ptr];//seg[counter_seg_thousands];
			counter_seg_update <= counter_seg_update+1;
		end else if(counter_seg_update < Timing2) begin
			ANUPDATE <= 2;
			CABCDEFGP <= seg[menu2_ptr];//seg[counter_seg_hundreds];
			counter_seg_update <= counter_seg_update+1;
		end else if(counter_seg_update < Timing3) begin
			ANUPDATE <= 1;
			CABCDEFGP <= seg[menu3_ptr];//seg[counter_seg_tens];
			counter_seg_update <= counter_seg_update+1;
		end else if(counter_seg_update < Timing4) begin
			ANUPDATE <= 0;
			CABCDEFGP <= seg[0]; //seg[counter_seg]
			counter_seg_update <= counter_seg_update+1;
		end else begin
			counter_seg_update <= 0;
		end
	end
end*/

/* DEMO FUNCTION
always @(posedge button1 or posedge rst) begin
	if(rst == 1'b1) begin
		counter_seg <= 0; 
		counter_seg_thousands <= 4'b0;
		counter_seg_hundreds <= 4'b0;
		counter_seg_tens <= 4'b0 ;
	end else begin
		if(counter_seg > 8) begin
			counter_seg <= 0;
			if(counter_seg_tens > 8 ) begin 
				counter_seg_tens <= 0;
				if(counter_seg_hundreds > 8 ) begin 
					counter_seg_hundreds <= 0;
					if(counter_seg_thousands > 8 ) begin 
						counter_seg_thousands <= 0;
					end else begin
						counter_seg_thousands <= counter_seg_thousands + 1;
					end
				end else begin
					counter_seg_hundreds <= counter_seg_hundreds+1;
				end
			end else begin
				counter_seg_tens <= counter_seg_tens+1;
			end
		end else begin
			counter_seg <= counter_seg + 1;
		end
	end
end
*/
/*

always @* begin

case(ANUPDATE)
	0: begin
		AN[0] = 0;
		AN[1] = 1;
		AN[2] = 1;
		AN[3] = 1;
	end
	1: begin
		AN[0] = 1;
		AN[1] = 0;
		AN[2] = 1;
		AN[3] = 1;
	end
	2: begin
		AN[0] = 1;
		AN[1] = 1;
		AN[2] = 0;
		AN[3] = 1;
	end
	3: begin
		AN[0] = 1;
		AN[1] = 1;
		AN[2] = 1;
		AN[3] = 0;
	end
	default: begin
		AN[0] = 1;
		AN[1] = 1;
		AN[2] = 1;
		AN[3] = 1;
	end
	endcase
end
*/

	
//VGA

//MUX TO SET COLOR OF IF BLANK=1;
always @* begin
	if(blank == 1'b1) begin
		RED <= 3'b000;
		GRN <= 3'b000;
		BLUE <= 2'b00;
	end else begin
		RED <= REDG;
		GRN <= GRNG;
		BLUE <= BLUEG;
	end
end

assign REDG[0] = vga_ram_out[bit_ptr[2:0]];
assign REDG[1] = vga_ram_out[bit_ptr[2:0]];//MemDB[0];
assign REDG[2] = vga_ram_out[bit_ptr[2:0]];
assign GRNG[0] = vga_ram_out[bit_ptr[2:0]];
assign GRNG[1] = vga_ram_out[bit_ptr[2:0]];
assign GRNG[2] = vga_ram_out[bit_ptr[2:0]];
assign BLUEG[0] = vga_ram_out[bit_ptr[2:0]];
assign BLUEG[1] = vga_ram_out[bit_ptr[2:0]];

assign rf_selreg = nreg_counter;

always @* begin
	if(rst == 1'b1) begin
		vga_ram_hadr = 10'b0;
		vga_ram_vadr = 10'b0;
		vga_ram_we = 1'b0;
		vga_ram_in = 8'b0;
		addr_in = 16'b0;
	end else if(start==1 || working==1) begin
			vga_ram_we = write_we;
			vga_ram_in = write_data;
			//addr_in <= addr_ptr;
			addr_in = write_addr;
	end else begin
			vga_ram_in = write_data;
			vga_ram_we = 0;
			addr_in = addr_ptr;
			if(blank == 0) begin
				vga_ram_vadr = vcount[9:0];
				vga_ram_hadr = hcount[9:0];
			end
	end
end
 
always @(posedge clk or posedge rst) begin
	if (rst == 1) begin
		button_counter <= 32'b0;
		button_timer_working <=0;
	end else if(button_timer_start == 1 && button_timer_working == 0) begin
		button_timer_working <= 1;
		button_counter <= button_counter+1;
	end else if(button_timer_working == 1 && (button_counter < MAX_TIMER)) begin
		button_counter <= button_counter+1;
	end else begin
		button_counter <= 32'b0;
		button_timer_working <=0;
	end
end
 
 
always @(posedge clk) begin 
 if (rst) begin 
 	nmenu1_ptr <= 0;
	nmenu2_ptr <= 0;
	nmenu3_ptr <= 0;
   state <= WAITFORB; // Initial state 
	nreg_hex_counter <= 0;
	nreg_counter <= 0;

 end else begin 
  	nmenu1_ptr <= menu1_ptr;
	nreg_counter <= reg_counter;
	nreg_hex_counter <= reg_hex_counter;
	nmenu2_ptr <= menu2_ptr;
	nmenu3_ptr <= menu3_ptr;
	state <= nxtState; 
 end 
end

always @(*) begin 
if(rst == 1) begin
	menu1_ptr = 0;
	menu2_ptr = 0;
	menu3_ptr = 0;
	start = 0;
	vpxhpx = 16'b0;
	nxtState = WAITFORB;
	symbol = 0;
	button_timer_start = 0;
	gui_register_refresh = 1'b0;
	reg_hex_counter = 0;
	reg_counter = 0;
	
	
end else begin
	nxtState = state; // Default next state: stay where we are 
	menu1_ptr = nmenu1_ptr;
	menu2_ptr = nmenu2_ptr;
	menu3_ptr = nmenu3_ptr;
	button_timer_start = 0;
	vpxhpx = 16'b0;
	start = 0;
	symbol = 16'b0;
	gui_register_refresh = 1'b0;
	reg_hex_counter = nreg_hex_counter;
	reg_counter = nreg_counter;
	case(b32)
				2'b10: begin
					button_timer_start = 1;
					case (nmenu1_ptr)
						0: begin
							vpxhpx = PX_MENU1_1;
							end
						1: begin
							vpxhpx = PX_MENU1_2;
							end
						2: begin	
							vpxhpx = PX_MENU1_3;
							end
						3: begin	
							vpxhpx = PX_MENU1_4;
							end
						4: begin	
							vpxhpx = PX_MENU1_5;
							end
					endcase
					end	
				2'b01: begin
					button_timer_start = 1;
					case(nmenu1_ptr)
						0: begin
							case(nreg_counter)
								0:begin
								vpxhpx = PX_R1 + nreg_hex_counter;
								end
								1:begin
								vpxhpx = PX_R2 + nreg_hex_counter;
								end
								2:begin
								vpxhpx = PX_R3 + nreg_hex_counter;
								end
								3:begin
								vpxhpx = PX_R4 + nreg_hex_counter;
								end
								4:begin
								vpxhpx = PX_R5 + nreg_hex_counter;
								end
								5:begin
								vpxhpx = PX_R6 + nreg_hex_counter;
								end
								6:begin
								vpxhpx = PX_R7 + nreg_hex_counter;
								end
								7:begin
								vpxhpx = PX_R8 + nreg_hex_counter;
								end
								8:begin
								vpxhpx = PX_R9 + nreg_hex_counter;
								end
								9:begin
								vpxhpx = PX_R10 + nreg_hex_counter;
								end
								10:begin
								vpxhpx = PX_R11 + nreg_hex_counter;
								end
								11:begin
								vpxhpx = PX_R12 + nreg_hex_counter;
								end
								12:begin
								vpxhpx = PX_R13 + nreg_hex_counter;
								end
								13:begin
								vpxhpx = PX_R14 + nreg_hex_counter;
								end
								14:begin
								vpxhpx = PX_R15 + nreg_hex_counter;
								end
							endcase
						end
						
						1: begin
							case (nmenu3_ptr)
								0: begin
									vpxhpx = PX_MENU3_1;
									end
								1: begin
									vpxhpx = PX_MENU3_2;
									end
								2: begin	
									vpxhpx = PX_MENU3_3;
									end
								3: begin	
									vpxhpx = PX_MENU3_4;
									end
							endcase
							end
						2: begin
							case (nmenu2_ptr)
								0: begin
									vpxhpx = PX_MENU2_1;
									end
								1: begin
									vpxhpx = PX_MENU2_2;
									end
								2: begin	
									vpxhpx = PX_MENU2_3;
									end
								3: begin	
									vpxhpx = PX_MENU2_4;
									end
								4: begin	
									vpxhpx = PX_MENU2_5;
									end
								5: begin	
									vpxhpx = PX_MENU2_6;
									end
							endcase
							end
					endcase
				end
			endcase
	case (state) 
		WAITFORBRELEASE : begin 
			if(button3 == 0 && button2 == 0 && !button_timer_working) begin //and timer?
				nxtState = WAITFORB;
				button_timer_start =0;
			end
		end
		
		WAITFORB : begin 
			symbol = SYMBOL_PTR+18;
			case (b32)
				2'b10: begin //button3==1
					nxtState = BUTTON_CLICKED_REMOVE_BLOCK;
					start = 1;
				end
				2'b01: begin //button2==1
					if(nmenu1_ptr < 1) begin
						nxtState = BUTTON_CLICKED_REFRESH_REGISTERS;		
						reg_hex_counter = 0;
						reg_counter = 0;
						
					end else begin
						nxtState = BUTTON_CLICKED_REMOVE_BLOCK;
						start = 1;
					end
				end
			endcase
		end
		BUTTON_CLICKED_REMOVE_BLOCK: begin
			nxtState = BUTTON_CLICKED_REMOVE_BLOCK_WAIT;
			symbol = SYMBOL_PTR+18;
			start = 1;
		end
		BUTTON_CLICKED_REMOVE_BLOCK_WAIT: begin
			start = 0;
			symbol = SYMBOL_PTR+18;
			//vpxhpx = vpxhpx;
			if(working == 0) begin
				nxtState = BUTTON_CLICKED_ADD_BLOCK_UPDATE_PTRS;
			end
		end
		BUTTON_CLICKED_ADD_BLOCK_UPDATE_PTRS: begin
				nxtState = BUTTON_CLICKED_ADD_BLOCK;
				//start = 1;
				symbol = SYMBOL_PTR+17;
			case(b32)
				2'b10: begin
					if(nmenu1_ptr < MENU1_MAX-1) begin
						menu1_ptr = nmenu1_ptr + 1;
					end else begin
						menu1_ptr = 4'b0;
					end
					end	
				2'b01: begin
					case(nmenu1_ptr)
						0: begin
						//Register
						end
						
						1: begin
							if(nmenu3_ptr < MENU3_MAX-1) begin
								menu3_ptr = nmenu3_ptr + 1;
							end else begin
								menu3_ptr = 4'b0;
							end
							end
						2: begin
							if(nmenu2_ptr < MENU2_MAX-1) begin
								menu2_ptr = nmenu2_ptr + 1;
							end else begin
								menu2_ptr = 4'b0;
							end
							end
					endcase
				end
			endcase
		end
		BUTTON_CLICKED_ADD_BLOCK: begin
				nxtState = BUTTON_CLICKED_ADD_BLOCK_WAIT;
				start = 1;
				symbol = SYMBOL_PTR+17;
				case(b32)
					2'b01: begin
						if(menu1_ptr < 1) begin
							symbol = SYMBOL_PTR;
							case(nreg_hex_counter)
								0: begin
									symbol = SYMBOL_PTR + rf_reg[15:12];
								end
								1: begin
									symbol = SYMBOL_PTR+ rf_reg[11:8];
								end
								2: begin
									symbol = SYMBOL_PTR + rf_reg[7:4];
								end
								3: begin
									symbol = SYMBOL_PTR + rf_reg[3:0];
								end
							endcase
						end
					end
				endcase
			/*case(b32)
				2'b10: begin
					if(nmenu1_ptr < MENU1_MAX-1) begin
						menu1_ptr = nmenu1_ptr + 1;
					end else begin
						menu1_ptr = 0;
					end
					end	
				2'b01: begin
					case(nmenu1_ptr)
						0: begin
						//Register
						end
						
						1: begin
							if(nmenu3_ptr < MENU3_MAX-1) begin
								menu3_ptr = nmenu3_ptr + 1;
							end else begin
								menu3_ptr = 0;
							end
							end
						2: begin
							if(nmenu2_ptr < MENU2_MAX-1) begin
								menu2_ptr = nmenu2_ptr + 1;
							end else begin
								menu2_ptr = 0;
							end
							end
					endcase
				end
			endcase*/
		end
		BUTTON_CLICKED_ADD_BLOCK_WAIT : begin 
			symbol = SYMBOL_PTR+17;
			case(b32)
				2'b01: begin
					if(menu1_ptr < 1) begin
						symbol = SYMBOL_PTR;
						case(nreg_hex_counter)
							0: begin
								symbol = SYMBOL_PTR + rf_reg[15:12];
							end
							1: begin
								symbol = SYMBOL_PTR + rf_reg[11:8];
							end
							2: begin
								symbol = SYMBOL_PTR + rf_reg[7:4];
							end
							3: begin
								symbol = SYMBOL_PTR + rf_reg[3:0];
							end
						endcase
					end
				end
			endcase
			start = 0;
			if(working == 0) begin
				case(b32)
					2'b10: begin
							nxtState = WAITFORBRELEASE;
					end
					2'b01: begin
						if(nmenu1_ptr < 1) begin
							nxtState = BUTTON_CLICKED_REFRESH_REGISTERS;
						end else begin
							nxtState = WAITFORBRELEASE;
						end
					end
				endcase
			end
		end
		BUTTON_CLICKED_REFRESH_REGISTERS : begin
			start = 1;
			symbol = SYMBOL_PTR+18;
			if(nreg_counter < 15 || nreg_hex_counter < 3) begin
				nxtState = BUTTON_CLICKED_REMOVE_BLOCK;
				if(nreg_hex_counter<3) begin
					reg_hex_counter = nreg_hex_counter + 1;
				end else begin
					reg_hex_counter = 0;
					//button_timer_start = 1;
					reg_counter = nreg_counter+1;
				end
			end else begin
				nxtState = WAITFORBRELEASE;
				reg_hex_counter = 0;
				reg_counter = 0;
			end
		end
	endcase 
end
end

		


vga_controller_800_60 VGACTRL1(	.rst(rst),
								.pixel_clk	(clk),
								.HS			(HS),
								.VS			(VS),
								.hcount		(hcount),
								.vcount		(vcount),
								.blank		(blank),
								.addr_ptr	(addr_ptr),
								.bit_ptr		(bit_ptr));
								
vga_ram VGARAM (.addr_ptr(addr_in[15:0]),.clk(clk), .in(vga_ram_in[7:0]), .we(vga_ram_we), .out(vga_ram_out),.rst(rst));
write_symbol WRITEMODULE(.start(start),.done(done),.working(working),.clk(clk),.symbol(symbol[15:0]),.vpxhpx (vpxhpx[15:0]),.mem_out(vga_ram_out),.mem_data(write_data),.addr(write_addr),.we(write_we),.rst(rst));
endmodule


module vga_controller_800_60(rst,pixel_clk,HS,VS,hcount,vcount,blank,addr_ptr,bit_ptr);
input rst;
input pixel_clk;
output HS;
output VS;
output [10:0] hcount;
output [10:0] vcount;
output [15:0] addr_ptr;
output [3:0] bit_ptr;
output blank;

////////////////////////////////////////////////////////////////////////
// CONSTANTS
////////////////////////////////////////////////////////////////////////

// maximum value for the horizontal pixel counter
parameter HMAX  = 800;
// maximum value for the vertical pixel counter
parameter VMAX  = 525;
// total number of visible columns
parameter HLINES= 640;
// value for the horizontal counter where front porch ends
parameter HFP   = 648;
// value for the horizontal counter where the synch pulse ends
parameter HSP   = 744;
// total number of visible lines
parameter VLINES=   480;
// value for the vertical counter where the front porch ends
parameter VFP   =   482;
// value for the vertical counter where the synch pulse ends
parameter VSP   =   484;
// polarity of the horizontal and vertical synch pulse
// only one polarity used, because for this resolution they coincide.
parameter SPP   = 0;

////////////////////////////////////////////////////////////////////////
// SIGNALS
////////////////////////////////////////////////////////////////////////

// horizontal and vertical counters
reg [10:0] hcount;
reg [10:0] vcount;
reg HS;
reg VS;
reg blank;

// active when inside visible screen area.
reg video_enable;
reg [15:0] addr_ptr;
reg [3:0] bit_ptr;

//RAM address managment
always @ (negedge pixel_clk or posedge rst) begin
	if(rst==1'b1) begin
		addr_ptr <= 16'b0;
		bit_ptr <= 4'd7;
	end else begin
		
		if(((hcount <= HLINES+1) && (vcount <= VLINES+1)) && (hcount > 1)) begin
		
			if(bit_ptr > 0) begin
				if(bit_ptr == 4'd2) begin
					addr_ptr <= addr_ptr +1'b1;
				end
					bit_ptr <= bit_ptr - 1'b1;
			end else begin
				bit_ptr <= 4'd7;
				//addr_ptr <= addr_ptr +1'b1;
			end
		end else if((hcount == HMAX) && (vcount == VMAX)) begin
				bit_ptr <= 4'd7;
				addr_ptr <= 16'b0;
		end
	end
end
	
	// blank is active when outside screen visible area
   // color output should be blacked (put on 0) when blank in active
   // blank is delayed one pixel clock period from the video_enable
   // signal to account for the pixel pipeline delay.
   always @ (posedge pixel_clk or posedge rst) begin
	if(rst==1'b1) begin
		blank <= 0;
	end else begin
		blank <= !video_enable;
	end
	end
   // increment horizontal counter at pixel_clk rate
   // until HMAX is reached, then reset and keep counting
   always @(posedge pixel_clk or posedge rst) begin
         if(rst == 1'b1) begin
            hcount <= 11'b0;
         end else if(hcount == HMAX) begin
            hcount <= 11'b0;
         end else begin
            hcount <= hcount + 1;
         end
   end

   // increment vertical counter when one line is finished
   // (horizontal counter reached HMAX)
   // until VMAX is reached, then reset and keep counting
  always @(posedge pixel_clk or posedge rst) begin
         if(rst == 1'b1) begin
            vcount <= 11'b0;
         end else if(hcount == HMAX) begin
            if(vcount == VMAX) begin
               vcount <= 11'b0;
            end else begin
               vcount <= vcount + 1;
            end
         end
  end

   // generate horizontal synch pulse
   // when horizontal counter is between where the
   // front porch ends and the synch pulse ends.
   // The HS is active (with polarity SPP) for a total of 128 pixels.
   always @(posedge pixel_clk or posedge rst) begin
	   if(rst == 1'b1) begin
            HS <= 1'b0;
       end else if(hcount >= HFP && hcount < HSP) begin
            HS <= SPP;
       end else begin
            HS <= !SPP;
        end
      
   end 

   // generate vertical synch pulse
   // when vertical counter is between where the
   // front porch ends and the synch pulse ends.
   // The VS is active (with polarity SPP) for a total of 4 video lines
   // = 4*HMAX = 4224 pixels.
   always @(posedge pixel_clk or posedge rst) begin
	   if(rst == 1'b1) begin
            VS <= 1'b0;
       end else if(vcount >= VFP && vcount < VSP) begin
            VS <= SPP;
       end else begin
            VS <= !SPP;
        end
      
   end 
   always @* begin
	video_enable <= (hcount < HLINES) && (vcount < VLINES);
   end
  endmodule
 
  module vga_ram (addr_ptr, clk, in, we, out,rst);
  input [15:0] addr_ptr;
  input clk;
  input [7:0] in;
  input we,rst;
  output [7:0] out;
  
	vga_mem640_8bit VGAMEM(
		.clka(clk),
		.wea(we),
		.addra(addr_ptr[15:0]),
		.dina(in[7:0]),
		.douta(out)
);

  endmodule 
  



module write_symbol(start,done,working,clk,symbol,vpxhpx,mem_out,mem_data,addr,we,rst);
	input start,clk,rst;
	input [15:0]symbol;
	input [15:0] vpxhpx;
	input [7:0] mem_out;
	output [7:0] mem_data;
	output [15:0] addr;
	output done,we,working;
	
	reg working;
	reg [2:0] counter;
	reg [15:0]addr;
	reg read;
	reg write;
	reg done;
	reg we; 
	reg workpipe;
	reg [7:0] mem_data;
	reg [7:0] readsymbol [0:7];
	//reg [15:0] vpxhpx_stored;
	integer i;
	
	always @(posedge clk or posedge rst) begin
		if(rst == 1) begin
			addr <= 16'b0;
			for(i = 0; i<7; i=i+1) begin
				readsymbol[i] <= 8'b0;
			end
			counter <= 3'b0;
			read <= 1'b0;
			working <= 1'b0;
			write <= 1'b0;
			done <= 1'b1;
			we <= 1'b0;
			mem_data <= 8'b0;
			workpipe <= 1'b0;
			//vpxhpx_stored <= 0;
		end else  begin
			if (start == 1'b1 || working == 1'b1) begin
			//FIRST READ BITS	
				if(working == 1'b0)begin
					working <=1'b1; 
					counter <= 3'b0;
					addr <= symbol[15:0];
					read <= 1'b1;
					done <= 1'b0; 
					//vpxhpx_stored <= vpxhpx;
				end else if(workpipe == 0) begin
					workpipe <= 1;
					addr <= addr + 8'd80;
				end else if((working == 1'b1) && (read ==1'b1) &&  (counter < 3'd7)) begin
					addr <= addr + 8'd80;
					readsymbol[counter] <= mem_out;
					counter <= counter + 1 ;
				end else if ((working == 1'b1) && (read ==1'b1) && (counter ==3'd7)) begin
					readsymbol[counter] <= mem_out;
					write <= 1'b1;
					we <= 1'b1;
					read <= 1'b0;
					counter <= 3'd0;
					addr <= vpxhpx[15:0];
				end else if ((working == 1'b1) && (write ==1'b1) && (counter <3'd7)) begin
					addr <= addr + 8'd80;
					counter <= counter + 1;
					mem_data <= readsymbol[counter];
				end else if ((working == 1'b1) && (write ==1'b1) && (counter ==3'd7)) begin	
					mem_data <= readsymbol[counter];
					working <= 1'b0;
					write <= 1'b0;
					for(i = 0; i<8; i=i+1) begin
						readsymbol[i] <= 8'b0;
					end
					we <= 1'b0;
					counter <= 3'b0;
					addr <= symbol[15:0];
					done <= 1'b1;
					workpipe <= 0;
				end
		end
	end
end
				
endmodule
  