module clock_divider (/*AUTOARG*/
  // Outputs
  clk_out,
  // Inputs
  clk_in, reset_neg
  );
  
  input clk_in;
  input reset_neg;
  output clk_out;

  parameter BITS = 16;
  parameter COUNT = {BITS{1'b1}};
  
  /*AUTOINPUT*/
  /*AUTOOUTPUT*/
  
  /*AUTOREG*/
  // Beginning of automatic regs (for this module's undeclared outputs)
  reg                   clk_out;
  // End of automatics
  /*AUTOWIRE*/

  reg [BITS-1:0]                counter_r;
  always @(posedge clk_in or negedge reset_neg) begin
    if(reset_neg == 1'b0) begin
      /*AUTORESET*/
      // Beginning of autoreset for uninitialized flops
      clk_out <= 1'h0;
      counter_r <= {BITS{1'b0}};
      // End of automatics
    end
    else begin
      if(counter_r == COUNT) begin
        counter_r <= 0;
        clk_out <= ~clk_out;
      end 
      else begin
        counter_r <= counter_r+1;
      end
    end
  end
  
  

  
endmodule // clock_divider
/*  
 Local Variables:
 verilog-library-directories:(
 "."
 )
 End:
 */
