module four_by_seven (/*AUTOARG*/
  // Outputs
  segments, anodes_neg,
  // Inputs
  data, dots, clock, strobe, reset
  );
  input [15:0] data;
  input [3:0]  dots;
  output [7:0] segments;
  output [3:0]      anodes_neg; // a zero must be driven to illuminate the 7-segment (PNP transitor outside)

  input        clock;
  input        strobe;
  input        reset;
  
  
  /*AUTOINPUT*/
  /*AUTOOUTPUT*/

  reg [1:0]    counter_r;
  reg [3:0]   nibble;
  reg         dot;
  
  /*AUTOREG*/
  /*AUTOWIRE*/

  always @(posedge clock or posedge reset) begin
    if(reset == 1'b1) begin
      /*AUTORESET*/
      // Beginning of autoreset for uninitialized flops
      counter_r <= 2'h0;
      // End of automatics
    end
    else begin
      if(strobe) begin
        if(counter_r == 2'd3) begin
          counter_r <= 0;
        end
        else begin
          counter_r <= counter_r + 1;
        end
      end
    end
  end
  
  assign anodes_neg  = ~(4'b0001<<counter_r);
  
   /* seven_segments AUTO_TEMPLATE(
    ); */
  seven_segments U_SEVEN_SEGMENTS (
                          /*AUTOINST*/
                                   // Outputs
                                   .segments            (segments[6:0]),
                                   // Inputs
                                   .nibble              (nibble[3:0]));


 
  
  assign segments[7] = dot;

  always @* begin
    case(counter_r[1:0])
      2'b00: begin
        nibble[3:0] <= data[3:0];
        dot <= dots[0];
      end
      2'b01: begin 
        nibble[3:0] <= data[7:4];
        dot <= dots[1];
      end
      2'b10: begin 
        nibble[3:0] <= data[11:8];
        dot <= dots[2];
      end
      2'b11: begin
        nibble[3:0] <= data[15:12];
        dot <= dots[3];
      end
      default: begin
        nibble[3:0] <= data[3:0];
        dot <= dots[0];
      end
      
    endcase // case (counter_r[1:0])
    
  end
  
  

  

endmodule // four_by_seven
/*  
 Local Variables:
 verilog-library-directories:(
 "."
 )
 End:
 */
