module seven_segments(/*AUTOARG*/
  // Outputs
  segments,
  // Inputs
  nibble
  );
  output [6:0] segments;
  input [3:0] nibble;


  // segments format dot g f e d c b a (see http://en.wikipedia.org/wiki/Seven-segment_display)
  // Note : signals needs to be inverted            
  reg [6:0] segments;
  
  always @(nibble)
    case (nibble)
      4'h0: segments[6:0] = ~(7'b0111111);
      4'h1: segments[6:0] = ~(7'b0000110);
      4'h2: segments[6:0] = ~(7'b1011011);
      4'h3: segments[6:0] = ~(7'b1001111);
      4'h4: segments[6:0] = ~(7'b1100110);
      4'h5: segments[6:0] = ~(7'b1101101);
      4'h6: segments[6:0] = ~(7'b1111101);
      4'h7: segments[6:0] = ~(7'b0000111);
      4'h8: segments[6:0] = ~(7'b1111111);
      4'h9: segments[6:0] = ~(7'b1100111);
      4'hA: segments[6:0] = ~(7'b1110111);
      4'hB: segments[6:0] = ~(7'b1111100);
      4'hC: segments[6:0] = ~(7'b0111001);
      4'hD: segments[6:0] = ~(7'b1011110);
      4'hE: segments[6:0] = ~(7'b1111001);
      4'hF: segments[6:0] = ~(7'b1110001);
      default: segments = ~(7'b1000000); // "dash"
    endcase // case (nibble)

endmodule // seven_segments
