module delay_cell (z,i);
	parameter DELAY = 1;
	parameter NR_BITS = $clog2(DELAY);
	input i;
	output z;
	wire [NR_BITS-1:0] delay_sel;
	assign delay_sel = DELAY-1;
	delay_module #(.DELAY(DELAY)) DELMOD(.out(z),.in(i),.sel(delay_sel[NR_BITS-1:0]));
	//assign #DELAY z = i;
endmodule

module delay_module(out,in,sel)	;
parameter DELAY = 1;
parameter NR_BITS = $clog2(DELAY);
	input in;  
	input [NR_BITS-1:0] sel;
	output out;
	reg out;	   
	//ORDLY15s8fhvt DELAYEL(out,in,1'b1);
	wire [DELAY-1:0] in_temp;
	wire test;	
				   
	genvar i;
		ORDLY15s8fhvt DELAYEL(.o(in_temp[0]),.i1(in),.i2(1'b0));
	generate 
		for(i=0;i<DELAY-1; i=i+1) begin:delaygen
				ORDLY15s8fhvt DELAYEL(.o(in_temp[i+1]),.i1(in_temp[i]) ,.i2(1'b0));
		end
	endgenerate						
	
	always @ * begin
		out	<= in_temp[sel];
	end
	

	endmodule
module two_to_one_mux_nand(in1, in2, sel, out)	 ;
	input in1,in2,sel;
	output out;
		 
	wire a,b,c;
	not n1(a,sel);
	nand a1(b,in1,a); 
		 
	nand n2(c,in2,sel);
		 
	nand n3(out,c,b);
endmodule


module muller_c_element(a,b,reset,c);

	input a,b,reset;
	output c;	 
	cmuller2d4s8fhvt MULL ( .a(a), .b(b), .rstneg(reset), .z(c) );
	/* wire d,e,f,g;
	nand(d,a,b);
	nand(e,a,c);
	nand(f,b,c);
	nand #2 (g,d,e,f);
	//added mux to reset
	two_to_one_mux_nand mux1(0, g, reset, c); */
endmodule
/*
module pipe_module(x_req,y_ack,reset,data_in,data_out,x_ack,y_req);
parameter DATASIZE=16;
parameter DELAY=2;
	input x_req,y_ack,reset;
	input [DATASIZE-1:0] data_in;
	output x_ack,y_req;
	output [DATASIZE-1:0] data_out;
	wire not_y_ack;
	wire c;
	assign not_y_ack = !y_ack;
	assign x_ack = c;
	muller_c_element M1(x_req,not_y_ack,reset,c);
	ev_ctrl_storage_byte #(.SIZE(DATASIZE)) SE (data_in,c,y_ack,data_out);
	delay_cell #(.DELAY(DELAY)) DC1 (c,y_req);
endmodule
*/
//Register elementdec_rf_sela_mux_sel
module ev_ctrl_storage_element(in,c,p,out);	//The fast one
	input in,c,p;
	output out;
	wire a,b,d,e,f,g,h;
reg out;	
	always @* begin
		if(c==0 && p== 0) begin
			 out<=  in;
			end else if(c==1 && p==0) begin
			out<=  out;
			 end else if (c==1 && p==1) begin
			  out<= in;
			  end else if (c==0 && p==1) begin
			  out<=  out;
			  end
			  end
	////first top mux
	// two_to_one_mux_nand U1(a,in,c,b);
	// not(d,b);
	// not(a,d);
	
	////bottom mux 
	// two_to_one_mux_nand U2(in,e,c,f);
	// not(g,f);
	// not(e,g);
	
	////out mux						  
	// two_to_one_mux_nand U3(g,d,p,h);  
	// not (out,h);		  
endmodule

module ev_ctrl_storage_byte(in,c,p,out);
	
	parameter SIZE=8;
	
	input [SIZE-1:0] in;
	input c,p;
	output [SIZE-1:0]out;
	
	genvar i;
	ev_ctrl_storage_element REGEL(in[0],c,p,out[0]);
	generate 
		for(i=0;i<SIZE; i=i+1) begin:reggen
		ev_ctrl_storage_element REGEL(in[i],c,p,out[i]);
		end
	endgenerate	
	
		
endmodule

module toggle_on_change(out,a,b,reset);
	input a,b,reset;
	output out;
	reg out;
	
	always @(a or b or  reset) begin
		if (reset==0) begin
			out <= 0;
		end else begin
			out <= !out;
		end		
	end
endmodule

module pulse_generator(out,in);
	input in;
	output out;
	wire in;
	wire out;
	wire a;
	delay_cell  #(.DELAY (1)) D1(.z(a),.i(in));
	xor2d3s8fhvt PXOR(.I1(a), .I2(in), .O(out));
endmodule




module simd_useq(/*AUTOARG*/
  // Outputs
  pc_r, mem_in, mem_addr, mem_cs,mem_we,mem_clk, cpu_ack, ram_clk,
  // Inputs
  instruction, cpu_req, rst_n,mem_out
  );

`include "simd_params.v"
  
  input  [USEQ_INST_MSB:0] instruction; // Instruction word fetched from memory
  output [USEQ_WORD_MSB:0] pc_r; // address for the code memory


  input                    rst_n;
  input 		  cpu_req;
   input 			[USEQ_WORD_MSB:0]	mem_out;
  output 		cpu_ack;
  output 					ram_clk;
  
     output mem_cs,mem_clk;
  output mem_we;
  output  [USEQ_WORD_MSB:0] mem_addr; 
  output [USEQ_WORD_MSB:0] mem_in;   
  
  
  /*AUTOINPUT*/
  /*AUTOOUTPUT*/
  
  /*AUTOREG*/
  /*AUTOWIRE*/


  wire [USEQ_WORD_MSB:0]    dec_inst_r;
  wire [USEQ_WORD_MSB:0]		dec_inst_rr;


  // Register file
  reg [3:0]                      rf_sela;
  reg [3:0]                      rf_selb;
  reg [3:0]                      rf_selc;
  reg                            rf_write;
  
  wire [USEQ_WORD_MSB:0]         rf_a_out;
  wire [USEQ_WORD_MSB:0]         rf_b_out;
  
  reg [USEQ_WORD_MSB:0]         rf_a;
  reg [USEQ_WORD_MSB:0]         rf_b;
  wire [USEQ_WORD_MSB:0]         rf_c;
  
  // alu
  reg  [USEQ_WORD_MSB:0]          alu_a;
  reg  [USEQ_WORD_MSB:0]          alu_b;
  wire [USEQ_WORD_MSB:0]          alu_c;
                           
  reg [USEQ_WORD_MSB:0]           dest_bus;
  reg [USEQ_WORD_MSB:0]           dest_bus_s0;
  reg [USEQ_WORD_MSB:0]           dest_bus_s1;
  reg [USEQ_WORD_MSB:0]           dest_bus_s2;


  // PC
  reg [USEQ_WORD_MSB:0]           pc_r;
  reg [USEQ_WORD_MSB:0]           npc;
  reg                             write_to_pc;

  // Flow control
  reg                             halt;
  reg                             halt_r;

  
  

  // Special register support
  reg [USEQ_WORD_MSB:0]           sr_read_bus;
  

  // PE array address register
  // Fixme - those must be moved outside uSeq, to the address generator block
  // We keep them here for now for instruction & toolchain tests

  reg [USEQ_WORD_MSB:0]           ar0_r;
  reg [USEQ_WORD_MSB:0]           ar1_r;
  reg [USEQ_WORD_MSB:0]           ar2_r;
  reg [2:0]                       write_ar;
  
  
//@begin[sig_mux_sel]
reg [USEQ_SEL_RFB_MSB:0]  dec_rf_selb_mux_sel;
reg [USEQ_SEL_ALUB_MSB:0]  dec_alu_sourceb_mux_sel;
reg [USEQ_SEL_DEST_MSB:0]  dec_writeback_dest_mux_sel;
reg [USEQ_SEL_PC_MSB:0]  dec_pc_next_mux_sel;
reg [USEQ_SEL_RFC_MSB:0]  dec_rf_selc_mux_sel;
reg [USEQ_SEL_WBSOURCE_MSB:0]  dec_writeback_source_mux_sel;
reg [USEQ_SEL_ALUOP_MSB:0]  dec_alu_op_mux_sel;
reg [USEQ_SEL_ALUA_MSB:0]  dec_alu_sourcea_mux_sel;
reg [USEQ_SEL_RFA_MSB:0]  dec_rf_sela_mux_sel;
reg [USEQ_FLOW_HALT_MSB:0]  dec_flow_halt_mux_sel;
//@end[sig_mux_sel]  

   wire mem_cs;
   reg mem_clk;
  reg mem_we;
  reg  [USEQ_WORD_MSB:0] mem_addr; 
  wire [USEQ_WORD_MSB:0] mem_in;   

wire [USEQ_WORD_MSB:0] mem16_out;
reg [USEQ_WORD_MSB:0] mem16_in ;
reg mem16_write;
reg [USEQ_WORD_MSB:0] mem16_addr ;
wire [USEQ_BYTE_MSB:0] mem8_out;
reg [USEQ_BYTE_MSB:0] mem8_in;
reg mem8_write;
reg [USEQ_WORD_MSB:0] mem8_addr;

reg mem_req;
  
		wire ram_clk; 
      reg rf_clk;
 
 
 reg alu_req;
 wire alu_ack;
 
  wire rf_done;
     wire rf_ack;
	  reg ram_req;
	  reg ram_req_stall;
	  reg ram_req_pre;
  wire ram_ack;
  reg rf_req;
  wire cpu_ack;
    wire mem_clk_pre;
   wire pc_r_clk;
    wire mem_req_delayed;
 reg  rf_req_pre;
 wire mem_req_pre;
 reg ram_done;
 wire ram_done_pre;
 wire alu_done;
 wire mem_done;
 wire mem_ack;
 
 
   wire [15:0] decode_string;
    reg [15:0] FIFO_pc_r0;
	reg [15:0] FIFO_pc_r1;
	reg [15:0] FIFO_pc_r2;
	reg [15:0] FIFO_pc_r3;
	 reg [3:0] FIFO_rd0;
	 reg [3:0] FIFO_rd1;
	 reg [3:0] FIFO_rd2;
	 reg [3:0] FIFO_rd3;
	  reg [15:0] FIFO_op0;
	  reg [15:0] FIFO_op1;
	  reg [15:0] FIFO_op2;
	  reg [15:0] FIFO_op3;
	  wire ram_done_clk;
	  wire ram_ack_clk;
   
   reg [2:0]stall_cnt;
reg [2:0]stall_target;
reg [15:0]alu_c_stored;
reg alu_rf_b_forward;
reg alu_rf_a_forward;
reg stalling;
 reg stall;
 wire alu_done_clk;
 wire rf_clk_pre;
 
 assign alu_done = mem_req_pre;
  //@begin[inst_decode]
wire [USEQ_INST_FORMAT_OPCODE1_MSB:0] dec_opcode1  = dec_inst_r[USEQ_INST_FORMAT_OPCODE1_OFFSET +: USEQ_INST_FORMAT_OPCODE1_SIZE];

wire [USEQ_INST_FORMAT_RD_MSB:0] dec_rd  = dec_inst_r[USEQ_INST_FORMAT_RD_OFFSET +: USEQ_INST_FORMAT_RD_SIZE];

wire [USEQ_INST_FORMAT_OPCODE3_MSB:0] dec_opcode3  = dec_inst_r[USEQ_INST_FORMAT_OPCODE3_OFFSET +: USEQ_INST_FORMAT_OPCODE3_SIZE];

wire [USEQ_INST_FORMAT_RS2_MSB:0] dec_rs2  = dec_inst_r[USEQ_INST_FORMAT_RS2_OFFSET +: USEQ_INST_FORMAT_RS2_SIZE];

wire [USEQ_INST_FORMAT_UK4_MSB:0] dec_uk4  = dec_inst_r[USEQ_INST_FORMAT_UK4_OFFSET +: USEQ_INST_FORMAT_UK4_SIZE];

wire [USEQ_INST_FORMAT_RS1_MSB:0] dec_rs1  = dec_inst_r[USEQ_INST_FORMAT_RS1_OFFSET +: USEQ_INST_FORMAT_RS1_SIZE];

wire [USEQ_INST_FORMAT_OPCODE4_MSB:0] dec_opcode4  = dec_inst_r[USEQ_INST_FORMAT_OPCODE4_OFFSET +: USEQ_INST_FORMAT_OPCODE4_SIZE];

wire [USEQ_INST_FORMAT_K8_MSB:0] dec_k8  = dec_inst_r[USEQ_INST_FORMAT_K8_OFFSET +: USEQ_INST_FORMAT_K8_SIZE];

wire [USEQ_INST_FORMAT_COND_MSB:0] dec_cond  = dec_inst_r[USEQ_INST_FORMAT_COND_OFFSET +: USEQ_INST_FORMAT_COND_SIZE];

wire [USEQ_INST_FORMAT_K12_MSB:0] dec_k12  = dec_inst_r[USEQ_INST_FORMAT_K12_OFFSET +: USEQ_INST_FORMAT_K12_SIZE];

wire [USEQ_INST_FORMAT_K4_MSB:0] dec_k4  = dec_inst_r[USEQ_INST_FORMAT_K4_OFFSET +: USEQ_INST_FORMAT_K4_SIZE];

  //@end[inst_decode]


//PULSE ELEMENT FOR THIS
  // temporay code for address registers
  always @(rf_done or rst_n) begin
    if(rst_n == 1'b0) begin
      /*AUTORESET*/
      // Beginning of autoreset for uninitialized flops
      ar0_r <= {(1+(USEQ_WORD_MSB)){1'b0}};
      ar1_r <= {(1+(USEQ_WORD_MSB)){1'b0}};
      ar2_r <= {(1+(USEQ_WORD_MSB)){1'b0}};
      // End of automatics
    end
    else begin
      if(write_ar[2:0] == 3'b001)
        ar0_r <= dest_bus;
      if(write_ar[2:0] == 3'b010)
        ar1_r <= dest_bus;
      if(write_ar[2:0] == 3'b100)
        ar2_r <= dest_bus;
    end
  end
  
assign mem_done = rf_req;

  

//wires for latches
//s0
wire [USEQ_WORD_MSB:0] alu_a_s0;
wire [USEQ_WORD_MSB:0] alu_b_s0;
wire [USEQ_SEL_ALUOP_MSB:0] dec_alu_op_mux_sel_s0;
wire [3:0] rf_selc_s0;
wire rf_write_s0;
wire [USEQ_SEL_WBSOURCE_MSB:0] dec_writeback_source_mux_sel_s0;
wire [USEQ_WORD_MSB:0] rf_b_s0;
wire [USEQ_SEL_PC_MSB:0] dec_pc_next_mux_sel_s0;
wire [USEQ_SEL_RFC_MSB:0] dec_rf_selc_mux_sel_s0;
wire [15:0] decode_string_s0;
wire [USEQ_SEL_DEST_MSB:0] dec_writeback_dest_mux_sel_s0;
wire [USEQ_INST_FORMAT_RD_MSB:0] dec_rd_s0;
wire halt_s0;

//s1
wire [USEQ_WORD_MSB:0] alu_c_s1;
wire rf_write_s1;
wire [3:0] rf_selc_s1;
wire [USEQ_SEL_WBSOURCE_MSB:0] dec_writeback_source_mux_sel_s1;
wire [USEQ_WORD_MSB:0] rf_b_s1;
wire [USEQ_SEL_PC_MSB:0] dec_pc_next_mux_sel_s1;
wire [USEQ_SEL_RFC_MSB:0] dec_rf_selc_mux_sel_s1;
wire [15:0] decode_string_s1;
wire [USEQ_SEL_DEST_MSB:0] dec_writeback_dest_mux_sel_s1;
wire [USEQ_INST_FORMAT_RD_MSB:0] dec_rd_s1;

//s2
wire [USEQ_WORD_MSB:0] alu_c_s2;
wire rf_write_s2;
wire [3:0] rf_selc_s2;
wire [USEQ_SEL_WBSOURCE_MSB:0] dec_writeback_source_mux_sel_s2;
wire [USEQ_BYTE_MSB:0] mem8_out_s2;
wire [USEQ_WORD_MSB:0] mem16_out_s2;
wire [USEQ_SEL_RFC_MSB:0] dec_rf_selc_mux_sel_s2;
wire [USEQ_SEL_DEST_MSB:0] dec_writeback_dest_mux_sel_s2;
wire [USEQ_WORD_MSB:0] rf_b_s2;
wire [USEQ_INST_FORMAT_RD_MSB:0] dec_rd_s2;

always @* begin
if(rst_n == 1'b0) begin
alu_req = 1'b0;

end else if (stall == 1) begin
	alu_req = ram_req_stall;
end else begin
	alu_req = ram_done;
end
end
//assign alu_req = ram_done;

assign mem_in = alu_c;
assign mem_cs = 0;
assign mem16_out = mem_out;
assign mem8_out = mem_out;

always @* begin
if(rst_n == 1'b0) begin
ram_req = 1'b0;
ram_req_stall = 1'b0;
end else if(stall == 1'b1) begin	
	ram_req_stall = ram_req_pre;
	ram_req = ram_req;
	end else begin
	ram_req = ram_req_pre;
	ram_req_stall = ram_req_stall;
	end
end

always @*begin
if(rst_n == 1'b0) begin
ram_done = 0;
end else if(stall==1) begin
ram_done = ram_req_stall;
end else begin
ram_done = ram_done_pre;
end
end
 
muller_c_element RAMC (ram_req,!alu_ack,rst_n,ram_ack);
delay_cell #(.DELAY (10)) RAMD (.z(ram_done_pre),.i(ram_ack));
pulse_generator PGPCR(.out(pc_r_clk),.in(alu_ack));
 
muller_c_element ALUC (.a(alu_req),.b(!mem_ack),.reset(rst_n),.c(alu_ack));
//ev_ctrl_storage_byte   #(.SIZE (1)) SBHALT(.in(halt),.c(alu_ack),.p(mem_ack),.out(halt_s0));
ev_ctrl_storage_byte   #(.SIZE (16)) DECS(.in(dec_inst_rr),.c(alu_ack),.p(mem_ack),.out(dec_inst_r)); //can skip this latch? should latch over register read to?
ev_ctrl_storage_byte   #(.SIZE (USEQ_WORD_BITS)) SBALUAS0(.in(alu_a),.c(alu_ack),.p(mem_ack),.out(alu_a_s0));
ev_ctrl_storage_byte   #(.SIZE (USEQ_WORD_BITS)) SBALUBS0(.in(alu_b),.c(alu_ack),.p(mem_ack),.out(alu_b_s0)); 
ev_ctrl_storage_byte   #(.SIZE (USEQ_SEL_ALUOP_BITS)) SBOPMUXS0(.in(dec_alu_op_mux_sel),.c(alu_ack),.p(mem_ack),.out(dec_alu_op_mux_sel_s0)); 
//ev_ctrl_storage_byte   #(.SIZE (16)) DECS(dest_bus,.c(alu_ack,.p(mem_ack,dest_bus_s0); //rf_b on mem
ev_ctrl_storage_byte   #(.SIZE (4)) SBSELCS0(.in(rf_selc),.c(alu_ack),.p(mem_ack),.out(rf_selc_s0)); 
ev_ctrl_storage_byte   #(.SIZE (1)) SBRFWRS0(.in(rf_write),.c(alu_ack),.p(mem_ack),.out(rf_write_s0)); 
ev_ctrl_storage_byte   #(.SIZE (USEQ_SEL_WBSOURCE_BITS)) SBWBMUXS0(.in(dec_writeback_source_mux_sel),.c(alu_ack),.p(mem_ack),.out(dec_writeback_source_mux_sel_s0)); 
ev_ctrl_storage_byte   #(.SIZE (USEQ_WORD_BITS)) SBRFBS0(.in(rf_b),.c(alu_ack),.p(mem_ack),.out(rf_b_s0)); //rf_b on mem
ev_ctrl_storage_byte   #(.SIZE (USEQ_SEL_PC_BITS)) SBPCMUXS0(.in(dec_pc_next_mux_sel),.c(alu_ack),.p(mem_ack),.out(dec_pc_next_mux_sel_s0)); 
ev_ctrl_storage_byte   #(.SIZE (16)) SBDECSTRS0(.in(decode_string),.c(alu_ack),.p(mem_ack),.out(decode_string_s0)); 
ev_ctrl_storage_byte   #(.SIZE (USEQ_SEL_DEST_BITS)) SBWBDESTMUXS0(.in(dec_writeback_dest_mux_sel),.c(alu_ack),.p(mem_ack),.out(dec_writeback_dest_mux_sel_s0));
ev_ctrl_storage_byte   #(.SIZE (USEQ_INST_FORMAT_RD_SIZE)) SBDECRDS0(.in(dec_rd),.c(alu_ack),.p(mem_ack),.out(dec_rd_s0));  
//ev_ctrl_storage_byte   #(.SIZE (USEQ_SEL_RFC_BITS)) SBSELCMUXS0(dec_rf_selc_mux_sel,alu_ack,mem_ack,dec_rf_selc_mux_sel_s0); 
//

delay_cell #(.DELAY (2))  ALUD (.z(mem_req_pre),.i(alu_ack));

 //MEMORY request  //store alu_c, dest_bus_s0, rf_write_s0, rf_selc_s0
 muller_c_element MEMC (.a(mem_req_pre),.b(!rf_ack),.reset(rst_n),.c(mem_ack));
 ev_ctrl_storage_byte   #(.SIZE (USEQ_WORD_BITS)) SBALUCS1(.in(alu_c),.c(mem_ack),.p(rf_ack),.out(alu_c_s1)); 
 //ev_ctrl_storage_byte   #(.SIZE (16)) DECS(dest_bus_s0),.c(mem_ack),.p(rf_ack),dest_bus_s1); 
 ev_ctrl_storage_byte   #(.SIZE (1)) SBRFWRS1(.in(rf_write_s0),.c(mem_ack),.p(rf_ack),.out(rf_write_s1)); 
 ev_ctrl_storage_byte   #(.SIZE (4)) SBSELCS1(.in(rf_selc_s0),.c(mem_ack),.p(rf_ack),.out(rf_selc_s1)); 
 ev_ctrl_storage_byte   #(.SIZE (USEQ_SEL_WBSOURCE_BITS)) SBWBMUXS1(.in(dec_writeback_source_mux_sel_s0),.c(mem_ack),.p(rf_ack),.out(dec_writeback_source_mux_sel_s1)); 
 ev_ctrl_storage_byte   #(.SIZE (USEQ_WORD_BITS)) SBRFBS1(.in(rf_b_s0),.c(mem_ack),.p(rf_ack),.out(rf_b_s1)); 
 ev_ctrl_storage_byte   #(.SIZE (USEQ_SEL_PC_BITS)) SBPCMUXS1(.in(dec_pc_next_mux_sel_s0),.c(mem_ack),.p(rf_ack),.out(dec_pc_next_mux_sel_s1)); 
 ev_ctrl_storage_byte   #(.SIZE (16)) SBDECSTRS1(.in(decode_string_s0),.c(mem_ack),.p(rf_ack),.out(decode_string_s1)); 
 ev_ctrl_storage_byte   #(.SIZE (USEQ_SEL_DEST_BITS)) SBWBDESTMUXS1(.in(dec_writeback_dest_mux_sel_s0),.c(mem_ack),.p(rf_ack),.out(dec_writeback_dest_mux_sel_s1)); 
 ev_ctrl_storage_byte   #(.SIZE (USEQ_INST_FORMAT_RD_SIZE)) SBDECRDS1(.in(dec_rd_s0),.c(mem_ack),.p(rf_ack),.out(dec_rd_s1));
 //ev_ctrl_storage_byte   #(.SIZE (USEQ_SEL_RFC_BITS)) SBSELCMUXS1(.in(dec_rf_selc_mux_sel_s0,.c(mem_ack,.p(rf_ack,dec_rf_selc_mux_sel_s1); 
 
  
  //RF request and delay
	
   muller_c_element RFC (.a(rf_req),.b(!rf_done),.reset(rst_n),.c(rf_ack));
   ev_ctrl_storage_byte   #(.SIZE (4)) SBSELCS2(.in(rf_selc_s1),.c(rf_ack),.p(rf_done),.out(rf_selc_s2)); 
    ev_ctrl_storage_byte   #(.SIZE (USEQ_SEL_WBSOURCE_BITS)) SBWBMUXS2(.in(dec_writeback_source_mux_sel_s1),.c(rf_ack),.p(rf_done),.out(dec_writeback_source_mux_sel_s2));
	ev_ctrl_storage_byte   #(.SIZE (1)) SBRFWRS2(.in(rf_write_s1),.c(rf_ack),.p(rf_done),.out(rf_write_s2)); 
 ev_ctrl_storage_byte   #(.SIZE (USEQ_WORD_BITS)) SBALUCS2(.in(alu_c_s1),.c(rf_ack),.p(rf_done),.out(alu_c_s2)); 	
 
 	ev_ctrl_storage_byte   #(.SIZE (USEQ_WORD_BITS)) SBMEM8OS2(.in(mem8_out),.c(rf_ack),.p(rf_done),.out(mem8_out_s2));
 	ev_ctrl_storage_byte   #(.SIZE (USEQ_WORD_BITS)) SBMEM16OS2(.in(mem16_out),.c(rf_ack),.p(rf_done),.out(mem16_out_s2));
	ev_ctrl_storage_byte   #(.SIZE (USEQ_SEL_DEST_BITS)) SBWBDESTMUXS2(.in(dec_writeback_dest_mux_sel_s1),.c(rf_ack),.p(rf_done),.out(dec_writeback_dest_mux_sel_s2));
 ev_ctrl_storage_byte   #(.SIZE (USEQ_WORD_BITS)) SBRFBS2(.in(rf_b_s1),.c(rf_ack),.p(rf_done),.out(rf_b_s2)); 	
 ev_ctrl_storage_byte   #(.SIZE (USEQ_INST_FORMAT_RD_SIZE)) SBDECRDS2(.in(dec_rd_s1),.c(rf_ack),.p(rf_done),.out(dec_rd_s2));
	// ev_ctrl_storage_byte   #(.SIZE (USEQ_SEL_RFC_BITS)) SBSELCMUXS2(dec_rf_selc_mux_sel_s1,mem_ack,rf_ack,dec_rf_selc_mux_sel_s2); 
	
delay_cell #(.DELAY (3))  RFD (.z(rf_done),.i(rf_ack));
      pulse_generator PGMEM(.out(mem_clk_pre),.in(mem_req));
  delay_cell #(.DELAY (10)) MEMD (.z(mem_req_delayed),.i(mem_req));
  pulse_generator PGRF(.out(rf_clk_pre),.in(rf_ack));
  
  always @* begin
  if(stall ==1) begin
	rf_clk <= 0;
	end else begin
	rf_clk <= rf_clk_pre;
	end
	end

	reg ram_ack_muxed;
	always @* begin
	if(rst_n== 1'b0) begin
		ram_ack_muxed = 0;
		end else if (stall== 1'b1) begin
		ram_ack_muxed = ram_req_stall;
		end else begin
		ram_ack_muxed = ram_ack;
		end 
	end
	
	
  //stalling
  pulse_generator PGRAMACK(.out(ram_ack_clk),.in(ram_ack_muxed));
  pulse_generator PGRAMDONE(.out(ram_done_clk),.in(ram_done));
  pulse_generator PGALUDONE(.out(alu_done_clk),.in(alu_done));
  //end of pipeline
  
  always @(posedge alu_done_clk) begin
	if(rst_n == 1'b0) begin
		alu_c_stored <= 0;
	end else begin
		alu_c_stored <= alu_c;
	end
end
		
 //FIFO FOR INSTR. AND RD 
 //ON RAM_ACK -> SHIFT FIFO AND ADD ELEMENT AT START
 always @(posedge ram_ack_clk or negedge rst_n) begin
	if(rst_n == 1'b0) begin
	FIFO_pc_r3<= {(1+(USEQ_WORD_MSB)){1'b0}};
	FIFO_pc_r2<= {(1+(USEQ_WORD_MSB)){1'b0}};
	FIFO_pc_r1<= {(1+(USEQ_WORD_MSB)){1'b0}};
	
	FIFO_rd3<= {(1+(USEQ_WORD_MSB)){1'b0}};
	FIFO_rd2<= {(1+(USEQ_WORD_MSB)){1'b0}};
	FIFO_rd1<= {(1+(USEQ_WORD_MSB)){1'b0}};

	FIFO_op3<= {(1+(USEQ_WORD_MSB)){1'b0}};
	FIFO_op2<= {(1+(USEQ_WORD_MSB)){1'b0}};
	FIFO_op1<= {(1+(USEQ_WORD_MSB)){1'b0}};
	end else begin
	FIFO_pc_r3<= FIFO_pc_r2;
	FIFO_pc_r2<= FIFO_pc_r1;
	FIFO_pc_r1<= FIFO_pc_r0;
	
	FIFO_rd3<= FIFO_rd2;
	FIFO_rd2<= FIFO_rd1;
	FIFO_rd1<= FIFO_rd0;

	FIFO_op3<= FIFO_op2;
	FIFO_op2<= FIFO_op1;
	FIFO_op1<= FIFO_op0;	
	end
end

 //ON RAM_DONE_CLK
 always @(posedge ram_done_clk or negedge rst_n) begin
 if(rst_n == 1'b0) begin
	FIFO_pc_r0 ={(1+(USEQ_WORD_MSB)){1'b0}};
	FIFO_rd0 ={(4){1'b0}};
	FIFO_op0 ={(1+(USEQ_WORD_MSB)){1'b0}};
	alu_rf_b_forward =0;
	alu_rf_a_forward = 0;
	stall=0;
	stall_target<=0;
end else begin
	FIFO_pc_r0 =pc_r;
	FIFO_rd0 =rf_selc;
	FIFO_op0 =decode_string;	
	if(((FIFO_rd1==rf_selb) || (FIFO_rd1==rf_sela)) && (FIFO_pc_r1!=pc_r)) begin
	//SEND BACK ALU_C UNLESS FIFO_op == LW or SW then stall long WCDELAY-RAM_DELAY
		casez(FIFO_op1)
		USEQ_OPCODES_SW: begin
			stall_target<=3;
			stall=1;
			alu_rf_a_forward = 0;
			alu_rf_b_forward = 0;
		end 
		USEQ_OPCODES_SB: begin
			stall_target<=3;
			stall=1;
			alu_rf_a_forward = 0;
			alu_rf_b_forward = 0;
		end 
		USEQ_OPCODES_LB:  begin
			stall_target<=3;
			stall=1;
			alu_rf_a_forward = 0;
			alu_rf_b_forward = 0;
		end 
		USEQ_OPCODES_LW: begin
			stall_target<=3;
			stall=1;
			alu_rf_a_forward = 0;
			alu_rf_b_forward = 0;
		end
		default: begin
		 stall=0;
		 stall_target<=0;
		 if(FIFO_rd1 == rf_sela) begin
			alu_rf_b_forward = 1;
		end else begin
			alu_rf_b_forward = 0;
			end
		if(FIFO_rd1 == rf_selb) begin
			alu_rf_a_forward = 1;
				end else begin
			alu_rf_b_forward = 0;
			end
		 
		end
		endcase
		

	end else if((FIFO_rd2==rf_selb) && (FIFO_pc_r2!=pc_r)) begin
	alu_rf_a_forward = 0;
	alu_rf_b_forward = 0;
				casez(FIFO_op2)
		USEQ_OPCODES_SW: begin
			stall_target<=2;
			stall=1;
		end 
		USEQ_OPCODES_SB: begin
			stall_target<=2;
			stall=1;
		end 
		USEQ_OPCODES_LB:  begin
			stall_target<=2;
			stall=1;
		end 
		USEQ_OPCODES_LW: begin
			stall_target<=2;
			stall=1;
		end
		default: begin
		 stall=0;
		 stall_target<=0;
		end
		endcase
//if FIFO_OP STALL till register is updated  stall WCDELAY-RAM_DELAY-ALU_DELAY

	end else if((FIFO_rd3==rf_selb) && (FIFO_pc_r2!=pc_r)) begin
		alu_rf_a_forward = 0;
	alu_rf_b_forward = 0;
//if FIFO_OP STALL till register is updated stall RF DELAY
		casez(FIFO_op3)
		USEQ_OPCODES_SW: begin
			stall_target<=1;
			stall=1;
		end 
		USEQ_OPCODES_SB: begin
			stall_target<=1;
			stall=1;
		end 
		USEQ_OPCODES_LB:  begin
			stall_target<=1;
			stall=1;
		end 
		USEQ_OPCODES_LW: begin
			stall_target<=1;
			stall=1;
		end
		default: begin
		 stall=0;
		 stall_target<=0;
		 end
		endcase
	end	else begin
		if(ram_req == ram_req_stall) begin
			stall=0;
		end else begin
			stall = 0;
		end 
		alu_rf_a_forward = 0;
		alu_rf_b_forward = 0;
		end
	
	end	
end
	
	assign dec_inst_rr = instruction;

  
  // decoder for register file, selection for port A
  // Constants in the file rf_sela.generated.v (and useq_params.v of course)
  always @* begin
    case(dec_rf_sela_mux_sel)
      USEQ_SEL_RFA_R0: begin
        rf_sela <= 0;        
      end
      USEQ_SEL_RFA_RS1: begin
        rf_sela <= dec_rs1;        
      end
      USEQ_SEL_RFA_RD: begin
        rf_sela <= dec_rd;        
      end
      default:
        rf_sela <= dec_rs1;        
    endcase
  end


  

  // decoder for register file, selection for port B
  // Constants in the file rf_selb.generated.v (and useq_params.v of course)
  
  always @* begin
    case(dec_rf_selb_mux_sel)
	  USEQ_SEL_RFB_RD: begin
		rf_selb <= dec_rd;
	  end
      USEQ_SEL_RFB_R1: begin
        rf_selb <= 'b1;        
      end
      USEQ_SEL_RFB_RS1: begin
        rf_selb <= dec_rs1;        
      end
      USEQ_SEL_RFB_RS2: begin
        rf_selb <= dec_rs2;        
      end
      default:
        rf_selb <= dec_rs2;        
    endcase
  end
  
  always @* begin
    case(alu_rf_b_forward)
	  0: begin
		rf_b <= rf_b_out;
	  end
      1: begin
        rf_b <= alu_c_stored;
	 end
      default:
        rf_b <= rf_b_out;        
    endcase
  end
  
  
  always @* begin
    case(alu_rf_a_forward)
	  0: begin
		rf_a <= rf_a_out;
	  end
      1: begin
        rf_a <= alu_c_stored;
	 end
      default:
        rf_a <= rf_a_out;        
    endcase
  end


  // decoder for register file, selection for port C (writeback)
  // Constants in the file rf_selc.generated.v (and useq_params.v of course)
  always @* begin
    case(dec_rf_selc_mux_sel)
      USEQ_SEL_RFC_R0: begin
        rf_selc <= 0; // Fixme : really needed ?        
      end
      USEQ_SEL_RFC_R1: begin
        rf_selc <= 'b1;        
      end
      USEQ_SEL_RFC_RS2: begin
        rf_selc <= dec_rs2;        
      end
      USEQ_SEL_RFC_RD: begin
        rf_selc <= dec_rd;        
      end
      default:
        rf_selc <= dec_rd;        
    endcase
  end
  

  // decoder for ALU port A
  // see alu_sourcea.generated.v
  always @* begin
    case(dec_alu_sourcea_mux_sel)
      USEQ_SEL_ALUA_RFA: begin
        alu_a <= rf_a;        
      end
      USEQ_SEL_ALUA_NPC: begin
        alu_a <= npc;        
      end
    default:
      alu_a <= rf_a;
    endcase
  end


  event evt_dbg;
  
  // decoder for ALU port B
  // see alu_sourcea.generated.v
  always @* begin
    case(dec_alu_sourceb_mux_sel)
      USEQ_SEL_ALUB_RFB: begin
        alu_b <= rf_b;        
      end
      USEQ_SEL_ALUB_NOT_RFB: begin
        alu_b <= ~rf_b;        
      end
      USEQ_SEL_ALUB_UK4: begin
        alu_b <= {{(USEQ_WORD_MINUS_K4){1'b0}},dec_uk4};        
      end
      USEQ_SEL_ALUB_K4: begin // Sign extention
        alu_b <= {{(USEQ_WORD_MINUS_K4+1){dec_uk4[3]}},dec_uk4[2:0]};        
      end
      USEQ_SEL_ALUB_K8: begin // Sign extention
        alu_b <= {{(USEQ_WORD_MINUS_K8+1){dec_k8[7]}},dec_k8[6:0]};        
      end
      USEQ_SEL_ALUB_K12: begin // no sign extention               
        alu_b <= {dec_k12,{(USEQ_WORD_MINUS_K12){1'b0}}};        
      end

      USEQ_SEL_ALUB_RFB_OR_UK4: begin
        alu_b <= rf_b | {{(USEQ_WORD_MINUS_K4){1'b0}},dec_uk4};        
      end
      USEQ_SEL_ALUB_NOT_RFB_OR_UK4: begin
        alu_b <= ~(rf_b | {{(USEQ_WORD_MINUS_K4){1'b0}},dec_uk4});        
      end
      USEQ_SEL_ALUB_SR: begin
        alu_b <= sr_read_bus;        
      end
      
      default:
        alu_b <= rf_b;        
    endcase
  end


  // Write back - source selection
  // see wb_source.generated.v
  always @* begin
    case(dec_writeback_source_mux_sel)
      USEQ_SEL_WBSOURCE_ALU: begin
        dest_bus <= 0 ;
      end
      USEQ_SEL_WBSOURCE_RFB: begin
        dest_bus <= rf_b; 
      end
      USEQ_SEL_WBSOURCE_MEM16: begin
        dest_bus <= 0;
      end
      USEQ_SEL_WBSOURCE_MEM8: begin
        dest_bus <= 0;
      end
     default:
       dest_bus <= 0; 
    endcase
  end
  
   always @* begin
    case(dec_writeback_source_mux_sel_s0)
      USEQ_SEL_WBSOURCE_ALU: begin
        dest_bus_s0 <= 0; 
      end
      USEQ_SEL_WBSOURCE_RFB: begin
        dest_bus_s0 <= rf_b_s0; 
      end
      USEQ_SEL_WBSOURCE_MEM16: begin
        dest_bus_s0 <= 0;
      end
      USEQ_SEL_WBSOURCE_MEM8: begin
        dest_bus_s0 <= 0;
      end
     default:
       dest_bus <= 0; 
    endcase
  end
  
  always @* begin
    case(dec_writeback_source_mux_sel_s1)
      USEQ_SEL_WBSOURCE_ALU: begin
        dest_bus_s1 <= alu_c_s1; 
		mem16_addr <=rf_b_s1;
		mem8_addr <= rf_b_s1;
		mem_addr <= rf_b_s1;
      end
      USEQ_SEL_WBSOURCE_RFB: begin
        dest_bus_s1 <= rf_b_s1; 
		mem16_addr <=rf_b_s1;
		mem8_addr <= rf_b_s1;
		mem_addr <= rf_b_s1;
		mem16_in <= alu_c_s1;
		mem8_in <= alu_c_s1;
      end
      USEQ_SEL_WBSOURCE_MEM16: begin
        dest_bus_s1 <= mem_out;
		mem16_addr <=alu_c_s1;
		mem8_addr <=alu_c_s1;
		mem16_in <= alu_c_s1;
		mem_addr <= alu_c_s1;
      end
      USEQ_SEL_WBSOURCE_MEM8: begin
        dest_bus_s1 <= mem_out;
		mem16_addr <=alu_c_s1;
		mem8_addr <=alu_c_s1;
		mem8_in <= alu_c_s1;
		mem_addr <= alu_c_s1;
      end
     default: begin
       dest_bus_s1 <= alu_c_s1; 
	   	mem8_addr <=rf_b_s1;
		mem8_in <= alu_c_s1;
		mem16_addr <=rf_b_s1;
		mem16_in <= alu_c_s1;
		mem_addr <= rf_b_s1;
		end
    endcase
  end
  
     always @* begin
    case(dec_writeback_source_mux_sel_s2)
      USEQ_SEL_WBSOURCE_ALU: begin
        dest_bus_s2 <= alu_c_s2; 
      end
      USEQ_SEL_WBSOURCE_RFB: begin
        dest_bus_s2 <= rf_b_s2; 
      end
      USEQ_SEL_WBSOURCE_MEM16: begin
        dest_bus_s2 <= mem16_out_s2;
      end
      USEQ_SEL_WBSOURCE_MEM8: begin
        dest_bus_s2 <= mem8_out_s2;
      end
     default:
       dest_bus_s2 <= alu_c_s2; 	   
    endcase
  end
  
  

  assign rf_c = dest_bus_s2;

  // Write back - destination selection
  // see wb_dest.generated.v
  always @* begin
    rf_write = 1'b0;
    write_ar = 3'b0;
	mem8_write = 1'b0;
	mem16_write = 1'b0;
	rf_write = 1'b0;
	mem_we <= 1'b0;
	
	
	case(dec_writeback_dest_mux_sel)
      USEQ_SEL_DEST_RFC: begin  
		rf_write =  1'b1;
      end
      USEQ_SEL_DEST_COND_LINK_REG: begin
      end
      USEQ_SEL_DEST_MEM16: begin
        // Fixme
      end   
      USEQ_SEL_DEST_MEM8: begin
        // Fixme
      end 
      USEQ_SEL_DEST_SR: begin
        case(dec_rd)
         USEQ_SR_AR0 : begin          
         end
         USEQ_SR_AR1 : begin         
         end
         USEQ_SR_AR2 : begin         
         end
          default: begin      
          end
          
        endcase 
      end 
      default: begin
		rf_write = 1'b0;
      end
    endcase 

case(dec_writeback_dest_mux_sel_s1)
      USEQ_SEL_DEST_RFC: begin   
      end
      USEQ_SEL_DEST_COND_LINK_REG: begin
      end
      USEQ_SEL_DEST_MEM16: begin
		mem16_write = 1'b1;
		mem_we <= 1'b1;
      end   
      USEQ_SEL_DEST_MEM8: begin
		mem8_write = 1'b1;
        mem_we <= 1'b1;
      end 
      USEQ_SEL_DEST_SR: begin
        case(dec_rd)
         USEQ_SR_AR0 : begin          
         end
         USEQ_SR_AR1 : begin         
         end
         USEQ_SR_AR2 : begin         
         end
          default: begin 
	  
          end
          
        endcase 
      end 
      default: begin
	  	  mem8_write = 1'b0;
	  mem8_write = 1'b0;
	  mem_we <= 1'b0;
      end
    endcase 
	
case(dec_writeback_dest_mux_sel_s2)
      USEQ_SEL_DEST_RFC: begin      
      end
      USEQ_SEL_DEST_COND_LINK_REG: begin
      end
      USEQ_SEL_DEST_MEM16: begin
        // Fixme

      end   
      USEQ_SEL_DEST_MEM8: begin

        // Fixme
      end 
      USEQ_SEL_DEST_SR: begin
        case(dec_rd)
         USEQ_SR_AR0 : begin
           write_ar = 3'b001;           
         end
         USEQ_SR_AR1 : begin
           write_ar = 3'b010;           
         end
         USEQ_SR_AR2 : begin
           write_ar = 3'b100;           
         end
          default: begin
            write_ar = 3'b000;           
          end
          
        endcase 
      end 
      default: begin

        write_ar = 3'b0;
      end
    endcase  	
  end


  // Selection of special register for read
  // To be used by mfrs instruction
  
  always @* begin
    case(dec_rs1)
      USEQ_SR_AR0 : begin
        sr_read_bus = ar0_r;        
      end
      USEQ_SR_AR1 : begin
        sr_read_bus = ar1_r;        
      end
      USEQ_SR_AR2 : begin
        sr_read_bus = ar2_r;        
      end
      USEQ_SR_SR : begin
        sr_read_bus = 0; // Fixme        
      end
      default: begin
      end
      
    endcase 
  end

  // Halt instruction
  always @* begin
    case(dec_flow_halt_mux_sel)
      USEQ_FLOW_HALT_YES: begin
        halt = 1'b1;        
      end
      USEQ_FLOW_HALT_NO: begin
        halt = 1'b0;        
      end
      default: begin
        halt = 1'b0;        
      end      
    endcase 
  end

  
  assign decode_string = {dec_opcode1,dec_opcode3,dec_opcode4,dec_cond};
  reg [39:0]           _codeop_ascii_r;          // Decode of state_r
  initial
    _codeop_ascii_r = "Unknown";
  
  
  always @* begin
    // FIXME : we need the default case
    casez(decode_string)
    //@begin[case_inst]
    USEQ_OPCODES_AND: begin
        _codeop_ascii_r = "USEQ_OPCODES_AND";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_RD;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_RS2;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_RFB;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_AND;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_XNORR1: begin
        _codeop_ascii_r = "USEQ_OPCODES_XNORR1";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_RD;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_R1;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_RFB_OR_UK4;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_XNOR;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_ADD2C: begin
        _codeop_ascii_r = "USEQ_OPCODES_ADD2C";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_RD;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_RS2;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_RFB;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_ADD;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_LDIR1: begin
        _codeop_ascii_r = "USEQ_OPCODES_LDIR1";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_R0;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_RS2;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_R1;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_K12;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_ADD;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_ORR1: begin
        _codeop_ascii_r = "USEQ_OPCODES_ORR1";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_RD;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_R1;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_RFB_OR_UK4;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_OR;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_HALT: begin
        _codeop_ascii_r = "USEQ_OPCODES_HALT";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_R0;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_RS1;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_R0;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_RFB;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_ADD;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_YES;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_XORR1: begin
        _codeop_ascii_r = "USEQ_OPCODES_XORR1";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_RD;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_R1;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_RFB_OR_UK4;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_XOR;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_LB: begin
        _codeop_ascii_r = "USEQ_OPCODES_LB";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_MEM8;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_RS1;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_RD;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_K4;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_ADD;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_SUB2C: begin
        _codeop_ascii_r = "USEQ_OPCODES_SUB2C";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_RD;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_RS2;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_NOT_RFB;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_ADD;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_RET: begin
        _codeop_ascii_r = "USEQ_OPCODES_RET";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_PC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_R0;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_R14;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_RFB;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_ADD;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_FROM_ALU;
    end
    USEQ_OPCODES_LW: begin
        _codeop_ascii_r = "USEQ_OPCODES_LW";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_MEM16;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_RS1;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_RD;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_K4;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_ADD;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_SUB3: begin
        _codeop_ascii_r = "USEQ_OPCODES_SUB3";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_RS1;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_RS2;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_RFB;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_SUB;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_XNOR: begin
        _codeop_ascii_r = "USEQ_OPCODES_XNOR";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_RD;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_RS2;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_RFB;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_XNOR;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_BRPC: begin
        _codeop_ascii_r = "USEQ_OPCODES_BRPC";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_COND_LINK_REG;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_RD;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_RS1;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RS2;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_K8;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_NPC;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_ADD;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_COND_LOAD_FROM_ALU;
    end
    USEQ_OPCODES_SUB2: begin
        _codeop_ascii_r = "USEQ_OPCODES_SUB2";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_RD;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_RS1;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_NOT_RFB_OR_UK4;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_ADD;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_ANDR1: begin
        _codeop_ascii_r = "USEQ_OPCODES_ANDR1";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_RD;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_R1;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_RFB_OR_UK4;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_AND;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_MFSR: begin
        _codeop_ascii_r = "USEQ_OPCODES_MFSR";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_R0;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_RS1;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_SR;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_ADD;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_MTSR: begin
        _codeop_ascii_r = "USEQ_OPCODES_MTSR";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_SR;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_R0;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_RS1;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_RFB;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_ADD;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_ORI4: begin
        _codeop_ascii_r = "USEQ_OPCODES_ORI4";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_R0;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_RS1;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_RFB_OR_UK4;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_OR;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_SRAI: begin
        _codeop_ascii_r = "USEQ_OPCODES_SRAI";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_RD;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_R1;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_UK4;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_SRA;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_SEXT: begin
        _codeop_ascii_r = "USEQ_OPCODES_SEXT";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_RD;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_RS2;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_RFB;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_SEXT;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_BR: begin
        _codeop_ascii_r = "USEQ_OPCODES_BR";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_COND_LINK_REG;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_R0;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_RS1;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_R0;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_RFB_OR_UK4;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_ADD;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_COND_LOAD_FROM_ALU;
    end
    USEQ_OPCODES_XOR: begin
        _codeop_ascii_r = "USEQ_OPCODES_XOR";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_RD;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_RS2;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_RFB;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_XOR;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_SRA: begin
        _codeop_ascii_r = "USEQ_OPCODES_SRA";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_RD;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_RS2;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_RFB;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_SRA;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_ADD3: begin
        _codeop_ascii_r = "USEQ_OPCODES_ADD3";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_RS1;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_RS2;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_RFB;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_ADD;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_ADD2: begin
        _codeop_ascii_r = "USEQ_OPCODES_ADD2";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_RD;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_RS1;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_RFB_OR_UK4;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_ADD;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_SRLI: begin
        _codeop_ascii_r = "USEQ_OPCODES_SRLI";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_RD;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_R1;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_UK4;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_SRL;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_SW: begin
        _codeop_ascii_r = "USEQ_OPCODES_SW";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_MEM16;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_RFB;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_RS1;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_RD;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_K4;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_ADD;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_SRL: begin
        _codeop_ascii_r = "USEQ_OPCODES_SRL";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_RD;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_RS2;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_RFB;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_SRL;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_SLL: begin
        _codeop_ascii_r = "USEQ_OPCODES_SLL";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_RD;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_RS2;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_RFB;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_SLL;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_SLLI: begin
        _codeop_ascii_r = "USEQ_OPCODES_SLLI";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_RD;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_R1;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_UK4;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_SLL;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_SB: begin
        _codeop_ascii_r = "USEQ_OPCODES_SB";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_MEM8;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_RFB;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_RS1;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_RD;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_K4;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_ADD;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
    USEQ_OPCODES_OR: begin
        _codeop_ascii_r = "USEQ_OPCODES_OR";
        dec_writeback_dest_mux_sel = USEQ_SEL_DEST_RFC;
        dec_writeback_source_mux_sel = USEQ_SEL_WBSOURCE_ALU;
        dec_rf_sela_mux_sel = USEQ_SEL_RFA_RD;
        dec_rf_selb_mux_sel = USEQ_SEL_RFB_RS2;
        dec_rf_selc_mux_sel = USEQ_SEL_RFC_RD;
        dec_alu_sourceb_mux_sel = USEQ_SEL_ALUB_RFB;
        dec_alu_sourcea_mux_sel = USEQ_SEL_ALUA_RFA;
        dec_alu_op_mux_sel = USEQ_SEL_ALUOP_OR;
        dec_flow_halt_mux_sel = USEQ_FLOW_HALT_NO;
        dec_pc_next_mux_sel = USEQ_SEL_PC_INCREMENT;
    end
   //@end[case_inst]
   endcase
  end

  wire cond_branch;
  assign cond_branch = 1'b1; // Fixme

 always @(posedge pc_r_clk or negedge rst_n) begin
    if(rst_n == 1'b0) begin
      /*AUTORESET*/
      // Beginning of autoreset for uninitialized flops
	  stall_cnt <= {(3){1'b0}};
	  npc <= 0;
      pc_r <= {(1+(USEQ_WORD_MSB)){1'b0}};
	  stalling <= 0;
      // End of automatics
	  //rf_req<=0 ;
    end
    else begin
		if(halt == 1'b1) begin
			pc_r <= pc_r;
		end else begin
			if(stall == 1'b1) begin
				/*if(stall_cnt<stall_target) begin
					stalling <= 1;
					stall_cnt <= stall_cnt+1;
					pc_r <= pc_r;
				end else begin
					stalling <= 0;
					stall_cnt <= 0;
					pc_r <= pc_r + USEQ_PC_INC;
				end*/
				pc_r <= pc_r;
			end else begin
		
				 case(dec_pc_next_mux_sel)
				  USEQ_SEL_PC_INCREMENT: begin
					 pc_r <= pc_r + USEQ_PC_INC;
				  end
				  USEQ_SEL_PC_FROM_ALU: begin
					// pc_r <= dest_bus;
				  end
				  USEQ_SEL_PC_COND_LOAD_FROM_ALU: begin
						if(cond_branch) begin
					  //   pc_r <= dest_bus;
						end
						else begin
						  pc_r <= pc_r + USEQ_PC_INC;
						end
					end

				  default: begin
					pc_r <= pc_r + USEQ_PC_INC;
				  end
				  
				endcase
			end
      //pc_r <= npc;
      halt_r <= halt;      
    
		end
	end // always @ (posedge clk or  rst_n)
end


  assign carry_in = 0; // FIXME
 
  pulse_generator PGRAM (ram_clk,ram_ack);
  always @* begin
	if(rst_n == 1'b0) begin
		ram_req_pre =0;
	end
	else begin
  		ram_req_pre = !alu_ack;
	end  
  end
  
  always @* begin
   if(rst_n == 1'b0) begin
		rf_req = 0;
	end else begin 
		casez(decode_string)
		USEQ_OPCODES_SW: begin
			rf_req = mem_req_delayed;
		end 
		USEQ_OPCODES_SB: begin
			rf_req = mem_req_delayed;
		end 
		USEQ_OPCODES_LB:  begin
			rf_req = mem_req_delayed;
		end 
		USEQ_OPCODES_LW: begin
			rf_req = mem_req_delayed;
		end
		default: begin
		 rf_req = rf_req_pre;
		end
		endcase
		end
 end
   
   
always @* begin
	if(rst_n == 1'b0) begin
		rf_req_pre = 0;
		mem_req = 0;
		mem_clk = 0;
	end
	else begin	
		casez(decode_string)
		USEQ_OPCODES_SW: begin
			mem_req = mem_req_pre;
			if(stall == 0) begin
				mem_clk = mem_clk_pre;
			end else begin
					mem_clk = 1'b0;
				end
		end 
		USEQ_OPCODES_SB: begin
			mem_req = mem_req_pre;
			if(stall == 0) begin
				mem_clk = mem_clk_pre;
			end else begin
					mem_clk = 1'b0;
				end
		end 
		USEQ_OPCODES_LB:  begin
			mem_req = mem_req_pre;
			if(stall == 0) begin
				mem_clk = mem_clk_pre;
			end else begin
					mem_clk = 1'b0;
				end
		end 
		USEQ_OPCODES_LW: begin
			mem_req = mem_req_pre;
			if(stall == 0) begin
				mem_clk = mem_clk_pre;
			end else begin
					mem_clk = 1'b0;
				end
		end
		default: begin
		 mem_req = 0;
		 rf_req_pre = mem_req_pre;
		 mem_clk = 0;
		end
		endcase
	end
end

  
  simd_useq_alu U_ALU (
                       // Outputs
                       .c               (alu_c[USEQ_WORD_MSB:0]),
                       // Inputs
                       .a               (alu_a_s0[USEQ_WORD_MSB:0]),
                       .b               (alu_b_s0[USEQ_WORD_MSB:0]),
                       .op              (dec_alu_op_mux_sel_s0[USEQ_SEL_ALUOP_MSB:0]),
                       .carry_in        (carry_in),
                       .carry_out       (carry_out));
  
   /* simd_useq_rf AUTO_TEMPLATE(
    ); */
  simd_useq_rf U_RF (
                     .rf_a              (rf_a_out[USEQ_WORD_MSB:0]),
                     .rf_b              (rf_b_out[USEQ_WORD_MSB:0]),
                     /*AUTOINST*/
                     // Inputs
                     .rf_sela           (rf_sela[USEQ_RF_SEL_MSB:0]),
                     .rf_selb           (rf_selb[USEQ_RF_SEL_MSB:0]),
                     .rf_selc           (rf_selc_s2[USEQ_RF_SEL_MSB:0]),
                     .rf_c              (rf_c[USEQ_WORD_MSB:0]),
                     .rf_write          (rf_write_s2),
                     .clk               (rf_clk),
                     .rst_n             (rst_n));
  
  

 
endmodule // simd_useq
/*  
 Local Variables:
 verilog-library-directories:(
 "."
 )
 End:
 */
