/******************************************************************************/
/* Verilog models generated by SiliconSmart 2013.06-SP2 (Production) build number: 4464. */
/* Siliconsmart Path: /nfsi/ref/soft/synopsys/siliconsmart/SiliconSmart-2013.06-SP2/linux26_x86_64/bin/siliconsmart */
/*                                                                            */
/* File generated on Fri Jan 17 13:24:39 MET 2014.                            */
/******************************************************************************/


`timescale 1ns/1ps

// udp_data_begin




primitive cmuller2d4s8fhvt_statetable_IQ(IQ, a, b, rstneg, notifier);
output IQ;
reg IQ;
input a, b, rstneg, notifier; 
table 
// a b rstneg notifier : IQ : IQ
  ?  ?  0  ?   : ?   : 0;
  0  0  1  ?   : ?   : 0;
  1  1  1  ?   : ?   : 1;
  1  0  1  ?   : ?   : -;
  0  1  1  ?   : ?   : -;

endtable
endprimitive




`celldefine
module cmuller2d4s8fhvt_func( a, b, rstneg, z, notifier );
input a, b, rstneg, notifier;
output z;

	cmuller2d4s8fhvt_statetable_IQ(IQ, a, b, rstneg, notifier);

	buf MGM_BG_0( z, IQ );

endmodule
`endcelldefine

// udp_data_end



`celldefine
module cmuller2d4s8fhvt( a, b, rstneg, z );
input a, b, rstneg;
output z;
reg notifier;

   `ifdef FUNCTIONAL  //  functional //

	cmuller2d4s8fhvt_func cmuller2d4s8fhvt_behav_inst(.a(a),.b(b),.rstneg(rstneg),.z(z),.notifier(notifier));

   `else
        wire a_delay ;

        wire b_delay ;

        wire rstneg_delay ;


	cmuller2d4s8fhvt_func cmuller2d4s8fhvt_inst(.a(a_delay),.b(b_delay),.rstneg(rstneg_delay),.z(z),.notifier(notifier));


	// spec_gates_begin


	// spec_gates_end



   specify

	// specify_block_begin 

	// comb arc a --> z
	 (a => z) = (1.0,1.0);

	// comb arc b --> z
	 (b => z) = (1.0,1.0);

	// seq arc rstneg --> z
	(rstneg => z)  = (1.0,1.0);

	// setuphold a- b-HL
	$setuphold(negedge b,posedge a,1.0,1.0,notifier,,,b_delay,a_delay);

	// setuphold a- b-LH
	$setuphold(posedge b,negedge a,1.0,1.0,notifier,,,b_delay,a_delay);

	// setuphold a- rstneg-LH
	$setuphold(posedge rstneg,negedge a,1.0,1.0,notifier,,,rstneg_delay,a_delay);

	// setuphold b- rstneg-LH
	$setuphold(posedge rstneg,negedge b,1.0,1.0,notifier,,,rstneg_delay,b_delay);

	// mpw rstneg_hl 
	$width(negedge rstneg,1.0,0,notifier);

	// specify_block_end 

   endspecify

   `endif 

endmodule
`endcelldefine
// udp_data_begin




primitive cmuller3p1n1d4s8fhvt_statetable_IQ(IQ, n, b, p, rstneg, notifier);
output IQ;
reg IQ;
input n, b, p, rstneg, notifier; 
table 
// n b p rstneg notifier : IQ : IQ
  ?  ?  ?  0  ?   : ?   : 0;
  0  0  ?  1  ?   : ?   : 0;
  ?  1  1  1  ?   : ?   : 1;
  1  0  ?  1  ?   : ?   : -;
  ?  1  0  1  ?   : ?   : -;

endtable
endprimitive




`celldefine
module cmuller3p1n1d4s8fhvt_func( b, n, p, rstneg, z, notifier );
input b, n, p, rstneg, notifier;
output z;

	cmuller3p1n1d4s8fhvt_statetable_IQ(IQ, n, b, p, rstneg, notifier);

	buf MGM_BG_0( z, IQ );

endmodule
`endcelldefine

// udp_data_end



`celldefine
module cmuller3p1n1d4s8fhvt( b, n, p, rstneg, z );
input b, n, p, rstneg;
output z;
reg notifier;

   `ifdef FUNCTIONAL  //  functional //

	cmuller3p1n1d4s8fhvt_func cmuller3p1n1d4s8fhvt_behav_inst(.b(b),.n(n),.p(p),.rstneg(rstneg),.z(z),.notifier(notifier));

   `else

        wire p_delay ;

        wire n_delay ;

        wire b_delay ;

        wire rstneg_delay ;


	cmuller3p1n1d4s8fhvt_func cmuller3p1n1d4s8fhvt_inst(.b(b_delay),.n(n_delay),.p(p_delay),.rstneg(rstneg_delay),.z(z),.notifier(notifier));


	// spec_gates_begin
	buf MGM_G0(ENABLE_p,p_delay);

	// spec_gates_end



   specify

	// specify_block_begin 

	// comb arc b --> z
	 (b => z) = (1.0,1.0);

	// comb arc n --> z
	 (negedge n => (z +: 1'b0)) = (1.0,1.0);

	// comb arc p --> z
	 (posedge p => (z +: 1'b0)) = (1.0,1.0);

	// comb arc rstneg --> z
	 (rstneg => z) = (1.0,1.0);

    // setuphold b- n-HL
    $setuphold(negedge n,posedge b,1.0,1.0,notifier,,,n_delay,b_delay);

    // setuphold b- n-LH
    $setuphold(posedge n,negedge b,1.0,1.0,notifier,,,n_delay,b_delay);
    $setuphold(posedge n &&& (ENABLE_p === 1'b1),negedge b &&& (ENABLE_p === 1'b1),1.0,1.0,notifier,,,n_delay,b_delay);

    // setuphold b- p-HL
    $setuphold(negedge p,posedge b,1.0,1.0,notifier,,,p_delay,b_delay);

    // setuphold b- p-LH
    $setuphold(posedge p,negedge b,1.0,1.0,notifier,,,p_delay,b_delay);

    // setuphold rstneg- b-HL
    $setuphold(negedge b,posedge rstneg,1.0,1.0,notifier,,,b_delay,rstneg_delay);

    // setuphold rstneg- p-HL
    $setuphold(negedge p,posedge rstneg,1.0,1.0,notifier,,,p_delay,rstneg_delay);

	// mpw rstneg_hl 
	$width(negedge rstneg,1.0,0,notifier);

	// specify_block_end 

   endspecify

   `endif 

endmodule
`endcelldefine
// udp_data_begin




`celldefine
module mutex2d4s8fhvt_func( g1, g2, r1, r2 );

  parameter DELAY = 1;
  
  input r1;
  input r2;
  output g1;
  output g2;

  reg    g1_i,g2_i;
  
  initial begin
    g1_i <= 0;
    g2_i <= 0;
  end
  
  

  always @* begin
    if(r1 && !g2 && !g2_i) begin
      g1_i <= 1'b1;
      g2_i <= 1'b0;
      
    end
    else begin
      if(r2 && !g1 && !g1_i) begin
      g1_i <= 1'b0;
      g2_i <= 1'b1;      
      end
      else begin
        g1_i <= 1'b0;
        g2_i <= 1'b0;      
      end
    end      
  end
  
  assign #DELAY g1 = g1_i;
  assign #DELAY g2 = g2_i;
  


endmodule
`endcelldefine

// udp_data_end



`celldefine
module mutex2d4s8fhvt( g1, g2, r1, r2 );
input r1, r2;
output g1, g2;

   `ifdef FUNCTIONAL  //  functional //

	mutex2d4s8fhvt_func mutex2d4s8fhvt_behav_inst(.g1(g1),.g2(g2),.r1(r1),.r2(r2));

   `else

	mutex2d4s8fhvt_func mutex2d4s8fhvt_inst(.g1(g1),.g2(g2),.r1(r1),.r2(r2));


	// spec_gates_begin


	// spec_gates_end



   specify

	// specify_block_begin 

	// comb arc r1 --> g1
	 (r1 => g1) = (1.0,1.0);

	// comb arc r2 --> g2
	 (r2 => g2) = (1.0,1.0);

	// specify_block_end 

   endspecify

   `endif 

endmodule
`endcelldefine
