/* Parameter file for SIMD module */

// Should be moved in a feature file ?
parameter USEQ_INST_BITS = 16,
  USEQ_INST_MSB = USEQ_INST_BITS-1;

parameter USEQ_WORD_BITS = 16,
  USEQ_WORD_MSB = USEQ_WORD_BITS-1;

parameter USEQ_HALF_WORD_BITS = USEQ_WORD_BITS/2;

parameter USEQ_ADDR_BITS = USEQ_WORD_BITS;

parameter USEQ_WORD_MINUS_K4 = USEQ_WORD_BITS-4;
parameter USEQ_WORD_MINUS_K8 = USEQ_WORD_BITS-8;
parameter USEQ_WORD_MINUS_K12 = USEQ_WORD_BITS-12;

// default increment for the PC
parameter USEQ_PC_INC = 2;

// Regfile
parameter USEQ_RF_SEL_BITS = 4,
  USEQ_RF_SEL_MSB = USEQ_RF_SEL_BITS-1;



//@begin[inst_format]
parameter USEQ_INST_FORMAT_OPCODE1_SIZE = 4;
parameter USEQ_INST_FORMAT_OPCODE1_MSB = 3;
parameter USEQ_INST_FORMAT_OPCODE1_OFFSET = 12;

parameter USEQ_INST_FORMAT_RD_SIZE = 4;
parameter USEQ_INST_FORMAT_RD_MSB = 3;
parameter USEQ_INST_FORMAT_RD_OFFSET = 8;

parameter USEQ_INST_FORMAT_OPCODE3_SIZE = 4;
parameter USEQ_INST_FORMAT_OPCODE3_MSB = 3;
parameter USEQ_INST_FORMAT_OPCODE3_OFFSET = 4;

parameter USEQ_INST_FORMAT_RS2_SIZE = 4;
parameter USEQ_INST_FORMAT_RS2_MSB = 3;
parameter USEQ_INST_FORMAT_RS2_OFFSET = 0;

parameter USEQ_INST_FORMAT_UK4_SIZE = 4;
parameter USEQ_INST_FORMAT_UK4_MSB = 3;
parameter USEQ_INST_FORMAT_UK4_OFFSET = 0;

parameter USEQ_INST_FORMAT_RS1_SIZE = 4;
parameter USEQ_INST_FORMAT_RS1_MSB = 3;
parameter USEQ_INST_FORMAT_RS1_OFFSET = 4;

parameter USEQ_INST_FORMAT_OPCODE4_SIZE = 4;
parameter USEQ_INST_FORMAT_OPCODE4_MSB = 3;
parameter USEQ_INST_FORMAT_OPCODE4_OFFSET = 0;

parameter USEQ_INST_FORMAT_K8_SIZE = 8;
parameter USEQ_INST_FORMAT_K8_MSB = 7;
parameter USEQ_INST_FORMAT_K8_OFFSET = 0;

parameter USEQ_INST_FORMAT_COND_SIZE = 4;
parameter USEQ_INST_FORMAT_COND_MSB = 3;
parameter USEQ_INST_FORMAT_COND_OFFSET = 8;

parameter USEQ_INST_FORMAT_K12_SIZE = 12;
parameter USEQ_INST_FORMAT_K12_MSB = 11;
parameter USEQ_INST_FORMAT_K12_OFFSET = 0;

parameter USEQ_INST_FORMAT_K4_SIZE = 4;
parameter USEQ_INST_FORMAT_K4_MSB = 3;
parameter USEQ_INST_FORMAT_K4_OFFSET = 0;

//@end[inst_format]



//@begin[param_opcode]
// Opcodes used for decoding : ['opcode1', 'opcode3', 'opcode4', 'cond']

parameter USEQ_OPCODES_AND = 'b01110000????????;
parameter USEQ_OPCODES_XNORR1 = 'b10000011????????;
parameter USEQ_OPCODES_ADD2C = 'b01111000????????;
parameter USEQ_OPCODES_LDIR1 = 'b1111????????????;
parameter USEQ_OPCODES_ORR1 = 'b10000001????????;
parameter USEQ_OPCODES_ANDR1 = 'b10000000????????;
parameter USEQ_OPCODES_XORR1 = 'b10000010????????;
parameter USEQ_OPCODES_LB = 'b0100????????????;
parameter USEQ_OPCODES_SUB2C = 'b01111001????????;
parameter USEQ_OPCODES_RET = 'b1110????0010????;
parameter USEQ_OPCODES_LW = 'b0011????????????;
parameter USEQ_OPCODES_SUB3 = 'b1101????????????;
parameter USEQ_OPCODES_XNOR = 'b01110011????????;
parameter USEQ_OPCODES_BRPC = 'b1001????????????;
parameter USEQ_OPCODES_SUB2 = 'b0010????????????;
parameter USEQ_OPCODES_HALT = 'b1110????0011????;
parameter USEQ_OPCODES_MFSR = 'b1110????0001????;
parameter USEQ_OPCODES_MTSR = 'b1110????0000????;
parameter USEQ_OPCODES_ORI4 = 'b0000????????????;
parameter USEQ_OPCODES_SRAI = 'b10000101????????;
parameter USEQ_OPCODES_SEXT = 'b01110111????????;
parameter USEQ_OPCODES_BR = 'b1010????????????;
parameter USEQ_OPCODES_XOR = 'b01110010????????;
parameter USEQ_OPCODES_SRA = 'b01110100????????;
parameter USEQ_OPCODES_ADD3 = 'b1100????????????;
parameter USEQ_OPCODES_ADD2 = 'b0001????????????;
parameter USEQ_OPCODES_SRLI = 'b10000110????????;
parameter USEQ_OPCODES_SW = 'b0101????????????;
parameter USEQ_OPCODES_SRL = 'b01110101????????;
parameter USEQ_OPCODES_SLL = 'b01110110????????;
parameter USEQ_OPCODES_SLLI = 'b10000111????????;
parameter USEQ_OPCODES_SB = 'b0110????????????;
parameter USEQ_OPCODES_OR = 'b01110001????????;
//@end[param_opcode]

//@begin[rf_sela]
parameter USEQ_SEL_RFA_RD = 0;
parameter USEQ_SEL_RFA_R0 = 1;
parameter USEQ_SEL_RFA_RS1 = 2;
parameter USEQ_SEL_RFA_BITS = 2;
parameter USEQ_SEL_RFA_MSB = 1;
//@end[rf_sela]

//@begin[rf_selb]
parameter USEQ_SEL_RFB_R14 = 0;
parameter USEQ_SEL_RFB_R1 = 1;
parameter USEQ_SEL_RFB_RS2 = 2;
parameter USEQ_SEL_RFB_RS1 = 3;
parameter USEQ_SEL_RFB_BITS = 2;
parameter USEQ_SEL_RFB_MSB = 1;
//@end[rf_selb]

//@begin[rf_selc]
parameter USEQ_SEL_RFC_RD = 0;
parameter USEQ_SEL_RFC_R0 = 1;
parameter USEQ_SEL_RFC_R1 = 2;
parameter USEQ_SEL_RFC_RS2 = 3;
parameter USEQ_SEL_RFC_BITS = 2;
parameter USEQ_SEL_RFC_MSB = 1;
//@end[rf_selc]

//@begin[alu_sourcea]
parameter USEQ_SEL_ALUA_RFA = 0;
parameter USEQ_SEL_ALUA_NPC = 1;
parameter USEQ_SEL_ALUA_BITS = 1;
parameter USEQ_SEL_ALUA_MSB = 0;
//@end[alu_sourcea]

//@begin[alu_sourceb]
parameter USEQ_SEL_ALUB_K12 = 0;
parameter USEQ_SEL_ALUB_RFB_OR_UK4 = 1;
parameter USEQ_SEL_ALUB_SR = 2;
parameter USEQ_SEL_ALUB_UK4 = 3;
parameter USEQ_SEL_ALUB_NOT_RFB = 4;
parameter USEQ_SEL_ALUB_RFB = 5;
parameter USEQ_SEL_ALUB_K4 = 6;
parameter USEQ_SEL_ALUB_K8 = 7;
parameter USEQ_SEL_ALUB_NOT_RFB_OR_UK4 = 8;
parameter USEQ_SEL_ALUB_BITS = 4;
parameter USEQ_SEL_ALUB_MSB = 3;
//@end[alu_sourceb]

//@begin[wb_source]
parameter USEQ_SEL_WBSOURCE_MEM16 = 0;
parameter USEQ_SEL_WBSOURCE_RFB = 1;
parameter USEQ_SEL_WBSOURCE_ALU = 2;
parameter USEQ_SEL_WBSOURCE_MEM8 = 3;
parameter USEQ_SEL_WBSOURCE_BITS = 2;
parameter USEQ_SEL_WBSOURCE_MSB = 1;
//@end[wb_source]

//@begin[wb_dest]
parameter USEQ_SEL_DEST_MEM16 = 0;
parameter USEQ_SEL_DEST_SR = 1;
parameter USEQ_SEL_DEST_COND_LINK_REG = 2;
parameter USEQ_SEL_DEST_RFC = 3;
parameter USEQ_SEL_DEST_PC = 4;
parameter USEQ_SEL_DEST_MEM8 = 5;
parameter USEQ_SEL_DEST_BITS = 3;
parameter USEQ_SEL_DEST_MSB = 2;
//@end[wb_dest]


//@begin[alu_op]
parameter USEQ_SEL_ALUOP_AND = 0;
parameter USEQ_SEL_ALUOP_XNOR = 1;
parameter USEQ_SEL_ALUOP_SRA = 2;
parameter USEQ_SEL_ALUOP_XOR = 3;
parameter USEQ_SEL_ALUOP_SUB = 4;
parameter USEQ_SEL_ALUOP_SRL = 5;
parameter USEQ_SEL_ALUOP_SLL = 6;
parameter USEQ_SEL_ALUOP_ADD = 7;
parameter USEQ_SEL_ALUOP_SEXT = 8;
parameter USEQ_SEL_ALUOP_OR = 9;
parameter USEQ_SEL_ALUOP_BITS = 4;
parameter USEQ_SEL_ALUOP_MSB = 3;
//@end[alu_op]

//@begin[pc_udate]
parameter USEQ_SEL_PC_COND_LOAD_FROM_ALU = 0;
parameter USEQ_SEL_PC_FROM_ALU = 1;
parameter USEQ_SEL_PC_INCREMENT = 2;
parameter USEQ_SEL_PC_BITS = 2;
parameter USEQ_SEL_PC_MSB = 1;
//@end[pc_update]

//@begin[param_cond]
parameter USEQ_COND_GT = 4'd4;
parameter USEQ_COND_GEU = 4'd9;
parameter USEQ_COND_ALAL = 4'd15;
parameter USEQ_COND_AL = 4'd14;
parameter USEQ_COND_GE = 4'd5;
parameter USEQ_COND_LEU = 4'd7;
parameter USEQ_COND_EQ = 4'd0;
parameter USEQ_COND_C = 4'd10;
parameter USEQ_COND_LE = 4'd3;
parameter USEQ_COND_LTU = 4'd6;
parameter USEQ_COND_O = 4'd11;
parameter USEQ_COND_LT = 4'd2;
parameter USEQ_COND_GTU = 4'd8;
parameter USEQ_COND_OU = 4'd0;
parameter USEQ_COND_NEQ = 4'd1;

//@end[param_cond]

//@begin[param_sreg]
parameter USEQ_SR_AR0 = 4'd8;
parameter USEQ_SR_SR = 4'd0;
parameter USEQ_SR_AR2 = 4'd10;
parameter USEQ_SR_AR1 = 4'd9;

//@end[param_sreg]

//@begin[flow]
parameter USEQ_FLOW_HALT_YES = 0;
parameter USEQ_FLOW_HALT_NO = 1;
parameter USEQ_FLOW_HALT_BITS = 1;
parameter USEQ_FLOW_HALT_MSB = 0;
//@end[flow]


