module simd (/*AUTOARG*/
  // Outputs
  pc_r, cpu_ack, ram_clk,
  // Inputs
  rst_n, instruction, cpu_req, clk
  );
  
`include "simd_params.v"
`include "simd_features.v"
  
  
  /*AUTOINPUT*/
  // Beginning of automatic inputs (from unused autoinst inputs)
  input                 clk;                    // To U_USEQ of simd_useq.v
  input [USEQ_INST_MSB:0] instruction;          // To U_USEQ of simd_useq.v
  input                 rst_n;                  // To U_USEQ of simd_useq.v
  // End of automatics
  /*AUTOOUTPUT*/
  // Beginning of automatic outputs (from unused autoinst outputs)
  output [USEQ_WORD_MSB:0] pc_r;                // From U_USEQ of simd_useq.v
  output ram_clk;
  output cpu_ack;
  input  cpu_req;
  // End of automatics
  
  /*AUTOREG*/
  /*AUTOWIRE*/

  
   /* simd_useq AUTO_TEMPLATE(
    ); */
  simd_useq U_USEQ (
                          /*AUTOINST*/
                    // Outputs
                    .pc_r               (pc_r[USEQ_WORD_MSB:0]),
			.cpu_ack	(cpu_ack),
		.ram_clk		(ram_clk),
                    // Inputs
                    .instruction        (instruction[USEQ_INST_MSB:0]),
			.cpu_req	(cpu_req),
                    .clk                (clk),
                    .rst_n              (rst_n));


   /* simd_agen AUTO_TEMPLATE(
    ); */
  simd_agen U_AGEN (
                           /*AUTOINST*/);
  
   /* simd_pe_array AUTO_TEMPLATE(
    ); */
  // simd_pe_array U_PE_ARRAY (
  //                         /*AUTOINST*/);
  
  


endmodule // simd
/*  
 Local Variables:
 verilog-library-directories:(
 "."
 )
 End:
 */
