module prog_mem_wrapper(
	load_program,
	prog_clk,
	prog_adr,
    clk,
    pc_r,
    instruction_in,
    instruction,
	rst_n_in,
	rst_n_out);

input load_program;	
input prog_clk;
input [10:0] prog_adr;
input   clk;
input   [15:0] pc_r;
input   [15:0] instruction_in;
input rst_n_in;
output rst_n_out;
output  [15:0] instruction;


reg rst_n_out;
wire [31:0] instruction_temp;
assign instruction = instruction_temp[15:0];
reg ram_clk;
reg [10:0] adr;
reg [3:0] we;
reg [3:0] re;

always @* begin
	if(load_program ==1) begin
		rst_n_out = 1'b0;
	end else begin
		rst_n_out = rst_n_in;
	end
end	

always @* begin
if(load_program == 1'b1) begin
	adr = prog_adr[10:0];
				we = 4'b0011;
			re = 4'b0000;
	end else begin
				we = 4'b0000;
			re = 4'b0011;
	adr = pc_r[11:1];
end 
end

	always @* begin
		if(load_program == 1'b1) begin
			ram_clk = #10 prog_clk;

		end else begin
			ram_clk = #10 clk;

		end
	end

tpe_ram_1536x8x4hs_at110n_n1 PROGMEM (
	.clk	(ram_clk),
	.me		(1'b1),
	.re		(re[3:0]),
	.we		(we[3:0]),
	.adr	(adr[10:0]),
	.din	( {16'b0, instruction_in}),// | instruction_in[USEQ_INST_MSB:0]),
	.rm		(4'b1111),
	.dout	(instruction_temp[31:0]),
	.pd		(1'b0),
	.pdd	(1'b1));
	
endmodule