`timescale 1ns/1ps


module chip_top (/*AUTOARG*/
  // Outputs
  pc_r, cpu_ack,
  // Inputs	
  sel_mode ,rst_n_temp, instruction, cpu_req, load_program, prog_clk, clk
  );
  
`include "simd_params.v"
  
  input [USEQ_INST_MSB:0] instruction;          // To U_USEQ of simd_useq.v
  input                 rst_n_temp;                  // To U_USEQ of simd_useq.v
  input load_program;
  input prog_clk;
  input clk;
  
  // End of automatics
  /*AUTOOUTPUT*/
  // Beginning of automatic outputs (from unused autoinst outputs)
  output [USEQ_WORD_MSB:0] pc_r;                // From U_USEQ of simd_useq.v
  output cpu_ack;
  input  cpu_req;
  input [3:0] sel_mode;
  // End of automatics
  wire mem_cs,mem_we,mem_clk;
  wire  [USEQ_WORD_MSB:0] mem_addr; 
  wire [USEQ_WORD_MSB:0] mem16_out;
  wire [USEQ_WORD_MSB:0] mem_in;
    wire [USEQ_WORD_MSB:0] mem_out;
	wire [3:0] ramdsel;
	
	wire [3:0] aludsel;
	wire [3:0] rfdsel;		
	wire [3:0] memdsel;	
  /*AUTOREG*/
  /*AUTOWIRE*/
   /* simd_useq AUTO_TEMPLATE(
    ); */
	
  simd_useq U_USEQ (
                          /*AUTOINST*/
                    // Outputs
                    .pc_r               (pc_r[USEQ_WORD_MSB:0]),
					.mem_in				(mem_in[USEQ_WORD_MSB:0]),
					.mem_addr			(mem_addr),
					.mem_cs				(mem_cs),
					.mem_we				(mem_we),
					.mem_clk			(mem_clk),
					.sel_mode			(sel_mode[3:0]),
					.cpu_ack			(cpu_ack),
					.ram_clk			(ram_clk),
						
                    // Inputs
                    .instruction        (instruction[USEQ_INST_MSB:0]),
					.cpu_req			(cpu_req),
                    .rst_n              (rst_n),
					.mem_out			(mem_out[USEQ_WORD_MSB:0]),
										.ramdsel			(ramdsel[3:0]),
					.aludsel			(aludsel[3:0]),
					.rfdsel				(rfdsel[3:0]),
					.memdsel			(memdsel[3:0]));
				   

				   	mem_wrapper U_USEQ_16_RAM (
                   .read_data           (mem_out[USEQ_WORD_MSB:0]),
                   // Inputs
                   .clock               (mem_clk),                   // Templated
                   .addr                (mem_addr[USEQ_WORD_MSB:0]), // Templated
                   .write_data          (mem_in[USEQ_WORD_MSB:0]), // Templated
                   .cs                  (1'b1),                  // Templated
                   .we                  (mem_we));
				   
				
				prog_mem_wrapper PROGMEMWRAP (
					.load_program (load_program),
					.prog_clk (prog_clk),
					.prog_adr (count[10:0]),
					.clk	(clk),
					.pc_r	(pc_r[15:0]),
					.instruction_in	(instruction_in[15:0]),
					.instruction	(instruction[USEQ_INST_MSB:0]),
					.rst_n_in (rst_n_temp),
					.rst_n_out (rst_n));
 /*ram #(.WORD_WIDTH(USEQ_WORD_BITS),
        .ADDR_WIDTH(USEQ_WORD_BITS)) 
  U_USEQ_16_RAM (
                   .read_data           (mem_out[USEQ_WORD_MSB:0]),
                   // Inputs
                   .clock               (mem_clk),                   // Templated
                   .addr                (mem_addr[USEQ_WORD_MSB:0]), // Templated
                   .write_data          (mem_in[USEQ_WORD_MSB:0]), // Templated
                   .cs                  (1'b1),                  // Templated
                   .we                  (mem_we));      
	*/			   
   /* simd_agen AUTO_TEMPLATE(
    ); */
  simd_agen U_AGEN (
                           /*AUTOINST*/);
  
   /* simd_pe_array AUTO_TEMPLATE(
    ); */
  // simd_pe_array U_PE_ARRAY (
  //                         /*AUTOINST*/);
  
  


endmodule // simd
/*  
 Local Variables:
 verilog-library-directories:(
 "."
 )
 End:
 */
