
//****************************************************************************
//                 PROPRIETARY INFORMATION OF ATMEL CORPORATION
//
//                     32-bit AVR UC3 / SAM source code file.
//                       Copyright Atmel Corporation
//
//         The scope of use of the material contained herein is limited
//         strictly to the terms of the LICENSE which grants permission
//         for the use of the material.  Distribution of this material
//            and all copies thereof to any entity other than to the
//           EMPLOYEES of the Licensee, as the term is defined in the
//        LICENSE, is strictly forbidden without a prior written consent
//                            of Atmel Corporation.
//****************************************************************************
//****************************************************************************
//
//  Project number  :  primitives_110n_U1004
//  Module name     :  primitive_clock_gate
//  Description     :  primitive gates for 110n HVT
//
//  URL             :  $URL: http://norsvn01.norway.atmel.com/ic/avr32/ultra/flow/primitives_110n_U1004/version/101/rtl/module/verilog/primitive_clock_gate.v $
//  Author          :  $Author: teleistad $
//  Date            :  $Date: 2013-12-16 16:29:45 +0100 (Mon, 16 Dec 2013) $
//  Revision        :  $Revision: 216416 $
//
//****************************************************************************



`ifndef DEFAULT_LIB
  `define DEFAULT_LIB "S8"
`endif
module primitive_clock_gate #(parameter LIB=`DEFAULT_LIB)
  (
  output z,
  input i, ce, se
  );

// FIXME : timing #0.1 fails simulation in U3005
  wire z0 ;
//`ifdef PRIMITIVE_TIMING
//  assign #0.1 z = z0 ;
//`else
  assign z = z0 ;
//`endif

  if (LIB=="S10X3") begin:U
    gcksd3x3s10 GATE (.Q(z0), .D(ce), .CKB(i), .SE(se));  
  end

  else if (LIB=="S8") begin:U
    gcksd3s8 GATE (.Q(z0), .D(ce), .CKB(i), .SE(se));  
  end

  else if (LIB=="S8FSHVT") begin:U
    gcksd3s8fshvt GATE (.Q(z0), .D(ce), .CKB(i), .SE(se));  
  end

  else if (LIB=="S8FHVT") begin:U
    gcksd3s8fhvt GATE (.Q(z0), .D(ce), .CKB(i), .SE(se));  
  end
  
endmodule //primitive_clock_gate
