
//****************************************************************************
//                 PROPRIETARY INFORMATION OF ATMEL CORPORATION
//
//                     32-bit AVR UC3 / SAM source code file.
//                       Copyright Atmel Corporation
//
//         The scope of use of the material contained herein is limited
//         strictly to the terms of the LICENSE which grants permission
//         for the use of the material.  Distribution of this material
//            and all copies thereof to any entity other than to the
//           EMPLOYEES of the Licensee, as the term is defined in the
//        LICENSE, is strictly forbidden without a prior written consent
//                            of Atmel Corporation.
//****************************************************************************
//****************************************************************************
//
//  Project number  :  primitives_110n_U1004
//  Module name     :  primitive_delay_1ns
//  Description     :  primitive gates for 110n HVT
//
//  URL             :  $URL: http://norsvn01.norway.atmel.com/ic/avr32/ultra/flow/primitives_110n_U1004/version/101/rtl/module/verilog/primitive_delay_1ns.v $
//  Author          :  $Author: teleistad $
//  Date            :  $Date: 2014-01-24 14:48:00 +0100 (Fri, 24 Jan 2014) $
//  Revision        :  $Revision: 223444 $
//
//****************************************************************************




`ifndef DEFAULT_LIB
  `define DEFAULT_LIB "S8"
`endif
module primitive_delay_1ns #(parameter LIB=`DEFAULT_LIB)              
  (
  output z,
  input i
  );
  
  wire z0 ;
`ifdef PRIMITIVE_TIMING
  assign #1.0 z = z0 ;
`else
  assign z = z0 ;
`endif

  if (LIB=="S10X3") begin:U
      // No delay cell (yet) for the 3.3V cell familly
      // We use just a buffer as a placeholder
      bufbd1x3s10 DONTTOUCH( .i(i), .z(z0) );
  end

  else if (LIB=="S8") begin:U
      delad11s8 DONTTOUCH( .I(i), .O(z0) );
  end
  
  else if (LIB=="S8FSHVT") begin:U
      // No delay cell (yet) for FSHVT , use S8
      delad11s8 DONTTOUCH( .I(i), .O(z0) );
  end

  else if (LIB=="S8FHVT") begin:U
      delad11s8fhvt DONTTOUCH( .I(i), .O(z0) );
  end
endmodule // primitive_delay_1ns
