//****************************************************************************/
//                 PROPRIETARY INFORMATION OF ATMEL CORPORATION
//
//                     32-bit AVR UC3 / SAM source code file.
//                       Copyright Atmel Corporation
//
//         The scope of use of the material contained herein is limited
//         strictly to the terms of the LICENSE which grants permission
//         for the use of the material.  Distribution of this material
//            and all copies thereof to any entity other than to the
//           EMPLOYEES of the Licensee, as the term is defined in the
//        LICENSE, is strictly forbidden without a prior written consent
//                            of Atmel Corporation.
//****************************************************************************/
//****************************************************************************/
//
//  Filename        :  primitive_dff_reset_neg.v
//
//  Project number  :
//  Module name     :
//  Description     :  A wrapper for a simple DFF with asynchronous reset (active low)
//
//
//  Author          :  rbarzic@noreod03.corp.atmel.com
//  Date            :  Fri Jan  3 11:42:06 2014
//
//****************************************************************************/


`ifndef DEFAULT_LIB
 `define DEFAULT_LIB "S8FHVT"
`endif
module primitive_dff_reset_neg 
  #(parameter LIB=`DEFAULT_LIB)
  (
                                output q,                                
                                input d,
                                input clk,
                                input rstneg
);


  wire z0 ;
`ifdef PRIMITIVE_TIMING
  assign #0.1 z = z0 ;
`else
  assign z = z0 ;
`endif

  
  if (LIB=="S10X3") begin:U
    dfcrq1x3s10 DFF(.d(d),.cp(clk),.cdn(rstneg),.q(q));    
  end

  else if (LIB=="S8") begin:U
    qdffrbd3s8 DFF(.D(d),.CK(clk),.RB(rstneg),.Q(q));   
  end

  else if (LIB=="S8FSHVT") begin:U
    qdffrbd3s8fshvt DFF(.D(d),.CK(clk),.RB(rstneg),.Q(q));
  end

  else if (LIB=="S8FHVT") begin:U
    qdffrbd3s8fhvt DFF(.D(d),.CK(clk),.RB(rstneg),.Q(q));
  end


endmodule // primitive_dff_reset_neg
/*
 Local Variables:
 verilog-library-directories:(
 "."
 )
 End:
 */
