
//****************************************************************************
//                 PROPRIETARY INFORMATION OF ATMEL CORPORATION
//
//                     32-bit AVR UC3 / SAM source code file.
//                       Copyright Atmel Corporation
//
//         The scope of use of the material contained herein is limited
//         strictly to the terms of the LICENSE which grants permission
//         for the use of the material.  Distribution of this material
//            and all copies thereof to any entity other than to the
//           EMPLOYEES of the Licensee, as the term is defined in the
//        LICENSE, is strictly forbidden without a prior written consent
//                            of Atmel Corporation.
//****************************************************************************
//****************************************************************************
//
//  Project number  :  primitives_110n_U1004
//  Module name     :  primitive_latch_reset_priority
//  Description     :  primitive gates for 110n HVT
//
//  URL             :  $URL: http://norsvn01.norway.atmel.com/ic/avr32/ultra/flow/primitives_110n_U1004/version/101/rtl/module/verilog/primitive_latch_reset_priority.v $
//  Author          :  $Author: teleistad $
//  Date            :  $Date: 2013-12-12 16:19:38 +0100 (Thu, 12 Dec 2013) $
//  Revision        :  $Revision: 215732 $
//
//****************************************************************************

/****************************************************************************/


`ifndef DEFAULT_LIB
  `define DEFAULT_LIB "S8"
`endif
module primitive_latch_reset_priority #(parameter LIB=`DEFAULT_LIB)     
  (
  output z,
  input rst, set
  );
  
  wire z0 ;
`ifdef PRIMITIVE_TIMING
  assign #0.1 z = z0 ;
`else
  assign z = z0 ;
`endif

  if (LIB=="S10X3") begin:U
      rsld1x3s10 LATCH (.R(rst), .S(set), .Q(z0) );
  end

  else if (LIB=="S8") begin:U
      rsld1s8 LATCH (.R(rst), .S(set), .Q(z0) );
  end

  else if (LIB=="S8FSHVT") begin:U
      rsld1s8fshvt LATCH (.R(rst), .S(set), .Q(z0) );
  end

  else if (LIB=="S8FHVT") begin:U
      rsld1s8fhvt LATCH (.R(rst), .S(set), .Q(z0) );
  end

endmodule // primitive_latch_reset_priority
