
//****************************************************************************
//                 PROPRIETARY INFORMATION OF ATMEL CORPORATION
//
//                     32-bit AVR UC3 / SAM source code file.
//                       Copyright Atmel Corporation
//
//         The scope of use of the material contained herein is limited
//         strictly to the terms of the LICENSE which grants permission
//         for the use of the material.  Distribution of this material
//            and all copies thereof to any entity other than to the
//           EMPLOYEES of the Licensee, as the term is defined in the
//        LICENSE, is strictly forbidden without a prior written consent
//                            of Atmel Corporation.
//****************************************************************************
//****************************************************************************
//
//  Project number  :  primitives_110n_U1004
//  Module name     :  primitive_or_gate
//  Description     :  primitive gates for 110n HVT
//
//  URL             :  $URL: http://norsvn01.norway.atmel.com/ic/avr32/ultra/flow/primitives_110n_U1004/version/101/rtl/module/verilog/primitive_or_gate.v $
//  Author          :  $Author: rvegsundvaag $
//  Date            :  $Date: 2014-02-03 18:22:50 +0100 (Mon, 03 Feb 2014) $
//  Revision        :  $Revision: 225860 $
//
//****************************************************************************



`ifndef DEFAULT_LIB
  `define DEFAULT_LIB "S8"
`endif
module primitive_or_gate #(parameter LIB=`DEFAULT_LIB)
  (
  output z,
  input a,b
  );

  wire z0 ;
`ifdef PRIMITIVE_TIMING
  assign #0.1 z = z0 ;
`else
  assign (supply0,supply1) z = z0 ;
`endif

  if (LIB=="S10X3") begin:U
      or02d1x3s10 PGATE (.z(z0), .a1(a), .a2(b));
  end

  else if (LIB=="S8") begin:U
      or2d3s8 PGATE (.O(z0), .I1(a), .I2(b));
  end

  else if (LIB=="S8FSHVT") begin:U
      or2d3s8fshvt PGATE (.O(z0), .I1(a), .I2(b));
  end

  else if (LIB=="S8FHVT") begin:U
      or2d3s8fhvt PGATE (.O(z0), .I1(a), .I2(b));
  end

endmodule // primitive_or_gate
