
//****************************************************************************
//                 PROPRIETARY INFORMATION OF ATMEL CORPORATION
//
//                     32-bit AVR UC3 / SAM source code file.
//                       Copyright Atmel Corporation
//
//         The scope of use of the material contained herein is limited
//         strictly to the terms of the LICENSE which grants permission
//         for the use of the material.  Distribution of this material
//            and all copies thereof to any entity other than to the
//           EMPLOYEES of the Licensee, as the term is defined in the
//        LICENSE, is strictly forbidden without a prior written consent
//                            of Atmel Corporation.
//****************************************************************************
//****************************************************************************
//
//  Project number  :  primitives_110n_U1004
//  Module name     :  primitive_tiehighlow_generator
//  Description     :  primitive gates for 110n HVT
//
//  URL             :  $URL: http://norsvn01.norway.atmel.com/ic/avr32/ultra/flow/primitives_110n_U1004/version/101/rtl/module/verilog/primitive_tiehighlow_generator.v $
//  Author          :  $Author: teleistad $
//  Date            :  $Date: 2013-12-12 16:19:38 +0100 (Thu, 12 Dec 2013) $
//  Revision        :  $Revision: 215732 $
//
//****************************************************************************




`ifndef DEFAULT_LIB
  `define DEFAULT_LIB "S8"
`endif
module primitive_tiehighlow_generator
  (
  out
  );
  
  parameter LIB = `DEFAULT_LIB;
  parameter VALUE = 0;
  parameter WIDTH = 1;

  output [WIDTH-1:0] out;

  genvar               index;

   for(index = 0; index < WIDTH; index = index + 1) begin:a
    if(VALUE[index] == 1'b1)
      begin:U
        if (LIB=="S8")
          tie1m1d1s8 TIE01 (.O(out[index]));
        else if (LIB=="S8FSHVT")
          tie1m1d1s8fshvt TIE01 (.O(out[index]));
        else if (LIB=="S8FHVT")
          tie1m1d1s8fhvt TIE01 (.O(out[index]));
        else if (LIB=="S10X3")
          tie1m1x3s10 TIE01 (.o(out[index]));
      end     
    else
      begin:U
        if (LIB=="S8")
          tie0m1d1s8 TIE01 (.O(out[index]));
        else if (LIB=="S8FSHVT")
          tie0m1d1s8fshvt TIE01 (.O(out[index]));
        else if (LIB=="S8FHVT")
          tie0m1d1s8fhvt TIE01 (.O(out[index]));
       else if (LIB=="S10X3")
          tie0m1x3s10 TIE01 (.o(out[index]));
      end
  end 

endmodule // primitive_tiehighlow_generator
