
//****************************************************************************
//                 PROPRIETARY INFORMATION OF ATMEL CORPORATION
//
//                     32-bit AVR UC3 / SAM source code file.
//                       Copyright Atmel Corporation
//
//         The scope of use of the material contained herein is limited
//         strictly to the terms of the LICENSE which grants permission
//         for the use of the material.  Distribution of this material
//            and all copies thereof to any entity other than to the
//           EMPLOYEES of the Licensee, as the term is defined in the
//        LICENSE, is strictly forbidden without a prior written consent
//                            of Atmel Corporation.
//****************************************************************************
//****************************************************************************
//
//  Project number  :  primitives_110n_U1004
//  Module name     :  tielow
//  Description     :  primitive gates for 110n HVT
//
//  URL             :  $URL: http://norsvn01.norway.atmel.com/ic/avr32/ultra/flow/primitives_110n_U1004/version/101/rtl/module/verilog/primitive_tielow.v $
//  Author          :  $Author: teleistad $
//  Date            :  $Date: 2013-12-12 16:19:38 +0100 (Thu, 12 Dec 2013) $
//  Revision        :  $Revision: 215732 $
//
//****************************************************************************


module tielow #(parameter LIB=`DEFAULT_LIB)
  (
  output zn
  );

  if (LIB=="S10X3") begin:U
      tie0x3s10 TIE0 (.o(zn));
  end

  else if (LIB=="S8") begin:U	
      tie0d1s8 TIE0 (.O(zn));
  end
  
  else if (LIB=="S8FSHVT") begin:U	
      tie0d1s8fshvt TIE0 (.O(zn));
  end
  
  else if (LIB=="S8FHVT") begin:U	
      tie0d1s8fhvt TIE0 (.O(zn));
  end
  
endmodule // tielow
