
#System clk period
set clk_period 20

#Create system clk
create_clock -name clk -period $clk_period [get_ports clk]
#create_clock -name clk -period $clk_period [get_ports clk_apb_sysctrl]
#create_clock -name clk -period $clk_period [get_ports clk_test]
#create_clock -name clk -period $clk_period [get_ports osc_raw]

#Scan-Aware integrated clock gating cell 
set clkgt_cell_dft gcksd3s8fhvt

#Set driving cell for the clocks, this helps CTS build a reasonable tree
set_driving_cell -lib_cell bufckd7s8fhvt [get_ports clk]
#set_driving_cell -lib_cell bufckd7s8fhvt [get_ports clk_apb_sysctrl]
#set_driving_cell -lib_cell bufckd7s8fhvt [get_ports  clk_test]
#set_driving_cell -lib_cell bufckd7s8fhvt [get_ports  osc_raw]

if {$synopsys_program_name == "dc_shell"}  {

set_dont_touch ram_ack_muxed
set_dont_touch ram_ack_muxed

set_dont_touch ram_ack_muxed
set_dont_touch ram_req_stalled

set_dont_touch stall
set_dont_touch ram_clk
set_dont_touch ram_clk
set_dont_touch mem_clk
set_dont_touch clk
set_dont_touch clk
set_dont_touch mem_clk
set_dont_touch mem_clk_pre
set_dont_touch rf_clk
set_dont_touch pc_r_clk
set_dont_touch alu_req
set_dont_touch ram_req
set_dont_touch rf_done
set_dont_touch alu_ack
set_dont_touch mem_req_pre
set_dont_touch rf_req
set_dont_touch mem_req
set_dont_touch mem_clk_async
set_dont_touch dec_clk_async
set_dont_touch rf_clk_async
set_dont_touch ram_clk_async
set_dont_touch mem_req_delayed
set_dont_touch rf_req_pre
set_dont_touch PGRAMACK/out
set_dont_touch PGRAMDONE/out
set_dont_touch PGALUDONE/out
set_dont_touch PGRAM/out
set_dont_touch PGMEM/out
set_dont_touch PGRF/out
set_dont_touch PGPCR/out
set_dont_touch PGRAMACK
set_dont_touch PGRAMDONE
set_dont_touch PGALUDONE
set_dont_touch PGDEC/out
set_dont_touch U_RF/clk
set_dont_touch ALUD/DELMOD/in_temp
set_dont_touch ALUD/DELMOD/out
set_dont_touch RAMD/DELMOD/in_temp
set_dont_touch RAMD/DELMOD/out
set_dont_touch MEMD/DELMOD/in_temp
set_dont_touch MEMD/DELMOD/out
set_dont_touch RFD/DELMOD/in_temp
set_dont_touch RFD/DELMOD/out

set_dont_touch halt
set_dont_touch DECS/out
set_dont_touch SBALUAS0/out
set_dont_touch SBALUBS0/out
set_dont_touch SBOPMUXS0/out
set_dont_touch SBSELCS0/out
set_dont_touch SBRFWRS0/out
set_dont_touch SBWBMUXS0/out
set_dont_touch SBRFBS0/out
set_dont_touch SBPCMUXS0/out
set_dont_touch SBDECSTRS0/out
set_dont_touch SBWBDESTMUXS0/out
set_dont_touch SBDECRDS0/out

set_dont_touch SBSELCS2/out
set_dont_touch SBWBMUXS2/out
set_dont_touch SBRFWRS2/out
set_dont_touch SBALUCS2/out
set_dont_touch SBMEM8OS2/out
set_dont_touch SBMEM16OS2/out
set_dont_touch SBWBDESTMUXS2/out
set_dont_touch SBRFBS2/out
set_dont_touch SBDECRDS2/out
}


if {$synopsys_program_name == "pt_shell"}  {
#Disable timing on SE
set_case_analysis 0 [get_ports {SCAN_ENABLE test_se SI}]
set_case_analysis 0 [get_ports {ramdsel aludsel rfdsel memdsel}]
set_case_analysis 1 [get_ports {sel_mode[0] sel_mode[1] sel_mode[2] sel_mode[3]}]
set_case_analysis 1 [get_ports {rst_n}]
#set_case_analysis 1 [get_nets {ram_req}]

set_disable_timing {RAMD ALUD MEMD RFD}
#group_path -name INOUT -from [get_nets {pc_r[1]}] -to [get_nets {pc_r[1]}]

}

