`timescale 1ns/1ps
//`include "simd_params.v"

module chip_top (/*AUTOARG*/
  // Outputs
  cpu_ack,
  // Inputs	
  sel_mode ,rst_n_temp, cpu_req, load_program, prog_clk, clk,ramdsel,aludsel,rfdsel,memdsel,instruction_in,prog_adr,pc_r
  );
  
  input rst_n_temp;                  // To U_USEQ of simd_useq.v
  input load_program;
  input prog_clk;
  input clk;
  input [3:0] ramdsel;
  input [3:0] aludsel;
  input [3:0] rfdsel;		
	input [3:0] memdsel;
  
  // End of automatics
  /*AUTOOUTPUT*/
  // Beginning of automatic outputs (from unused autoinst outputs)
  output [15:0] pc_r;                // From U_USEQ of simd_useq.v
  output cpu_ack;
  input  cpu_req;
  input [3:0] sel_mode;
  // End of automatics
  wire mem_cs,mem_we;
  wire  [15:0] mem_addr; 
  wire [15:0] mem16_out;
  wire [15:0] mem_in;
    wire [15:0] mem_out;	
	input [10:0]prog_adr;
	wire [15:0] instruction;
	input [15:0] instruction_in;
	wire rst_n;
	wire ram_clk;
  /*AUTOREG*/
  /*AUTOWIRE*/
   /* simd_useq AUTO_TEMPLATE(
    ); */
	
  simd_useq UUSEQ (
                          /*AUTOINST*/
                    // Outputs
                    .pc_r               (pc_r[15:0]),
					.mem_in				(mem_in[15:0]),
					.mem_addr			(mem_addr[15:0]),
					.mem_cs				(mem_cs),
					.mem_we				(mem_we),
						
                    // Inputs
                    .instruction        (instruction[15:0]),
					.clk				(clk),
                    .rst_n              (rst_n),
					.mem_out			(mem_out[15:0]));
		   
`ifdef negativeedge

				   	mem_wrapper U_USEQ_16_RAM (
                   .read_data           (mem_out[15:0]),
                   // Inputs
                   .clk               (!clk),                   // Templated
                   .addr                (mem_addr[15:0]), // Templated
                   .write_data          (mem_in[15:0]), // Templated
                   .cs                  (1'b1),                  // Templated
                   .we                  (mem_we));
`else
					mem_wrapper U_USEQ_16_RAM (
                   .read_data           (mem_out[15:0]),
                   // Inputs
                   .clk               (clk),                   // Templated
                   .addr                (mem_addr[15:0]), // Templated
                   .write_data          (mem_in[15:0]), // Templated
                   .cs                  (1'b1),                  // Templated
                   .we                  (mem_we));

`endif
				
				prog_mem_wrapper PROGMEMWRAP (
					.load_program (load_program),
					.prog_clk (prog_clk),
					.prog_adr (prog_adr),
					.clk	(clk),
					.pc_r	(pc_r[15:0]),
					.instruction_in	(instruction_in[15:0]),
					.instruction	(instruction[15:0]),
					.rst_n_in (rst_n_temp),
					.rst_n_out (rst_n));

endmodule // simd
=======
`timescale 1ns/1ps
//`include "simd_params.v"

module chip_top (/*AUTOARG*/
  // Outputs
  cpu_ack,
  // Inputs	
  sel_mode ,rst_n_temp, cpu_req, load_program, prog_clk, clk,ramdsel,aludsel,rfdsel,memdsel
  );
  
  input rst_n_temp;                  // To U_USEQ of simd_useq.v
  input load_program;
  input prog_clk;
  input clk;
  input [3:0] ramdsel;
  input [3:0] aludsel;
  input [3:0] rfdsel;		
	input [3:0] memdsel;
  
  // End of automatics
  /*AUTOOUTPUT*/
  // Beginning of automatic outputs (from unused autoinst outputs)
  wire [15:0] pc_r;                // From U_USEQ of simd_useq.v
  output cpu_ack;
  input  cpu_req;
  input [3:0] sel_mode;
  // End of automatics
  wire mem_cs,mem_we,mem_clk;
  wire  [15:0] mem_addr; 
  wire [15:0] mem16_out;
  wire [15:0] mem_in;
    wire [15:0] mem_out;	
	wire [10:0]count;
	wire [15:0] instruction;
	wire [15:0] instruction_in;
	wire rst_n;
	wire ram_clk;
  /*AUTOREG*/
  /*AUTOWIRE*/
   /* simd_useq AUTO_TEMPLATE(
    ); */
	
  simd_useq UUSEQ (
                          /*AUTOINST*/
                    // Outputs
                    .pc_r               (pc_r[15:0]),
					.mem_in				(mem_in[15:0]),
					.mem_addr			(mem_addr),
					.mem_cs				(mem_cs),
					.mem_we				(mem_we),
					.mem_clk			(mem_clk),
					.sel_mode			(sel_mode[3:0]),
					.cpu_ack			(cpu_ack),
					.ram_clk			(ram_clk),
						
                    // Inputs
                    .instruction        (instruction[15:0]),
					.cpu_req			(cpu_req),
                    .rst_n              (rst_n),
					.mem_out			(mem_out[15:0]),
					.clk				(clk),
					.ramdsel			(ramdsel[3:0]),
					.aludsel			(aludsel[3:0]),
					.rfdsel				(rfdsel[3:0]),
					.memdsel			(memdsel[3:0]));
				   

				   	mem_wrapper U_USEQ_16_RAM (
                   .read_data           (mem_out[15:0]),
                   // Inputs
                   .clock               (mem_clk),                   // Templated
                   .addr                (mem_addr[15:0]), // Templated
                   .write_data          (mem_in[15:0]), // Templated
                   .cs                  (1'b1),                  // Templated
                   .we                  (mem_we));
				   
				
				prog_mem_wrapper PROGMEMWRAP (
					.load_program (load_program),
					.prog_clk (prog_clk),
					.prog_adr (count[10:0]),
					.clk	(ram_clk),
					.pc_r	(pc_r[15:0]),
					.instruction_in	(instruction_in[15:0]),
					.instruction	(instruction[15:0]),
					.rst_n_in (rst_n_temp),
					.rst_n_out (rst_n));
 

endmodule // simd
