module simd (/*AUTOARG*/
  // Outputs
  pc_r,
  // Inputs
  rst_n, instruction, clk
  );
  
`include "simd_params.v"
//`include "simd_features.v"
  
  
  /*AUTOINPUT*/
  // Beginning of automatic inputs (from unused autoinst inputs)
  input                 clk;                    // To U_USEQ of simd_useq.v
  input [USEQ_INST_MSB:0] instruction;          // To U_USEQ of simd_useq.v
  input                 rst_n;                  // To U_USEQ of simd_useq.v
  // End of automatics
  /*AUTOOUTPUT*/
  // Beginning of automatic outputs (from unused autoinst outputs)
  output [USEQ_WORD_MSB:0] pc_r;                // From U_USEQ of simd_useq.v
  // End of automatics
  wire mem_cs,mem_we,mem_clk;
  wire  [USEQ_WORD_MSB:0] mem_addr; 
  wire [USEQ_WORD_MSB:0] mem16_out;
  wire [USEQ_WORD_MSB:0] mem_in;
    wire [USEQ_WORD_MSB:0] mem_out;
  /*AUTOREG*/
  /*AUTOWIRE*/
   /* simd_useq AUTO_TEMPLATE(
    ); */

`ifdef NTL
	wire SI, SCAN_ENABLE,test_se, SO;
	assign SI = 0;
	assign SCAN_ENABLE=0;
	assign test_se=0;
  simd_useq U_USEQ (
                          /*AUTOINST*/
                    // Outputs
                    .pc_r               (pc_r[USEQ_WORD_MSB:0]),
					.mem_in				(mem_in[USEQ_WORD_MSB:0]),
					.mem_addr			(mem_addr),
					.mem_cs				(mem_cs),
					.mem_we				(mem_we),
					.mem_clk			(mem_clk),
                    // Inputs
                    .instruction        (instruction[USEQ_INST_MSB:0]),
                    .clk                (clk),
                    .rst_n              (rst_n),
					.mem_out			(mem_out[USEQ_WORD_MSB:0]),
					.SI					(SI),
					.SCAN_ENABLE		(SCAN_ENABLE),
					.test_se				(test_se),
					.SO					(SO));
`else
simd_useq U_USEQ (
                          /*AUTOINST*/
                    // Outputs
                    .pc_r               (pc_r[USEQ_WORD_MSB:0]),
					.mem_in				(mem_in[USEQ_WORD_MSB:0]),
					.mem_addr			(mem_addr),
					.mem_cs				(mem_cs),
					.mem_we				(mem_we),
					.mem_clk			(mem_clk),
                    // Inputs
                    .instruction        (instruction[USEQ_INST_MSB:0]),
                    .clk                (clk),
                    .rst_n              (rst_n),
					.mem_out			(mem_out[USEQ_WORD_MSB:0]));
`endif
mem_wrapper U_USEQ_16_RAM (
                   .read_data           (mem_out[USEQ_WORD_MSB:0]),
                   // Inputs
                   .clock               (mem_clk),                   // Templated
                   .addr                (mem_addr[USEQ_WORD_MSB:0]), // Templated
                   .write_data          (mem_in[USEQ_WORD_MSB:0]), // Templated
                   .cs                  (1'b1),                  // Templated
                   .we                  (mem_we));
/*				   
 ram #(.WORD_WIDTH(USEQ_WORD_BITS),
        .ADDR_WIDTH(USEQ_WORD_BITS)) 
  U_USEQ_16_RAM (
                   .read_data           (mem_out[USEQ_WORD_MSB:0]),
                   // Inputs
                   .clock               (mem_clk),                   // Templated
                   .addr                (mem_addr[USEQ_WORD_MSB:0]), // Templated
                   .write_data          (mem_in[USEQ_WORD_MSB:0]), // Templated
                   .cs                  (1'b1),                  // Templated
                   .we                  (mem_we));      
			   
	*/			   
   /* simd_agen AUTO_TEMPLATE(
    ); */
  simd_agen U_AGEN (
                           /*AUTOINST*/);
  
   /* simd_pe_array AUTO_TEMPLATE(
    ); */
  // simd_pe_array U_PE_ARRAY (
  //                         /*AUTOINST*/);
  
  


endmodule // simd
/*  
 Local Variables:
 verilog-library-directories:(
 "."
 )
 End:
 */
