
module SNPS_CLOCK_GATE_HIGH_osc32k_apb_3 ( CLK, EN, ENCLK, TE );
  input CLK, EN, TE;
  output ENCLK;


  gcksd3s8 latch ( .CKB(CLK), .D(EN), .SE(TE), .Q(ENCLK) );
endmodule


module SNPS_CLOCK_GATE_HIGH_osc32k_apb_2 ( CLK, EN, ENCLK, TE );
  input CLK, EN, TE;
  output ENCLK;


  gcksd3s8 latch ( .CKB(CLK), .D(EN), .SE(TE), .Q(ENCLK) );
endmodule


module SNPS_CLOCK_GATE_HIGH_osc32k_apb_1 ( CLK, EN, ENCLK, TE );
  input CLK, EN, TE;
  output ENCLK;


  gcksd3s8 latch ( .CKB(CLK), .D(EN), .SE(TE), .Q(ENCLK) );
endmodule


module osc32k_apb ( osc32ctrlb_calib_r, osc32ctrla_startup_r, 
        osc32ctrla_en1k_r, osc32ctrla_en32k_r, osc32ctrla_enable_r, 
        clk_apb_sysctrl, rst_apb_n, sysctrl_write, sysctrl_slotsel, 
        sysctrl_pstrb, sysctrl_wdata_22_, sysctrl_wdata_21_, sysctrl_wdata_20_, 
        sysctrl_wdata_19_, sysctrl_wdata_18_, sysctrl_wdata_17_, 
        sysctrl_wdata_16_, sysctrl_wdata_10_, sysctrl_wdata_9_, 
        sysctrl_wdata_8_, sysctrl_wdata_3_, sysctrl_wdata_2_, sysctrl_wdata_1_, 
        sysctrl_rdata_31_, sysctrl_rdata_30_, sysctrl_rdata_29_, 
        sysctrl_rdata_28_, sysctrl_rdata_27_, sysctrl_rdata_26_, 
        sysctrl_rdata_25_, sysctrl_rdata_24_, sysctrl_rdata_23_, 
        sysctrl_rdata_22__BAR, sysctrl_rdata_15_, sysctrl_rdata_14_, 
        sysctrl_rdata_13_, sysctrl_rdata_12_, sysctrl_rdata_11_, 
        sysctrl_rdata_7_, sysctrl_rdata_6_, sysctrl_rdata_5_, sysctrl_rdata_4_, 
        sysctrl_rdata_0_, sysctrl_rdata_21__BAR, sysctrl_rdata_20__BAR, 
        sysctrl_rdata_19__BAR, sysctrl_rdata_18__BAR, sysctrl_rdata_17__BAR, 
        sysctrl_rdata_16__BAR, sysctrl_rdata_10__BAR, sysctrl_rdata_9__BAR, 
        sysctrl_rdata_8__BAR, sysctrl_rdata_3__BAR, sysctrl_rdata_2__BAR, 
        sysctrl_rdata_1__BAR, test_si, test_so, test_se, test_sea );
  output [6:0] osc32ctrlb_calib_r;
  output [2:0] osc32ctrla_startup_r;
  input [0:0] sysctrl_slotsel;
  input [3:0] sysctrl_pstrb;
  input clk_apb_sysctrl, rst_apb_n, sysctrl_write, sysctrl_wdata_22_,
         sysctrl_wdata_21_, sysctrl_wdata_20_, sysctrl_wdata_19_,
         sysctrl_wdata_18_, sysctrl_wdata_17_, sysctrl_wdata_16_,
         sysctrl_wdata_10_, sysctrl_wdata_9_, sysctrl_wdata_8_,
         sysctrl_wdata_3_, sysctrl_wdata_2_, sysctrl_wdata_1_, test_si,
         test_se, test_sea;
  output osc32ctrla_en1k_r, osc32ctrla_en32k_r, osc32ctrla_enable_r,
         sysctrl_rdata_31_, sysctrl_rdata_30_, sysctrl_rdata_29_,
         sysctrl_rdata_28_, sysctrl_rdata_27_, sysctrl_rdata_26_,
         sysctrl_rdata_25_, sysctrl_rdata_24_, sysctrl_rdata_23_,
         sysctrl_rdata_22__BAR, sysctrl_rdata_15_, sysctrl_rdata_14_,
         sysctrl_rdata_13_, sysctrl_rdata_12_, sysctrl_rdata_11_,
         sysctrl_rdata_7_, sysctrl_rdata_6_, sysctrl_rdata_5_,
         sysctrl_rdata_4_, sysctrl_rdata_0_, sysctrl_rdata_21__BAR,
         sysctrl_rdata_20__BAR, sysctrl_rdata_19__BAR, sysctrl_rdata_18__BAR,
         sysctrl_rdata_17__BAR, sysctrl_rdata_16__BAR, sysctrl_rdata_10__BAR,
         sysctrl_rdata_9__BAR, sysctrl_rdata_8__BAR, sysctrl_rdata_3__BAR,
         sysctrl_rdata_2__BAR, sysctrl_rdata_1__BAR, test_so;
  wire   N4, N5, N6, net169, net174, net179, n7, n9, n11, n13, n15, n17;

  dfzrbd3s8 slot_osc32k_ctrla_ctrlb_r_reg_ctrlb_calib__5_ ( .D(n17), .TD(
        sysctrl_rdata_20__BAR), .SEL(test_sea), .CK(net169), .RB(rst_apb_n), 
        .Q(sysctrl_rdata_21__BAR), .QB(osc32ctrlb_calib_r[5]) );
  dfzrbd3s8 slot_osc32k_ctrla_ctrlb_r_reg_ctrlb_calib__4_ ( .D(n15), .TD(
        sysctrl_rdata_19__BAR), .SEL(test_sea), .CK(net169), .RB(rst_apb_n), 
        .Q(sysctrl_rdata_20__BAR), .QB(osc32ctrlb_calib_r[4]) );
  dfzrbd3s8 slot_osc32k_ctrla_ctrlb_r_reg_ctrlb_calib__3_ ( .D(n13), .TD(
        sysctrl_rdata_18__BAR), .SEL(test_sea), .CK(net169), .RB(rst_apb_n), 
        .Q(sysctrl_rdata_19__BAR), .QB(osc32ctrlb_calib_r[3]) );
  dfzrbd3s8 slot_osc32k_ctrla_ctrlb_r_reg_ctrlb_calib__2_ ( .D(n11), .TD(
        sysctrl_rdata_17__BAR), .SEL(test_sea), .CK(net169), .RB(rst_apb_n), 
        .Q(sysctrl_rdata_18__BAR), .QB(osc32ctrlb_calib_r[2]) );
  dfzrbd3s8 slot_osc32k_ctrla_ctrlb_r_reg_ctrlb_calib__1_ ( .D(n9), .TD(
        sysctrl_rdata_16__BAR), .SEL(test_sea), .CK(net169), .RB(rst_apb_n), 
        .Q(sysctrl_rdata_17__BAR), .QB(osc32ctrlb_calib_r[1]) );
  dfzrbd3s8 slot_osc32k_ctrla_ctrlb_r_reg_ctrlb_calib__0_ ( .D(n7), .TD(
        osc32ctrla_startup_r[2]), .SEL(test_sea), .CK(net169), .RB(rst_apb_n), 
        .Q(sysctrl_rdata_16__BAR), .QB(osc32ctrlb_calib_r[0]) );
  dfzrbd3s8 slot_osc32k_ctrla_ctrlb_r_reg_ctrlb_calib__6_ ( .D(
        sysctrl_wdata_22_), .TD(sysctrl_rdata_21__BAR), .SEL(test_sea), .CK(
        net169), .RB(rst_apb_n), .Q(osc32ctrlb_calib_r[6]), .QB(
        sysctrl_rdata_22__BAR) );
  dfzrbd3s8 slot_osc32k_ctrla_ctrlb_r_reg_ctrla_enable_ ( .D(sysctrl_wdata_1_), 
        .TD(osc32ctrla_en32k_r), .SEL(test_sea), .CK(net179), .RB(rst_apb_n), 
        .Q(osc32ctrla_enable_r), .QB(sysctrl_rdata_1__BAR) );
  dfzrbd3s8 slot_osc32k_ctrla_ctrlb_r_reg_ctrla_startup__2_ ( .D(
        sysctrl_wdata_10_), .TD(osc32ctrla_startup_r[1]), .SEL(test_sea), .CK(
        net174), .RB(rst_apb_n), .Q(osc32ctrla_startup_r[2]), .QB(
        sysctrl_rdata_10__BAR) );
  dfzrbd3s8 slot_osc32k_ctrla_ctrlb_r_reg_ctrla_en1k_ ( .D(sysctrl_wdata_3_), 
        .TD(test_si), .SEL(test_sea), .CK(net179), .RB(rst_apb_n), .Q(
        osc32ctrla_en1k_r), .QB(sysctrl_rdata_3__BAR) );
  dfzrbd3s8 slot_osc32k_ctrla_ctrlb_r_reg_ctrla_en32k_ ( .D(sysctrl_wdata_2_), 
        .TD(osc32ctrla_en1k_r), .SEL(test_sea), .CK(net179), .RB(rst_apb_n), 
        .Q(osc32ctrla_en32k_r), .QB(sysctrl_rdata_2__BAR) );
  dfzrbd3s8 slot_osc32k_ctrla_ctrlb_r_reg_ctrla_startup__1_ ( .D(
        sysctrl_wdata_9_), .TD(osc32ctrla_startup_r[0]), .SEL(test_sea), .CK(
        net174), .RB(rst_apb_n), .Q(osc32ctrla_startup_r[1]), .QB(
        sysctrl_rdata_9__BAR) );
  dfzrbd3s8 slot_osc32k_ctrla_ctrlb_r_reg_ctrla_startup__0_ ( .D(
        sysctrl_wdata_8_), .TD(osc32ctrla_enable_r), .SEL(test_sea), .CK(
        net174), .RB(rst_apb_n), .Q(osc32ctrla_startup_r[0]), .QB(
        sysctrl_rdata_8__BAR) );
  invd4s8 U2 ( .I(sysctrl_wdata_20_), .O(n15) );
  invd4s8 U3 ( .I(sysctrl_wdata_18_), .O(n11) );
  invd4s8 U4 ( .I(sysctrl_wdata_21_), .O(n17) );
  invd4s8 U5 ( .I(sysctrl_wdata_19_), .O(n13) );
  invd4s8 U6 ( .I(sysctrl_wdata_17_), .O(n9) );
  invd4s8 U7 ( .I(sysctrl_wdata_16_), .O(n7) );
  an3d3s8 U8 ( .I1(sysctrl_slotsel[0]), .I2(sysctrl_write), .I3(
        sysctrl_pstrb[0]), .O(N4) );
  an3d3s8 U9 ( .I1(sysctrl_slotsel[0]), .I2(sysctrl_write), .I3(
        sysctrl_pstrb[1]), .O(N5) );
  an3d3s8 U10 ( .I1(sysctrl_slotsel[0]), .I2(sysctrl_write), .I3(
        sysctrl_pstrb[2]), .O(N6) );
  qdbahd5s8 LOCKUP ( .D(osc32ctrlb_calib_r[6]), .GB(net169), .Q(test_so) );
  SNPS_CLOCK_GATE_HIGH_osc32k_apb_3 clk_gate_slot_osc32k_ctrla_ctrlb_r_reg_ctrlb_reserved3__0 ( 
        .CLK(clk_apb_sysctrl), .EN(N6), .ENCLK(net169), .TE(test_se) );
  SNPS_CLOCK_GATE_HIGH_osc32k_apb_2 clk_gate_slot_osc32k_ctrla_ctrlb_r_reg_ctrla_reserved2_ ( 
        .CLK(clk_apb_sysctrl), .EN(N5), .ENCLK(net174), .TE(test_se) );
  SNPS_CLOCK_GATE_HIGH_osc32k_apb_1 clk_gate_slot_osc32k_ctrla_ctrlb_r_reg_ctrla_reserved1_ ( 
        .CLK(clk_apb_sysctrl), .EN(N4), .ENCLK(net179), .TE(test_se) );
endmodule


module primitive_clock_mux_1 ( z, i0, i1, s );
  input i0, i1, s;
  output z;


  mux2d3s8 U1 ( .A(i0), .B(i1), .S(s), .O(z) );
endmodule


module primitive_clock_start_1 ( z, i );
  input i;
  output z;
  wire   n1;

  invd4s8 U1 ( .I(n1), .O(z) );
  invd4s8 U2 ( .I(i), .O(n1) );
endmodule


module cm_reset_testbuf_v100_1 ( rst_out, rst_in, rst_test, test_enable );
  input rst_in, rst_test, test_enable;
  output rst_out;
  wire   rst_prebuf;

  primitive_clock_mux_1 U_PCM ( .z(rst_prebuf), .i0(rst_in), .i1(rst_test), 
        .s(test_enable) );
  primitive_clock_start_1 U_PCS ( .z(rst_out), .i(rst_prebuf) );
endmodule


module primitive_clock_mux_0 ( z, i0, i1, s );
  input i0, i1, s;
  output z;


  mux2d3s8 U1 ( .A(i0), .B(i1), .S(s), .O(z) );
endmodule


module primitive_clock_start_0 ( z, i );
  input i;
  output z;
  wire   n1;

  invd4s8 U1 ( .I(n1), .O(z) );
  invd4s8 U2 ( .I(i), .O(n1) );
endmodule


module cm_reset_testbuf_v100_0 ( rst_out, rst_in, rst_test, test_enable );
  input rst_in, rst_test, test_enable;
  output rst_out;
  wire   rst_prebuf;

  primitive_clock_mux_0 U_PCM ( .z(rst_prebuf), .i0(rst_in), .i1(rst_test), 
        .s(test_enable) );
  primitive_clock_start_0 U_PCS ( .z(rst_out), .i(rst_prebuf) );
endmodule


module cm_reset_maker_v100 ( rst_n, clk, rst_n_a, rst_test_n, test_enable, 
        test_si2, test_si1, test_so2, test_so1, test_se );
  input clk, rst_n_a, rst_test_n, test_enable, test_si2, test_si1, test_se;
  output rst_n, test_so2, test_so1;
  wire   rst_maker_n, n3;

  dfzrbd3s8 rst_n_r_reg ( .D(test_so2), .TD(test_si1), .SEL(test_se), .CK(n3), 
        .RB(rst_maker_n), .Q(test_so1) );
  dfzrbd3s8 rst_n_m_reg ( .D(1'b1), .TD(test_si2), .SEL(test_se), .CK(clk), 
        .RB(rst_maker_n), .Q(test_so2) );
  invd4s8 U5 ( .I(clk), .O(n3) );
  cm_reset_testbuf_v100_1 U_RTB_MAKER ( .rst_out(rst_maker_n), .rst_in(rst_n_a), .rst_test(rst_test_n), .test_enable(test_enable) );
  cm_reset_testbuf_v100_0 U_RTB ( .rst_out(rst_n), .rst_in(test_so1), 
        .rst_test(rst_test_n), .test_enable(test_enable) );
endmodule


module SNPS_CLOCK_GATE_HIGH_cm_clock_startup_counter_v100_8_3_3_8_fac688 ( CLK, 
        EN, ENCLK, TE );
  input CLK, EN, TE;
  output ENCLK;


  gcksd3s8 latch ( .CKB(CLK), .D(EN), .SE(TE), .Q(ENCLK) );
endmodule


module cm_clock_startup_counter_v100_8_3_3_8_fac688 ( stable, clk_slow, 
        rst_startup_n, osc_en, sm_select_startup, test_enable, test_si3, 
        test_si2, test_si1, test_so3, test_so2, test_so1, test_se, test_sea );
  input [2:0] sm_select_startup;
  input clk_slow, rst_startup_n, osc_en, test_enable, test_si3, test_si2,
         test_si1, test_se, test_sea;
  output stable, test_so3, test_so2, test_so1;
  wire   startup_6_, startup_5_, startup_4_, startup_3_, startup_2_,
         startup_1_, startup_0_, net135, net136, net137, net138, net139,
         net140, net141, net142, net145, n12, n14, n1, n2, n3, n4, n5, n6, n7,
         n8, n9, n11, n13, n15, n16, n17, n18, n19, n20, n21, n22, n23, n24;

  dfzrbd3s8 startup_reg_2_ ( .D(net140), .TD(startup_1_), .SEL(test_sea), .CK(
        net145), .RB(rst_startup_n), .Q(startup_2_), .QB(n3) );
  dfzrbd3s8 startup_reg_4_ ( .D(net138), .TD(startup_3_), .SEL(test_sea), .CK(
        net145), .RB(rst_startup_n), .Q(startup_4_), .QB(n2) );
  dfzrbd3s8 startup_reg_6_ ( .D(net136), .TD(startup_5_), .SEL(test_sea), .CK(
        net145), .RB(rst_startup_n), .Q(startup_6_), .QB(n1) );
  dfzrbd3s8 osc_en_m_reg ( .D(osc_en), .TD(test_si2), .SEL(test_sea), .CK(
        clk_slow), .RB(rst_startup_n), .Q(test_so2) );
  dfzrbd3s8 startup_reg_5_ ( .D(net137), .TD(startup_4_), .SEL(test_sea), .CK(
        net145), .RB(rst_startup_n), .Q(startup_5_) );
  dfzrbd3s8 startup_reg_3_ ( .D(net139), .TD(startup_2_), .SEL(test_sea), .CK(
        net145), .RB(rst_startup_n), .Q(startup_3_) );
  dfzrbd3s8 startup_reg_7_ ( .D(net135), .TD(startup_6_), .SEL(test_sea), .CK(
        net145), .RB(rst_startup_n), .Q(test_so3) );
  dfzrbd3s8 startup_reg_1_ ( .D(net141), .TD(startup_0_), .SEL(test_sea), .CK(
        net145), .RB(rst_startup_n), .Q(startup_1_) );
  dfzrbd3s8 startup_reg_0_ ( .D(net142), .TD(test_si3), .SEL(test_sea), .CK(
        net145), .RB(rst_startup_n), .Q(startup_0_) );
  an3d3s8 U3 ( .I1(startup_2_), .I2(startup_1_), .I3(startup_0_), .O(n21) );
  aoi12d3s8 U4 ( .B1(test_so1), .B2(n15), .A1(test_enable), .O(n24) );
  nr2d3s8 U5 ( .I1(test_so3), .I2(n17), .O(n16) );
  nd2d4s8 U6 ( .I1(test_so1), .I2(n24), .O(n14) );
  oa112d5s8 U7 ( .C1(startup_3_), .C2(n21), .A1(n20), .B1(n22), .O(net139) );
  oa112d5s8 U8 ( .C1(startup_5_), .C2(n19), .A1(n18), .B1(n22), .O(net137) );
  nr2d3s8 U9 ( .I1(n1), .I2(n18), .O(n17) );
  nd2d4s8 U10 ( .I1(startup_5_), .I2(n19), .O(n18) );
  nr2d3s8 U11 ( .I1(n2), .I2(n20), .O(n19) );
  nd2d4s8 U12 ( .I1(startup_3_), .I2(n21), .O(n20) );
  nr2d3s8 U13 ( .I1(startup_0_), .I2(n24), .O(net142) );
  oa112d5s8 U14 ( .C1(startup_1_), .C2(startup_0_), .A1(n23), .B1(n22), .O(
        net141) );
  invd4s8 U15 ( .I(n24), .O(n22) );
  invd4s8 U16 ( .I(stable), .O(n15) );
  invd4s8 U17 ( .I(sm_select_startup[1]), .O(n7) );
  invd4s8 U18 ( .I(sm_select_startup[0]), .O(n6) );
  nd2d4s8 U19 ( .I1(startup_1_), .I2(startup_0_), .O(n23) );
  invd4s8 U20 ( .I(clk_slow), .O(n12) );
  aoi22d2s8 U21 ( .A1(sm_select_startup[0]), .A2(startup_3_), .B1(startup_2_), 
        .B2(n6), .O(n5) );
  aoi22d2s8 U22 ( .A1(sm_select_startup[0]), .A2(startup_1_), .B1(startup_0_), 
        .B2(n6), .O(n4) );
  aoi22d2s8 U23 ( .A1(sm_select_startup[1]), .A2(n5), .B1(n4), .B2(n7), .O(n13) );
  aoi22d2s8 U24 ( .A1(sm_select_startup[0]), .A2(test_so3), .B1(startup_6_), 
        .B2(n6), .O(n9) );
  aoi22d2s8 U25 ( .A1(sm_select_startup[0]), .A2(startup_5_), .B1(startup_4_), 
        .B2(n6), .O(n8) );
  aoi22d2s8 U26 ( .A1(sm_select_startup[1]), .A2(n9), .B1(n8), .B2(n7), .O(n11) );
  mux2d3s8 U27 ( .A(n13), .B(n11), .S(sm_select_startup[2]), .O(stable) );
  aoi112d2s8 U28 ( .C1(test_so3), .C2(n17), .A1(n24), .B1(n16), .O(net135) );
  aoi112d2s8 U29 ( .C1(n1), .C2(n18), .A1(n17), .B1(n24), .O(net136) );
  aoi112d2s8 U30 ( .C1(n2), .C2(n20), .A1(n19), .B1(n24), .O(net138) );
  aoi112d2s8 U31 ( .C1(n3), .C2(n23), .A1(n21), .B1(n24), .O(net140) );
  dfzrbd3s8 osc_en_r_reg ( .D(test_so2), .TD(test_si1), .SEL(test_sea), .CK(
        n12), .RB(rst_startup_n), .Q(test_so1) );
  SNPS_CLOCK_GATE_HIGH_cm_clock_startup_counter_v100_8_3_3_8_fac688 clk_gate_startup_reg ( 
        .CLK(clk_slow), .EN(n14), .ENCLK(net145), .TE(test_se) );
endmodule


module primitive_and2_gate_3 ( z, a, b );
  input a, b;
  output z;


  an2d5s8 U1 ( .I1(a), .I2(b), .O(z) );
endmodule


module primitive_and2_gate_2 ( z, a, b );
  input a, b;
  output z;


  an2d5s8 U1 ( .I1(a), .I2(b), .O(z) );
endmodule


module primitive_or3_gate ( z, a, b, c );
  input a, b, c;
  output z;


  or3d3s8 U1 ( .I1(a), .I2(b), .I3(c), .O(z) );
endmodule


module primitive_clock_mux_5 ( z, i0, i1, s );
  input i0, i1, s;
  output z;


  mux2d3s8 U1 ( .A(i0), .B(i1), .S(s), .O(z) );
endmodule


module primitive_and2_gate_1 ( z, a, b );
  input a, b;
  output z;


  an2d5s8 U1 ( .I1(a), .I2(b), .O(z) );
endmodule


module cm_clock_osc_ctrl_v100_1 ( en_osc_qual, en_osc_in, osc_clk, rst_n, 
        test_si, test_so, test_se );
  input en_osc_in, osc_clk, rst_n, test_si, test_se;
  output en_osc_qual, test_so;
  wire   en_osc_qual_fe_m, n3;

  qdffrbd3s8 en_osc_qual_fe_r_reg ( .D(en_osc_qual_fe_m), .CK(n3), .RB(rst_n), 
        .Q(test_so) );
  dfzrbd3s8 en_osc_qual_fe_m_reg ( .D(en_osc_in), .TD(test_si), .SEL(test_se), 
        .CK(n3), .RB(rst_n), .Q(en_osc_qual_fe_m) );
  invd4s8 U3 ( .I(osc_clk), .O(n3) );
  or2d5s8 U4 ( .I1(test_so), .I2(en_osc_in), .O(en_osc_qual) );
endmodule


module primitive_clock_mux_3 ( z, i0, i1, s );
  input i0, i1, s;
  output z;


  mux2d3s8 U1 ( .A(i0), .B(i1), .S(s), .O(z) );
endmodule


module primitive_clock_stop_exclude_1 ( z, i );
  input i;
  output z;
  wire   n1;

  invd4s8 U1 ( .I(n1), .O(z) );
  invd4s8 U2 ( .I(i), .O(n1) );
endmodule


module primitive_clock_gate_1 ( z, i, ce, se );
  input i, ce, se;
  output z;


  gcksd3s8 U_GATE ( .CKB(i), .D(ce), .SE(se), .Q(z) );
endmodule


module cm_clock_masker_v100_1 ( clk_out, enabled_r, rst_n, clk_source, 
        test_enable, enable, qualifier, clk_test, test_si2, test_si1, test_so1, 
        test_se );
  input rst_n, clk_source, test_enable, enable, qualifier, clk_test, test_si2,
         test_si1, test_se;
  output clk_out, enabled_r, test_so1;
  wire   clk_source_a, clk_source_a_tst, n3;

  dfzrbd3s8 enable_m_reg ( .D(enable), .TD(test_si2), .SEL(test_se), .CK(
        clk_source_a_tst), .RB(rst_n), .Q(test_so1) );
  dfzrbd3s8 enabled_r_reg ( .D(test_so1), .TD(test_si1), .SEL(test_se), .CK(n3), .RB(rst_n), .Q(enabled_r) );
  invd4s8 U5 ( .I(clk_source_a_tst), .O(n3) );
  primitive_clock_mux_3 U_PCM_SRC_A ( .z(clk_source_a_tst), .i0(clk_source_a), 
        .i1(clk_test), .s(test_enable) );
  primitive_clock_stop_exclude_1 U_PCSE_SOURCE ( .z(clk_source_a), .i(
        clk_source) );
  primitive_clock_gate_1 U_CG ( .z(clk_out), .i(clk_source), .ce(enabled_r), 
        .se(test_enable) );
endmodule


module primitive_clock_mux_4 ( z, i0, i1, s );
  input i0, i1, s;
  output z;


  mux2d3s8 U1 ( .A(i0), .B(i1), .S(s), .O(z) );
endmodule


module primitive_and2_gate_0 ( z, a, b );
  input a, b;
  output z;


  an2d3s8 U1 ( .I1(b), .I2(a), .O(z) );
endmodule


module primitive_or_gate ( z, a, b );
  input a, b;
  output z;


  or2d3s8 U1 ( .I1(b), .I2(a), .O(z) );
endmodule


module cm_clock_osc_ctrl_v100_0 ( en_osc_qual, en_osc_in, osc_clk, rst_n, 
        test_si, test_so, test_se );
  input en_osc_in, osc_clk, rst_n, test_si, test_se;
  output en_osc_qual, test_so;
  wire   en_osc_qual_fe_m, n1;

  qdffrbd3s8 en_osc_qual_fe_r_reg ( .D(en_osc_qual_fe_m), .CK(n1), .RB(rst_n), 
        .Q(test_so) );
  dfzrbd3s8 en_osc_qual_fe_m_reg ( .D(en_osc_in), .TD(test_si), .SEL(test_se), 
        .CK(n1), .RB(rst_n), .Q(en_osc_qual_fe_m) );
  or2d5s8 U3 ( .I1(test_so), .I2(en_osc_in), .O(en_osc_qual) );
  invd3s8 U4 ( .I(osc_clk), .O(n1) );
endmodule


module primitive_clock_mux_2 ( z, i0, i1, s );
  input i0, i1, s;
  output z;


  mux2d3s8 U1 ( .A(i0), .B(i1), .S(s), .O(z) );
endmodule


module primitive_clock_stop_exclude_0 ( z, i );
  input i;
  output z;
  wire   n1;

  invd4s8 U1 ( .I(i), .O(n1) );
  invd4s8 U2 ( .I(n1), .O(z) );
endmodule


module primitive_clock_gate_0 ( z, i, ce, se );
  input i, ce, se;
  output z;


  gcksd3s8 U_GATE ( .CKB(i), .D(ce), .SE(se), .Q(z) );
endmodule


module cm_clock_masker_v100_0 ( clk_out, enabled_r, rst_n, clk_source, 
        test_enable, enable, qualifier, clk_test, test_si2, test_si1, test_so1, 
        test_se );
  input rst_n, clk_source, test_enable, enable, qualifier, clk_test, test_si2,
         test_si1, test_se;
  output clk_out, enabled_r, test_so1;
  wire   clk_source_a, clk_source_a_tst, n4;

  dfzrbd3s8 enable_m_reg ( .D(enable), .TD(test_si2), .SEL(test_se), .CK(
        clk_source_a_tst), .RB(rst_n), .Q(test_so1) );
  dfzrbd3s8 enabled_r_reg ( .D(test_so1), .TD(test_si1), .SEL(test_se), .CK(n4), .RB(rst_n), .Q(enabled_r) );
  invd4s8 U5 ( .I(clk_source_a_tst), .O(n4) );
  primitive_clock_mux_2 U_PCM_SRC_A ( .z(clk_source_a_tst), .i0(clk_source_a), 
        .i1(clk_test), .s(test_enable) );
  primitive_clock_stop_exclude_0 U_PCSE_SOURCE ( .z(clk_source_a), .i(
        clk_source) );
  primitive_clock_gate_0 U_CG ( .z(clk_out), .i(clk_source), .ce(enabled_r), 
        .se(test_enable) );
endmodule


module osc32k_oscctrl ( oscen_osc32k_1k, oscen_osc32k_32k, clk_osc32k_1khz, 
        clk_osc32k_32khz, osc32k_startup_dly_done, enabled_osc32k_32khz, 
        enabled_osc32k_1khz, osc32ctrla_startup_r, clk_osc32k_32khz_raw, 
        clk_osc32k_1khz_raw, clk_apb_sysctrl, rst_apb_n, 
        rst_startup_osc32k_int_n_pre, oscctrl_enable_osc32k_32khz, 
        oscctrl_enable_osc32k, oscctrl_enable_osc32k_1khz, clk_test, 
        scan_test_mode, test_si2, test_si1, test_so1, test_se, test_sea );
  input [2:0] osc32ctrla_startup_r;
  input clk_osc32k_32khz_raw, clk_osc32k_1khz_raw, clk_apb_sysctrl, rst_apb_n,
         rst_startup_osc32k_int_n_pre, oscctrl_enable_osc32k_32khz,
         oscctrl_enable_osc32k, oscctrl_enable_osc32k_1khz, clk_test,
         scan_test_mode, test_si2, test_si1, test_se, test_sea;
  output oscen_osc32k_1k, oscen_osc32k_32k, clk_osc32k_1khz, clk_osc32k_32khz,
         osc32k_startup_dly_done, enabled_osc32k_32khz, enabled_osc32k_1khz,
         test_so1;
  wire   rst_startup_osc32k_int_n, clk_osc32k_32khz_test, osc32k_stable,
         osc32k_stable_en_qual, osc32k_startup_dly_done_m, osc32k_enable_q,
         osc32k_enable_uq, osc1k_enable_q, osc1k_enable_uq,
         osc32k_32khz_en_int, clk_osc32k_1khz_test, osc1k_en_ctrl, n3, n4, n5,
         n6, n7, n8, n9, n10;

  qdffrbd3s8 osc32k_startup_dly_done_r_reg ( .D(osc32k_startup_dly_done_m), 
        .CK(clk_apb_sysctrl), .RB(rst_apb_n), .Q(osc32k_startup_dly_done) );
  dfzrbd3s8 osc32k_startup_dly_done_m_reg ( .D(osc32k_stable_en_qual), .TD(n7), 
        .SEL(test_sea), .CK(clk_apb_sysctrl), .RB(rst_apb_n), .Q(
        osc32k_startup_dly_done_m) );
  oa12d3s8 U3 ( .B1(enabled_osc32k_32khz), .B2(enabled_osc32k_1khz), .A1(
        osc32k_stable), .O(osc32k_stable_en_qual) );
  cm_reset_maker_v100 U_OSC32K_RESETMAKER ( .rst_n(rst_startup_osc32k_int_n), 
        .clk(clk_osc32k_32khz_test), .rst_n_a(rst_startup_osc32k_int_n_pre), 
        .rst_test_n(rst_apb_n), .test_enable(scan_test_mode), .test_si2(n4), 
        .test_si1(enabled_osc32k_32khz), .test_so2(n3), .test_so1(n7), 
        .test_se(test_sea) );
  cm_clock_startup_counter_v100_8_3_3_8_fac688 U_STARTUP_OSC32K ( .stable(
        osc32k_stable), .clk_slow(clk_osc32k_32khz_test), .rst_startup_n(
        rst_startup_osc32k_int_n), .osc_en(oscctrl_enable_osc32k), 
        .sm_select_startup(osc32ctrla_startup_r), .test_enable(scan_test_mode), 
        .test_si3(n3), .test_si2(test_si2), .test_si1(test_si1), .test_so3(
        test_so1), .test_so2(n6), .test_so1(n10), .test_se(test_se), 
        .test_sea(test_sea) );
  primitive_and2_gate_3 U_OSC32KEN_Q ( .z(osc32k_enable_q), .a(
        osc32k_enable_uq), .b(osc32k_stable) );
  primitive_and2_gate_2 U_OSC1KEN_Q ( .z(osc1k_enable_q), .a(osc1k_enable_uq), 
        .b(osc32k_stable) );
  primitive_or3_gate U_OSC32INTEN ( .z(osc32k_32khz_en_int), .a(
        oscctrl_enable_osc32k), .b(enabled_osc32k_32khz), .c(oscen_osc32k_1k)
         );
  primitive_clock_mux_5 U_CLKMUX_OSC32K_32K ( .z(clk_osc32k_32khz_test), .i0(
        clk_osc32k_32khz_raw), .i1(clk_test), .s(scan_test_mode) );
  primitive_and2_gate_1 U_OSC32KEN_UQ ( .z(osc32k_enable_uq), .a(
        oscctrl_enable_osc32k_32khz), .b(oscctrl_enable_osc32k) );
  cm_clock_osc_ctrl_v100_1 U_CTRL_OSC32K_32K ( .en_osc_qual(oscen_osc32k_32k), 
        .en_osc_in(osc32k_32khz_en_int), .osc_clk(clk_osc32k_32khz_test), 
        .rst_n(rst_apb_n), .test_si(n10), .test_so(n9), .test_se(test_sea) );
  cm_clock_masker_v100_1 U_MASK_OSC32K_32k ( .clk_out(clk_osc32k_32khz), 
        .enabled_r(enabled_osc32k_32khz), .rst_n(rst_apb_n), .clk_source(
        clk_osc32k_32khz_test), .test_enable(scan_test_mode), .enable(
        osc32k_enable_q), .qualifier(1'b1), .clk_test(clk_test), .test_si2(n5), 
        .test_si1(enabled_osc32k_1khz), .test_so1(n4), .test_se(test_sea) );
  primitive_clock_mux_4 U_CLKMUX_OSC32K_1K ( .z(clk_osc32k_1khz_test), .i0(
        clk_osc32k_1khz_raw), .i1(clk_test), .s(scan_test_mode) );
  primitive_and2_gate_0 U_OSC1KEN_UQ ( .z(osc1k_enable_uq), .a(
        oscctrl_enable_osc32k_1khz), .b(oscctrl_enable_osc32k) );
  primitive_or_gate U_OSC1KCTRL_Q ( .z(osc1k_en_ctrl), .a(osc1k_enable_uq), 
        .b(enabled_osc32k_1khz) );
  cm_clock_osc_ctrl_v100_0 U_CTRL_OSC32K_1K ( .en_osc_qual(oscen_osc32k_1k), 
        .en_osc_in(osc1k_en_ctrl), .osc_clk(clk_osc32k_1khz_test), .rst_n(
        rst_apb_n), .test_si(n9), .test_so(n8), .test_se(test_sea) );
  cm_clock_masker_v100_0 U_MASK_OSC32K_1K ( .clk_out(clk_osc32k_1khz), 
        .enabled_r(enabled_osc32k_1khz), .rst_n(rst_apb_n), .clk_source(
        clk_osc32k_1khz_test), .test_enable(scan_test_mode), .enable(
        osc1k_enable_q), .qualifier(1'b1), .clk_test(clk_test), .test_si2(n6), 
        .test_si1(n8), .test_so1(n5), .test_se(test_sea) );
endmodule


module osc32k_glue ( sysctrl_pad_osc32k_clk32k_test_out, 
        sysctrl_pad_osc32k_clk1k_test_out, oscctrl_enable_osc32k, 
        oscctrl_enable_osc32k_32khz, oscctrl_enable_osc32k_1khz, 
        sysctrl_osc32krdy, osc32k_32khz_ready, osc32k_1khz_ready, 
        rst_startup_osc32k_int_n_pre, osc32k_en1k, osc32k_en32k, osc32k_en, 
        osc32k_coarse_calib, osc32ctrla_enable_r, osc32ctrla_en32k_r, 
        osc32ctrla_en1k_r, oscen_osc32k_1k, oscen_osc32k_32k, osc32k_test_mode, 
        scan_test_mode, rst_apb_n, enabled_osc32k_32khz, enabled_osc32k_1khz, 
        osc32ctrlb_calib_r, osc32k_startup_dly_done, clk_osc32k_1khz_raw, 
        clk_osc32k_32khz_raw, pm_keep_osc_osc32k_32khz, 
        pm_keep_osc_osc32k_1khz, pm_enable_osc32k, 
        pad_sysctrl_osc32k_en_test_in, pad_sysctrl_osc32k_en32k_test_in, 
        pad_sysctrl_osc32k_en1k_test_in );
  output [6:0] osc32k_coarse_calib;
  input [6:0] osc32ctrlb_calib_r;
  input osc32ctrla_enable_r, osc32ctrla_en32k_r, osc32ctrla_en1k_r,
         oscen_osc32k_1k, oscen_osc32k_32k, osc32k_test_mode, scan_test_mode,
         rst_apb_n, enabled_osc32k_32khz, enabled_osc32k_1khz,
         osc32k_startup_dly_done, clk_osc32k_1khz_raw, clk_osc32k_32khz_raw,
         pm_keep_osc_osc32k_32khz, pm_keep_osc_osc32k_1khz, pm_enable_osc32k,
         pad_sysctrl_osc32k_en_test_in, pad_sysctrl_osc32k_en32k_test_in,
         pad_sysctrl_osc32k_en1k_test_in;
  output sysctrl_pad_osc32k_clk32k_test_out, sysctrl_pad_osc32k_clk1k_test_out,
         oscctrl_enable_osc32k, oscctrl_enable_osc32k_32khz,
         oscctrl_enable_osc32k_1khz, sysctrl_osc32krdy, osc32k_32khz_ready,
         osc32k_1khz_ready, rst_startup_osc32k_int_n_pre, osc32k_en1k,
         osc32k_en32k, osc32k_en;
  wire   n2, n1, n4, n6, n8, n10, n12, n14, n16, n18, n20, n22, n23;

  an2b1d3s8 U5 ( .I1(clk_osc32k_1khz_raw), .B1(n2), .O(
        sysctrl_pad_osc32k_clk1k_test_out) );
  ao112d5s8 U2 ( .C1(osc32ctrla_enable_r), .C2(pm_enable_osc32k), .A1(
        pm_keep_osc_osc32k_1khz), .B1(pm_keep_osc_osc32k_32khz), .O(
        oscctrl_enable_osc32k) );
  or2d3s8 U3 ( .I1(pm_keep_osc_osc32k_1khz), .I2(osc32ctrla_en1k_r), .O(
        oscctrl_enable_osc32k_1khz) );
  invd3s8 U4 ( .I(enabled_osc32k_1khz), .O(n1) );
  invd4s8 U6 ( .I(osc32k_test_mode), .O(n2) );
  or2d5s8 U7 ( .I1(pm_keep_osc_osc32k_32khz), .I2(osc32ctrla_en32k_r), .O(
        oscctrl_enable_osc32k_32khz) );
  nr2d3s8 U8 ( .I1(pad_sysctrl_osc32k_en_test_in), .I2(n2), .O(n22) );
  nr2d3s8 U9 ( .I1(oscen_osc32k_32k), .I2(oscctrl_enable_osc32k), .O(n23) );
  invd4s8 U10 ( .I(n20), .O(osc32k_coarse_calib[6]) );
  invd4s8 U11 ( .I(osc32ctrlb_calib_r[6]), .O(n20) );
  invd4s8 U12 ( .I(n18), .O(osc32k_coarse_calib[5]) );
  invd4s8 U13 ( .I(osc32ctrlb_calib_r[5]), .O(n18) );
  invd4s8 U14 ( .I(n16), .O(osc32k_coarse_calib[4]) );
  invd4s8 U15 ( .I(osc32ctrlb_calib_r[4]), .O(n16) );
  invd4s8 U16 ( .I(n14), .O(osc32k_coarse_calib[3]) );
  invd4s8 U17 ( .I(osc32ctrlb_calib_r[3]), .O(n14) );
  invd4s8 U18 ( .I(n12), .O(osc32k_coarse_calib[2]) );
  invd4s8 U19 ( .I(osc32ctrlb_calib_r[2]), .O(n12) );
  invd4s8 U20 ( .I(n10), .O(osc32k_coarse_calib[1]) );
  invd4s8 U21 ( .I(osc32ctrlb_calib_r[1]), .O(n10) );
  invd4s8 U22 ( .I(n8), .O(osc32k_coarse_calib[0]) );
  invd4s8 U23 ( .I(osc32ctrlb_calib_r[0]), .O(n8) );
  invd4s8 U24 ( .I(n6), .O(sysctrl_osc32krdy) );
  invd4s8 U25 ( .I(osc32k_startup_dly_done), .O(n6) );
  invd4s8 U26 ( .I(n4), .O(osc32k_32khz_ready) );
  invd4s8 U27 ( .I(enabled_osc32k_32khz), .O(n4) );
  invd4s8 U28 ( .I(n1), .O(osc32k_1khz_ready) );
  aoi112d2s8 U29 ( .C1(n2), .C2(n23), .A1(scan_test_mode), .B1(n22), .O(
        osc32k_en) );
  mux2d3s8 U30 ( .A(oscen_osc32k_1k), .B(pad_sysctrl_osc32k_en1k_test_in), .S(
        osc32k_test_mode), .O(osc32k_en1k) );
  mux2d3s8 U31 ( .A(oscen_osc32k_32k), .B(pad_sysctrl_osc32k_en32k_test_in), 
        .S(osc32k_test_mode), .O(osc32k_en32k) );
  oa12d3s8 U32 ( .B1(scan_test_mode), .B2(oscctrl_enable_osc32k), .A1(
        rst_apb_n), .O(rst_startup_osc32k_int_n_pre) );
  an2b1d3s8 U33 ( .I1(clk_osc32k_32khz_raw), .B1(n2), .O(
        sysctrl_pad_osc32k_clk32k_test_out) );
endmodule


module osc32k ( sysctrl_pad_osc32k_clk32k_test_out, 
        sysctrl_pad_osc32k_clk1k_test_out, sysctrl_rdata, osc32k_coarse_calib, 
        osc32k_en, osc32k_en1k, osc32k_en32k, clk_osc32k_1khz, 
        clk_osc32k_32khz, sysctrl_osc32krdy, osc32k_32khz_ready, 
        osc32k_1khz_ready, clk_apb_sysctrl, rst_apb_n, scan_test_mode, 
        clk_osc32k_1khz_raw, clk_osc32k_32khz_raw, clk_test, osc32k_test_mode, 
        sysctrl_slotsel, sysctrl_pstrb, pm_keep_osc_osc32k_32khz, 
        pm_keep_osc_osc32k_1khz, pm_enable_osc32k, 
        pad_sysctrl_osc32k_en_test_in, pad_sysctrl_osc32k_en32k_test_in, 
        pad_sysctrl_osc32k_en1k_test_in, pad_sysctrl_osc32k_coarse_test_in, 
        sysctrl_write, sysctrl_wdata, SI, SCAN_ENABLE, test_se, SO );
  output [31:0] sysctrl_rdata;
  output [6:0] osc32k_coarse_calib;
  input [0:0] sysctrl_slotsel;
  input [3:0] sysctrl_pstrb;
  input [6:0] pad_sysctrl_osc32k_coarse_test_in;
  input [31:0] sysctrl_wdata;
  input clk_apb_sysctrl, rst_apb_n, scan_test_mode, clk_osc32k_1khz_raw,
         clk_osc32k_32khz_raw, clk_test, osc32k_test_mode,
         pm_keep_osc_osc32k_32khz, pm_keep_osc_osc32k_1khz, pm_enable_osc32k,
         pad_sysctrl_osc32k_en_test_in, pad_sysctrl_osc32k_en32k_test_in,
         pad_sysctrl_osc32k_en1k_test_in, sysctrl_write, SI, SCAN_ENABLE,
         test_se;
  output sysctrl_pad_osc32k_clk32k_test_out, sysctrl_pad_osc32k_clk1k_test_out,
         osc32k_en, osc32k_en1k, osc32k_en32k, clk_osc32k_1khz,
         clk_osc32k_32khz, sysctrl_osc32krdy, osc32k_32khz_ready,
         osc32k_1khz_ready, SO;
  wire   n72, n73, n74, n75, n76, n77, n78, n79, n80, n81, n82, n83, n84,
         osc32ctrla_en1k_r, osc32ctrla_en32k_r, osc32ctrla_enable_r,
         oscen_osc32k_1k, oscen_osc32k_32k, osc32k_startup_dly_done,
         enabled_osc32k_32khz, enabled_osc32k_1khz,
         rst_startup_osc32k_int_n_pre, oscctrl_enable_osc32k_32khz,
         oscctrl_enable_osc32k, oscctrl_enable_osc32k_1khz, n88;
  wire   [6:0] osc32ctrlb_calib_r;
  wire   [2:0] osc32ctrla_startup_r;

  invd4s8 U39 ( .I(n84), .O(sysctrl_rdata[1]) );
  invd4s8 U40 ( .I(n83), .O(sysctrl_rdata[2]) );
  invd4s8 U41 ( .I(n82), .O(sysctrl_rdata[3]) );
  invd4s8 U42 ( .I(n81), .O(sysctrl_rdata[8]) );
  invd4s8 U43 ( .I(n80), .O(sysctrl_rdata[9]) );
  invd4s8 U44 ( .I(n79), .O(sysctrl_rdata[10]) );
  invd4s8 U45 ( .I(n78), .O(sysctrl_rdata[16]) );
  invd4s8 U46 ( .I(n77), .O(sysctrl_rdata[17]) );
  invd4s8 U47 ( .I(n76), .O(sysctrl_rdata[18]) );
  invd4s8 U48 ( .I(n75), .O(sysctrl_rdata[19]) );
  invd4s8 U49 ( .I(n74), .O(sysctrl_rdata[20]) );
  invd4s8 U50 ( .I(n73), .O(sysctrl_rdata[21]) );
  invd4s8 U51 ( .I(n72), .O(sysctrl_rdata[22]) );
  osc32k_apb u_osc32k_apb ( .osc32ctrlb_calib_r(osc32ctrlb_calib_r), 
        .osc32ctrla_startup_r(osc32ctrla_startup_r), .osc32ctrla_en1k_r(
        osc32ctrla_en1k_r), .osc32ctrla_en32k_r(osc32ctrla_en32k_r), 
        .osc32ctrla_enable_r(osc32ctrla_enable_r), .clk_apb_sysctrl(
        clk_apb_sysctrl), .rst_apb_n(rst_apb_n), .sysctrl_write(sysctrl_write), 
        .sysctrl_slotsel(sysctrl_slotsel[0]), .sysctrl_pstrb({1'b0, 
        sysctrl_pstrb[2:0]}), .sysctrl_wdata_22_(sysctrl_wdata[22]), 
        .sysctrl_wdata_21_(sysctrl_wdata[21]), .sysctrl_wdata_20_(
        sysctrl_wdata[20]), .sysctrl_wdata_19_(sysctrl_wdata[19]), 
        .sysctrl_wdata_18_(sysctrl_wdata[18]), .sysctrl_wdata_17_(
        sysctrl_wdata[17]), .sysctrl_wdata_16_(sysctrl_wdata[16]), 
        .sysctrl_wdata_10_(sysctrl_wdata[10]), .sysctrl_wdata_9_(
        sysctrl_wdata[9]), .sysctrl_wdata_8_(sysctrl_wdata[8]), 
        .sysctrl_wdata_3_(sysctrl_wdata[3]), .sysctrl_wdata_2_(
        sysctrl_wdata[2]), .sysctrl_wdata_1_(sysctrl_wdata[1]), 
        .sysctrl_rdata_22__BAR(n72), .sysctrl_rdata_21__BAR(n73), 
        .sysctrl_rdata_20__BAR(n74), .sysctrl_rdata_19__BAR(n75), 
        .sysctrl_rdata_18__BAR(n76), .sysctrl_rdata_17__BAR(n77), 
        .sysctrl_rdata_16__BAR(n78), .sysctrl_rdata_10__BAR(n79), 
        .sysctrl_rdata_9__BAR(n80), .sysctrl_rdata_8__BAR(n81), 
        .sysctrl_rdata_3__BAR(n82), .sysctrl_rdata_2__BAR(n83), 
        .sysctrl_rdata_1__BAR(n84), .test_si(osc32k_startup_dly_done), 
        .test_so(n88), .test_se(test_se), .test_sea(SCAN_ENABLE) );
  osc32k_oscctrl u_osc32k_oscctrl ( .oscen_osc32k_1k(oscen_osc32k_1k), 
        .oscen_osc32k_32k(oscen_osc32k_32k), .clk_osc32k_1khz(clk_osc32k_1khz), 
        .clk_osc32k_32khz(clk_osc32k_32khz), .osc32k_startup_dly_done(
        osc32k_startup_dly_done), .enabled_osc32k_32khz(enabled_osc32k_32khz), 
        .enabled_osc32k_1khz(enabled_osc32k_1khz), .osc32ctrla_startup_r(
        osc32ctrla_startup_r), .clk_osc32k_32khz_raw(clk_osc32k_32khz_raw), 
        .clk_osc32k_1khz_raw(clk_osc32k_1khz_raw), .clk_apb_sysctrl(
        clk_apb_sysctrl), .rst_apb_n(rst_apb_n), 
        .rst_startup_osc32k_int_n_pre(rst_startup_osc32k_int_n_pre), 
        .oscctrl_enable_osc32k_32khz(oscctrl_enable_osc32k_32khz), 
        .oscctrl_enable_osc32k(oscctrl_enable_osc32k), 
        .oscctrl_enable_osc32k_1khz(oscctrl_enable_osc32k_1khz), .clk_test(
        clk_test), .scan_test_mode(scan_test_mode), .test_si2(n88), .test_si1(
        SI), .test_so1(SO), .test_se(test_se), .test_sea(SCAN_ENABLE) );
  osc32k_glue u_osc32k_glue ( .sysctrl_pad_osc32k_clk32k_test_out(
        sysctrl_pad_osc32k_clk32k_test_out), 
        .sysctrl_pad_osc32k_clk1k_test_out(sysctrl_pad_osc32k_clk1k_test_out), 
        .oscctrl_enable_osc32k(oscctrl_enable_osc32k), 
        .oscctrl_enable_osc32k_32khz(oscctrl_enable_osc32k_32khz), 
        .oscctrl_enable_osc32k_1khz(oscctrl_enable_osc32k_1khz), 
        .sysctrl_osc32krdy(sysctrl_osc32krdy), .osc32k_32khz_ready(
        osc32k_32khz_ready), .osc32k_1khz_ready(osc32k_1khz_ready), 
        .rst_startup_osc32k_int_n_pre(rst_startup_osc32k_int_n_pre), 
        .osc32k_en1k(osc32k_en1k), .osc32k_en32k(osc32k_en32k), .osc32k_en(
        osc32k_en), .osc32k_coarse_calib(osc32k_coarse_calib), 
        .osc32ctrla_enable_r(osc32ctrla_enable_r), .osc32ctrla_en32k_r(
        osc32ctrla_en32k_r), .osc32ctrla_en1k_r(osc32ctrla_en1k_r), 
        .oscen_osc32k_1k(oscen_osc32k_1k), .oscen_osc32k_32k(oscen_osc32k_32k), 
        .osc32k_test_mode(osc32k_test_mode), .scan_test_mode(scan_test_mode), 
        .rst_apb_n(rst_apb_n), .enabled_osc32k_32khz(enabled_osc32k_32khz), 
        .enabled_osc32k_1khz(enabled_osc32k_1khz), .osc32ctrlb_calib_r(
        osc32ctrlb_calib_r), .osc32k_startup_dly_done(osc32k_startup_dly_done), 
        .clk_osc32k_1khz_raw(clk_osc32k_1khz_raw), .clk_osc32k_32khz_raw(
        clk_osc32k_32khz_raw), .pm_keep_osc_osc32k_32khz(
        pm_keep_osc_osc32k_32khz), .pm_keep_osc_osc32k_1khz(
        pm_keep_osc_osc32k_1khz), .pm_enable_osc32k(pm_enable_osc32k), 
        .pad_sysctrl_osc32k_en_test_in(pad_sysctrl_osc32k_en_test_in), 
        .pad_sysctrl_osc32k_en32k_test_in(pad_sysctrl_osc32k_en32k_test_in), 
        .pad_sysctrl_osc32k_en1k_test_in(pad_sysctrl_osc32k_en1k_test_in) );
  invd3s8 U1 ( .I(1'b1), .O(sysctrl_rdata[0]) );
  invd3s8 U3 ( .I(1'b1), .O(sysctrl_rdata[4]) );
  invd3s8 U5 ( .I(1'b1), .O(sysctrl_rdata[5]) );
  invd3s8 U7 ( .I(1'b1), .O(sysctrl_rdata[6]) );
  invd3s8 U9 ( .I(1'b1), .O(sysctrl_rdata[7]) );
  invd3s8 U11 ( .I(1'b1), .O(sysctrl_rdata[11]) );
  invd3s8 U13 ( .I(1'b1), .O(sysctrl_rdata[12]) );
  invd3s8 U15 ( .I(1'b1), .O(sysctrl_rdata[13]) );
  invd3s8 U17 ( .I(1'b1), .O(sysctrl_rdata[14]) );
  invd3s8 U19 ( .I(1'b1), .O(sysctrl_rdata[15]) );
  invd3s8 U21 ( .I(1'b1), .O(sysctrl_rdata[23]) );
  invd3s8 U23 ( .I(1'b1), .O(sysctrl_rdata[24]) );
  invd3s8 U25 ( .I(1'b1), .O(sysctrl_rdata[25]) );
  invd3s8 U27 ( .I(1'b1), .O(sysctrl_rdata[26]) );
  invd3s8 U29 ( .I(1'b1), .O(sysctrl_rdata[27]) );
  invd3s8 U31 ( .I(1'b1), .O(sysctrl_rdata[28]) );
  invd3s8 U33 ( .I(1'b1), .O(sysctrl_rdata[29]) );
  invd3s8 U35 ( .I(1'b1), .O(sysctrl_rdata[30]) );
  invd3s8 U37 ( .I(1'b1), .O(sysctrl_rdata[31]) );
endmodule

